void allocate_curr_state () {
	struct global_list *temp_globals_list;
	struct var_list * temp_locals_list; 
	s_mem_loc_list curr_temp_memory = NULL;
	tree params;
	int count = 0;

	printf ("allocate curr state\n");
	r_curr_state = (s_state *) xmalloc (sizeof (s_state)); 
	r_curr_state->number = 0;
	r_curr_state->heap = NULL;
	r_curr_state->memory = NULL;
	r_curr_state->stmt = curr_proc->cfg_array[0]->insn;
	r_curr_state->proc = curr_proc;
	curr_cfg_node = curr_proc->cfg_array[0];
	r_curr_state->node = curr_cfg_node;
	r_curr_state->return_state = NULL;
	last_allocated_memory = NULL;
	last_allocated_heap = NULL;

	temp_globals_list = globals_list;
 	while (temp_globals_list != NULL) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
			allocate_memory_for_records (temp_globals_list->global, G);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = temp_globals_list->global;
			temp_memory->location->kind = G;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (temp_globals_list->global));	
			temp_memory->location->next_struct = NULL;
			if (temp_memory->location->val && temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}

		temp_globals_list = temp_globals_list->next;
	}	
			

	params = DECL_ARGUMENTS (curr_proc->proc);	
	while (params) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (params)) == RECORD_TYPE) {
			allocate_memory_for_records (params, L);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = params;
			temp_memory->location->kind = L;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (params));	
			temp_memory->location->next_struct = NULL;
			if (temp_memory->location->val && temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		params = TREE_CHAIN (params);
	}

	temp_locals_list = curr_proc->vars;
 	while (temp_locals_list != NULL) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (temp_locals_list->var)) == RECORD_TYPE) {
			allocate_memory_for_records (temp_locals_list->var, L);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = temp_locals_list->var;
			temp_memory->location->kind = L;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (temp_locals_list->var));	
			temp_memory->location->next_struct = NULL;
			if (temp_memory->location->val && temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		temp_locals_list = temp_locals_list->next;
	}	
}

void allocate_memory_for_records (tree var, int kind) {
	tree fields;
	tree type;
	s_mem_loc_list curr_temp_memory, prev_curr_temp_memory;
	s_mem_loc_list temp_memory;

	printf ("allocate memory for records\n");
	
	/* a memory location for the structure variable */
	/* location is null as it is dummy location just to keep track of the starting of structure variable*/
	temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
	temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
	temp_memory->location->var = var;
	temp_memory->location->kind = kind;
	temp_memory->location->points_to_index = -1; //initialize
	temp_memory->location->val = NULL;
	temp_memory->location->next_struct = NULL;
	temp_memory->next = NULL;
	if (last_allocated_memory == NULL) {
		r_curr_state->memory = temp_memory;
		last_allocated_memory = temp_memory;
	} else {
		last_allocated_memory->next = temp_memory;
		last_allocated_memory = temp_memory;
	}
	type = TREE_TYPE (var);
	fields = TYPE_FIELDS (type);
	while (fields) {
		if (TREE_CODE (TREE_TYPE (fields)) != RECORD_TYPE) {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = fields;
			temp_memory->location->kind = kind;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (fields));	
			temp_memory->location->next_struct = NULL;
			if (temp_memory->location->val && temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				r_curr_state->memory = temp_memory;
				last_allocated_memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		else {
			allocate_memory_for_records (fields, kind);
		}
		fields = TREE_CHAIN (fields);
	}
}

s_mem_loc_list allocate_heap_for_records (tree type) {
	tree fields;
	s_mem_loc_list temp_heap;
	s_mem_loc_list return_heap;

	printf ("allocate heap for records\n");
	temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
	temp_heap->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
	temp_heap->location->var = type; //FIXME, var should be set to some other value not type
	temp_heap->location->points_to_index = -1; //initialize
	temp_heap->location->val = NULL;	
	temp_heap->location->next_struct = NULL;
	if (temp_heap->location->val && temp_heap->location->val->kind == HEAP_KIND) {
		temp_heap->location->points_to_index = (temp_heap->location->val->value.heap_val)->location->index;
	}
	temp_heap->next = NULL;
	if (last_allocated_heap != NULL) {
		temp_heap->location->index = last_allocated_heap->location->index + 1;
		last_allocated_heap->next = temp_heap;
	} else {
		temp_heap->location->index = 0;
		r_curr_state->heap = temp_heap;
	}
	last_allocated_heap = temp_heap;
	return_heap = temp_heap;
	
	
	fields = TYPE_FIELDS (type);
	while (fields) {
		if (TREE_CODE (TREE_TYPE (fields)) != RECORD_TYPE) {
			temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			temp_heap->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_heap->location->var = fields;
			temp_heap->location->points_to_index = -1; //initialize
			temp_heap->location->val = create_value_structure (TREE_TYPE (fields));	
			temp_heap->location->next_struct = NULL;
			if (temp_heap->location->val && temp_heap->location->val->kind == HEAP_KIND) {
				temp_heap->location->points_to_index = (temp_heap->location->val->value.heap_val)->location->index;
			}
			temp_heap->next = NULL;
			if (last_allocated_heap != NULL) {
				temp_heap->location->index = last_allocated_heap->location->index + 1;
				last_allocated_heap->next = temp_heap;
			} else {
				temp_heap->location->index = 0;
				r_curr_state->heap = temp_heap;
			}
			last_allocated_heap = temp_heap;
		}
		else {
			temp_heap = allocate_heap_for_records (TREE_TYPE (fields));
			temp_heap->location->var = fields;
		}
		fields = TREE_CHAIN (fields);
	}
	return return_heap;
}
