#include "memory.h"
#include "location.h"
#include "state.h"
#include "globals.h"
#include "macros.h"
#include "execution.h"
#include "clone.c"
#include "allocate.c"
#include "lvalue.c"
#include "rvalue.c"
#include "value-structures.c"

void start_execution(void) 
{
	struct proc_cfg * main_proc; 
	int i;
	printf ("start_execution\n");
	/*
	hash_table1 = pblHtCreate ();
	if (hash_table1 == NULL)
	{
		sprintf (stderr, "error in allocating hash_table1\n");
		exit(0);
	}
	curr_state_inv = (struct state_inv *) xmalloc (sizeof (struct state_inv));
	*/
	/*identify the main procedure in the list of all procedures*/
	main_proc = procs;
	while (1)
	{
		if (main_proc == NULL ||strcmp (main_proc->proc_name, "main") == 0 )
			break;
		main_proc = main_proc->next;
	}
	if (main_proc == NULL)
	{
		fprintf (stderr, "function <main> is not defined\n");
		exit(0);
	}
	curr_proc = main_proc;
	allocate_curr_state ();	
	curr_cfg_node = curr_proc->cfg_array[1];
	execute();
}

void execute ()
{
	tree curr_insn;
	s_mem_loc_list  lhs_mem;
	while (curr_cfg_node != NULL) {
		curr_insn = curr_cfg_node->insn;
		if (curr_insn!= NULL && TREE_CODE (curr_insn) == FUNCTION_DECL) {
		
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == MODIFY_EXPR) {
			s_value * rhs_value;

			printf ("modify statements\n");
			if (TREE_CODE (TREE_OPERAND (curr_insn, 1)) == CALL_EXPR) {
				tree formal_params;
				tree actual_params;
				s_value * param_value;
				s_value * global_value;
				char * proc_name;
				struct global_list *temp_globals_list;

				printf ("call expression\n");
				r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
				clone_state (r_curr_state, r_next_state);
				r_next_state->stmt = curr_insn;
				r_next_state->node = curr_cfg_node;
				r_curr_state = r_next_state;

				proc_name = IDENTIFIER_POINTER (DECL_NAME (TREE_OPERAND (TREE_OPERAND (TREE_OPERAND (curr_insn,1), 0), 0))); /*FIXME:*/
				if (strcmp (proc_name, "malloc") != 0) {
					tree temp_insn;
					temp_insn = TREE_OPERAND (curr_insn, 1);			
					r_prev_state = r_curr_state;
					curr_proc = procs;
					while (1)
					{
						if (curr_proc == NULL ||strcmp (curr_proc->proc_name, proc_name) == 0 )
							break;
						curr_proc = curr_proc->next;
					}
					if (curr_proc == NULL)
					{
						fprintf (stderr, "function <%s> is not defined\n", proc_name);
						exit(0);
					}
					allocate_curr_state ();
					r_curr_state->return_state = r_prev_state;
					formal_params = DECL_ARGUMENTS (curr_proc->proc);
					actual_params = TREE_OPERAND (temp_insn, 1);
					while (formal_params && actual_params) {
						lhs_mem = find_lvalue (r_curr_state, formal_params);
						param_value = find_rvalue (r_prev_state, TREE_VALUE (actual_params));
						lhs_mem->location->val = param_value;
						if (param_value && param_value->kind == HEAP_KIND)
							lhs_mem->location->points_to_index = param_value->value.heap_val->location->index;
						formal_params = TREE_CHAIN (formal_params);
						actual_params = TREE_CHAIN (actual_params);
					}

					temp_globals_list = globals_list;
					while (temp_globals_list != NULL) {
						if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
							copy_record (r_prev_state, r_curr_state, temp_globals_list->global,0);
							
						} else {
							lhs_mem = find_lvalue (r_curr_state, temp_globals_list->global);		
							global_value = find_rvalue (r_prev_state, temp_globals_list->global);
							lhs_mem->location->val = global_value;
							if (global_value && global_value->kind == HEAP_KIND)
								lhs_mem->location->points_to_index = global_value->value.heap_val->location->index;
						}
						temp_globals_list = temp_globals_list->next;
					}
					clone_heap (r_prev_state, r_curr_state);
					next_cfg_node = curr_proc->cfg_array[1];
				} else {
					int malloc_size;
					tree type;
					tree temp_insn;
					temp_insn = TREE_OPERAND (curr_insn, 1);

					lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
					malloc_size = TREE_VALUE (TREE_OPERAND (temp_insn, 1))->int_cst.int_cst.low ;
					type = TREE_TYPE (curr_insn);
					rhs_value = create_value_structure_for_pointer (malloc_size, type);
					if (lhs_mem != NULL) {
						if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
							lhs_mem->location->val = rhs_value;
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
							lhs_mem->location->val = rhs_value;
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						} else {
							lhs_mem->location->val = rhs_value;
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						}
					}
					next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
				}
			} else {
				tree temp_insn;	

				temp_insn = TREE_OPERAND (curr_insn, 1);
				r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
				clone_state (r_curr_state, r_next_state);
				r_next_state->stmt = curr_insn;
				r_next_state->node = curr_cfg_node;
				r_curr_state = r_next_state;
				lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
				if (TREE_CODE (temp_insn) == CONVERT_EXPR) {
					rhs_value = find_rvalue (r_curr_state, TREE_OPERAND (temp_insn, 0));
				} else if (TREE_CODE (temp_insn) == NOP_EXPR) {
					rhs_value = find_rvalue (r_curr_state, TREE_OPERAND (temp_insn, 0));
				} else {
					rhs_value = find_rvalue (r_curr_state, temp_insn);
				}
				if (lhs_mem != NULL) {
					if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
						lhs_mem->location->val = rhs_value;
						if (rhs_value->kind == HEAP_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
					} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
						lhs_mem->location->val = rhs_value;
						if (rhs_value->kind == HEAP_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
					} else {
						lhs_mem->location->val = rhs_value;
						if (rhs_value->kind == HEAP_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						if (rhs_value->kind == MEM_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.mem_val->location->index;
					}
				}
				/*
				cdata = (struct state_inv *) pblHtLookup (hash_table1, (void *) new_key, sizeof (int));
				if (cdata == NULL)
				{
					pblHtInsert (hash_table1, (void *) new_key, sizeof (int), (void *) next_state_inv);
				}else 
				{
					printf (stderr, "state of same number exists\n");
					exit(0);
				}
				*/
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			}
			check_rule();
			if (found_second == 1) {
				printf ("property is satisfied\n");
				exit(0);
			}
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == COND_EXPR) {
			s_value * cond_value;

			printf ("conditional statement\n");
			cond_value = find_rvalue (r_curr_state, COND_EXPR_COND (curr_insn));		
			/* cond_value will always have bool_val or int_val */
			if (cond_value->value.int_val == 1 || cond_value->value.bool_val == 1)
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			else
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->next->node[1]];
			check_rule();
			if (found_second == 1) {
				printf ("property is satisfied\n");
				exit(0);
			}
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == CALL_EXPR) {
			tree formal_params;
			tree actual_params;
			s_value * param_value;
			s_value * global_value;
			char * proc_name;
			struct global_list *temp_globals_list;

			printf ("call statement\n");
			r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
			clone_state (r_curr_state, r_next_state);
			r_next_state->stmt = curr_insn;
			r_next_state->node = curr_cfg_node;
			r_curr_state = r_next_state;
			r_prev_state = r_curr_state;
			proc_name = IDENTIFIER_POINTER (DECL_NAME (TREE_OPERAND (TREE_OPERAND (curr_insn, 0), 0))); /*FIXME:*/
			curr_proc = procs;
			while (1)
			{
				if (curr_proc == NULL ||strcmp (curr_proc->proc_name, proc_name) == 0 )
					break;
				curr_proc = curr_proc->next;
			}
			if (curr_proc == NULL)
			{
				fprintf (stderr, "function <%s> is not defined\n", proc_name);
				exit(0);
			}
			allocate_curr_state ();
			r_curr_state->return_state = r_prev_state;
			formal_params = DECL_ARGUMENTS (curr_proc->proc);
			actual_params = TREE_OPERAND (curr_insn, 1);
			while (formal_params && actual_params) {
				lhs_mem = find_lvalue (r_curr_state, formal_params);
				param_value = find_rvalue (r_prev_state, TREE_VALUE (actual_params));
				lhs_mem->location->val = param_value;
				if (param_value && param_value->kind == HEAP_KIND)
					lhs_mem->location->points_to_index = param_value->value.heap_val->location->index;
				formal_params = TREE_CHAIN (formal_params);
				actual_params = TREE_CHAIN (actual_params);
			}
			
			temp_globals_list = globals_list;
			while (temp_globals_list != NULL) {
				if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
					copy_record (r_prev_state, r_curr_state, temp_globals_list->global, 0);
				} else {
					lhs_mem = find_lvalue (r_curr_state, temp_globals_list->global);		
					global_value = find_rvalue (r_prev_state, temp_globals_list->global);
					lhs_mem->location->val = global_value;
					if (global_value && global_value->kind == HEAP_KIND)
						lhs_mem->location->points_to_index = global_value->value.heap_val->location->index;
				}
				temp_globals_list = temp_globals_list->next;
			}
			clone_heap (r_prev_state, r_curr_state);
			next_cfg_node = curr_proc->cfg_array[1];
			check_rule();
			if (found_second == 1) {
				printf ("property is satisfied\n");
				exit(0);
			}
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == RETURN_EXPR) {
			s_value * return_value;
			s_mem_loc_list temp_memory;
			s_mem_loc_list temp_memorya;

			printf ("return statement\n");
			if (TREE_OPERAND (curr_insn, 0)) {
				curr_insn = TREE_OPERAND (curr_insn, 0);
			}	
			if (TREE_CODE (curr_insn) == MODIFY_EXPR) {
				return_value = find_rvalue (r_curr_state, TREE_OPERAND (curr_insn, 1));	
			} else {
				return_value = find_rvalue (r_curr_state, curr_insn);	
			}
			r_prev_state = r_curr_state;
			r_curr_state = r_prev_state->return_state;
			/*if return state is null means this is the first procedure in the call graph */
			if (r_curr_state != NULL) {
				curr_proc = r_curr_state->proc;
				curr_insn = r_curr_state->stmt;
				curr_cfg_node = r_curr_state->node;
				temp_memory = r_curr_state->memory;	
				while (temp_memory != NULL) {
					temp_memorya = r_prev_state->memory;
					while (temp_memorya != NULL) {
						if (temp_memory->location->var == temp_memorya->location->var) {
							temp_memory->location->index = temp_memorya->location->index;
							temp_memory->location->points_to_index = temp_memorya->location->points_to_index;
							if (temp_memorya->location->val) {
								temp_memory->location->val->value = temp_memorya->location->val->value;
								temp_memory->location->val->kind = temp_memorya->location->val->kind;
							} else {
								temp_memory->location->val = NULL;
							}
							break;
						} else {
							temp_memorya = temp_memorya->next;
						}	
					}
					temp_memory = temp_memory->next;
				}
				clone_heap (r_prev_state, r_curr_state);
				/* if the target of return is assignment then update the value of lhs by return value*/
				if (TREE_CODE (curr_insn) == MODIFY_EXPR) {
					lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
					if (lhs_mem != NULL) {
						if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
							lhs_mem->location->val = return_value;
							if (return_value->kind == HEAP_KIND)
								lhs_mem->location->points_to_index = return_value->value.heap_val->location->index;
						} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
							lhs_mem->location->val = return_value;
							if (return_value->kind == HEAP_KIND)
								lhs_mem->location->points_to_index = return_value->value.heap_val->location->index;
						} else {
							lhs_mem->location->val = return_value;
							if (return_value->kind == HEAP_KIND)
								lhs_mem->location->points_to_index = return_value->value.heap_val->location->index;
						}
					}
				}
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			} else {
				printf ("************** values *******************\n");
				while (r_prev_state && r_prev_state->memory != NULL) {
					printf ("memory value ");
					if (r_prev_state->memory->location->val)
						printf ("%d\n", r_prev_state->memory->location->val->value.int_val);
					else 
						printf ("null \n");
					r_prev_state->memory = r_prev_state->memory->next;
				}
				while (r_prev_state && r_prev_state->heap != NULL) {
					printf ("heap value ");
					if (r_prev_state->heap->location->val)
						printf ("%d \n", r_prev_state->heap->location->val->value.int_val);
					else
						printf ("null \n");
					r_prev_state->heap = r_prev_state->heap->next;
				}
				next_cfg_node = NULL;
			}
		} else {
			printf ("other type of statement\n");
			check_rule();
			next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			if (found_second == 1) {
				printf ("property is satisfied\n");
				exit(0);
			}
		}
		curr_cfg_node = next_cfg_node;
	}
	/* printing all the varibales in memory */
	while (r_curr_state && r_curr_state->memory != NULL) {
		r_curr_state->memory = r_curr_state->memory->next;
	}
	printf ("**************     *******************\n");
	printf ("execute finished\n");
}

int check_rule () {
	struct cfg_node * temp_cfg_node;
	int node_number;

	temp_cfg_node = r_curr_state->node ;
	node_number = temp_cfg_node->node_number;
	//printf ("node %d %s\n", node_number, r_curr_state->proc->proc_name);
	if (strcmp (r_curr_state->proc->proc_name, "alt_sep_test") == 0 && (node_number == FIRST_NODE_NUMBER)) {
		found_first = 1;
	}
	if ((found_first == 1) && strcmp (r_curr_state->proc->proc_name, "alt_sep_test") == 0 && (node_number == SECOND_NODE_NUMBER)) {
		found_second = 1;
	}
}

void copy_record (s_state * curr_state, s_state * next_state, tree var, int offset) {
	tree type;
	tree fields;
	s_mem_loc_list  lhs_mem;
	s_mem_loc_list  rhs_mem;
	s_value * r_value;
	int k;
	
	//printf ("copy_record\n");
	lhs_mem = find_lvalue (next_state, var);		
	rhs_mem = find_lvalue (curr_state, var);
	for (k = 0; k<offset; k++) {
		lhs_mem = lhs_mem->next;
		rhs_mem = rhs_mem->next;
	}
	r_value = (s_value *) xmalloc (sizeof (s_value));
	if (rhs_mem->location->val) {
		r_value->value = rhs_mem->location->val->value;
		r_value->kind = rhs_mem->location->val->kind;
	} else {
		r_value = NULL;
	}
	lhs_mem->location->val = r_value;	
	if (r_value && r_value->kind == HEAP_KIND)
		lhs_mem->location->points_to_index = r_value->value.heap_val->location->index;
	type = TREE_TYPE (var);		
	fields = TYPE_FIELDS (type);	
	while (fields) {
		offset = offset + 1;
		if (TREE_CODE (TREE_TYPE (fields)) != RECORD_TYPE) {
			lhs_mem = find_lvalue (next_state, var);		
			rhs_mem = find_lvalue (curr_state, var);
			for (k = 0; k<offset; k++) {
				lhs_mem = lhs_mem->next;
				rhs_mem = rhs_mem->next;
			}
			r_value = (s_value *) xmalloc (sizeof (s_value));
			if (rhs_mem->location->val) {
				r_value->value = rhs_mem->location->val->value;
				r_value->kind = rhs_mem->location->val->kind;
			} else {
				r_value = NULL;
			}
			lhs_mem->location->val = r_value;	
			if (r_value && r_value->kind == HEAP_KIND)
				lhs_mem->location->points_to_index = r_value->value.heap_val->location->index;
		} else {
			copy_record (curr_state, next_state, var, offset);
		}
		fields = TREE_CHAIN (fields);
	}
	return;
}
