/*This File defines data structures corresponding to memory location 
  Which involves variable and value stored in the memory location */

enum my_kind {INT_KIND, FLOAT_KIND, BOOL_KIND, MEM_KIND, HEAP_KIND};
struct my_value {
	union {
		int 	int_val; 
		float	float_val;
		bool	bool_val;
		s_mem_loc_list mem_val;
		s_heap_loc_list heap_val;
	} value;
	enum my_kind kind;
};

typedef struct my_value s_value;

struct my_memory {
	tree var;
	int points_to_index;
	s_value * val;
}; 

typedef struct my_memory s_mem_loc;

struct my_heap {
	int index;
	int points_to_index;
	s_value * val;

}; 

typedef struct my_heap s_heap_loc;

union common_loc {
	s_mem_loc * mem_loc;
	s_heap_loc * heap_loc;
};

typedef union common_loc s_common_loc;
