#include "memory.h"
#include "heap.h"
#include "location.h"
#include "state.h"
#include "globals.h"
#include "macros.h"
#include "execution.h"

int up_sep;	
int down_sep;
int positive_ra_alt_thresh;
int alt_layer_value;
int own_tracked_alt;
int other_tracked_alt;
int seed = 0;
int first_procedure_allocate_state=0;
void start_execution(void) 
{
	struct proc_cfg * main_proc; 
	int i;
	for (i=0; i<500; i++) {
		seed = seed+1;
		printf ("start_execution\n");
		/*
		hash_table1 = pblHtCreate ();
		if (hash_table1 == NULL)
		{
			sprintf (stderr, "error in allocating hash_table1\n");
			exit(0);
		}
		curr_state_inv = (struct state_inv *) xmalloc (sizeof (struct state_inv));
		*/
		/*identify the main procedure in the list of all procedures*/
		main_proc = procs;
		while (1)
		{
			if (main_proc == NULL ||strcmp (main_proc->proc_name, "main") == 0 )
				break;
			main_proc = main_proc->next;
		}
		if (main_proc == NULL)
		{
			fprintf (stderr, "function <main> is not defined\n");
			exit(0);
		}
		curr_proc = main_proc;
		first_procedure_allocate_state = 1;
		allocate_curr_state ();	
		first_procedure_allocate_state = 0;
		curr_cfg_node = curr_proc->cfg_array[1];
		execute();
	}
}

void allocate_curr_state () {
	struct global_list *temp_globals_list;
	struct var_list * temp_locals_list; 
	s_mem_loc_list temp_temp_memory = NULL;
	tree params;
	int count = 0;

	//printf ("allocate curr state\n");
	r_curr_state = (s_state *) xmalloc (sizeof (s_state)); 
	r_curr_state->number = 0;
	r_curr_state->heap = NULL;
	r_curr_state->memory = NULL;
	r_curr_state->stmt = curr_proc->cfg_array[0]->insn;
	r_curr_state->proc = curr_proc;
	curr_cfg_node = curr_proc->cfg_array[0];
	r_curr_state->node = curr_cfg_node;
	r_curr_state->return_state = NULL;
	last_allocated_heap = NULL;

	temp_globals_list = globals_list;
 	while (temp_globals_list != NULL) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
			allocate_memory_for_records (temp_globals_list->global);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_memory_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = temp_globals_list->global;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (temp_globals_list->global));	
			if (temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			if (first_procedure_allocate_state == 1) {
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Own_Tracked_Alt") == 0) {
					int x;
					srand(seed);
					x = 1+(int) (2.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Own_Tracked_Alt_Rate") == 0) {
					int x;
					srand(seed+1);
					x = 1+(int) (700.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Other_Tracked_Alt") == 0) {
					int x;
					srand(seed+2);
					x = 1+(int) (2.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Cur_Vertical_Sep") == 0) {
					int x;
					srand(seed+3);
					x = 1+(int) (700.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Up_Separation") == 0) {
					int x;
					srand(seed+4);
					x = 1+(int) (900.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Down_Separation") == 0) {
					int x;
					srand(seed+5);
					x = 1+(int) (900.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "High_Confidence") == 0) {
					int x;
					srand(seed+6);
					x = (int) (2.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Two_of_Three_Reports_Valid") == 0) {
					int x;
					srand(seed+7);
					x = (int) (2.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Alt_Layer_Value") == 0) {
					int x;
					srand(seed+8);
					x = (int) (4.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Other_RAC") == 0) {
					int x;
					srand(seed+9);
					x = (int) (3.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Other_Capability") == 0) {
					int x;
					srand(seed+10);
					x = 1+(int) (2.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Climb_Inhibit") == 0) {
					int x;
					srand(seed+11);
					x = (int) (2.0*rand()/(RAND_MAX+1.0));
					printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
			}
			temp_memory->next = NULL;
			if (count == 0) {
				temp_temp_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
				count = 1;
			} else {
				temp_temp_memory->next = temp_memory;
				temp_temp_memory = temp_memory;
			}
		}

		temp_globals_list = temp_globals_list->next;
	}	
			

	params = DECL_ARGUMENTS (curr_proc->proc);	
	while (params) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (params)) == RECORD_TYPE) {
			allocate_memory_for_records (params);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_memory_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = params;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (params));	
			if (temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			temp_memory->next = NULL;
			if (count == 0) {
				temp_temp_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
				count = 1;
			} else {
				temp_temp_memory->next = temp_memory;
				temp_temp_memory = temp_memory;
			}
		}
		params = TREE_CHAIN (params);
	}

	temp_locals_list = curr_proc->vars;
 	while (temp_locals_list != NULL) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (temp_locals_list->var)) == RECORD_TYPE) {
			allocate_memory_for_records (temp_locals_list->var);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_memory_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = temp_locals_list->var;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (temp_locals_list->var));	
			if (temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			temp_memory->next = NULL;
			if (count == 0) {
				temp_temp_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
				count = 1;
			} else {
				temp_temp_memory->next = temp_memory;
				temp_temp_memory = temp_memory;
			}
		}
		temp_locals_list = temp_locals_list->next;
	}	
}


void allocate_memory_for_records (tree var) {
	tree fields;
	tree type;
	s_mem_loc_list curr_temp_memory, prev_curr_temp_memory;
	s_mem_loc_list temp_memory;

	//printf ("allocate memory for records\n");
	curr_temp_memory = r_curr_state->memory;
	prev_curr_temp_memory = curr_temp_memory;
	while (curr_temp_memory != NULL) {
		prev_curr_temp_memory = curr_temp_memory;
		curr_temp_memory = curr_temp_memory->next;
	}
	
	/* a memory location for the structure variable */
	/* location is null as it is dummy location just to keep track of the starting of structure variable*/
	temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_memory_list));
	temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
	temp_memory->location->var = var;
	temp_memory->location->points_to_index = -1; //initialize
	temp_memory->location->val = NULL;
	temp_memory->next = NULL;
	if (prev_curr_temp_memory == NULL) {
		r_curr_state->memory = temp_memory;
		prev_curr_temp_memory = temp_memory;
	} else {
		prev_curr_temp_memory->next = temp_memory;
		prev_curr_temp_memory = temp_memory;
	}
	type = TREE_TYPE (var);
	fields = TYPE_FIELDS (type);
	while (fields) {
		if (TREE_CODE (TREE_TYPE (fields)) != RECORD_TYPE) {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_memory_list));
			temp_memory->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_memory->location->var = fields;
			temp_memory->location->points_to_index = -1; //initialize
			temp_memory->location->val = create_value_structure (TREE_TYPE (fields));	
			if (temp_memory->location->val->kind == HEAP_KIND) {
				temp_memory->location->points_to_index = (temp_memory->location->val->value.heap_val)->location->index;
			}
			temp_memory->next = NULL;
		}
		else {
			allocate_memory_for_records (fields);
		}
		if (prev_curr_temp_memory == NULL) {
			r_curr_state->memory = temp_memory;
			prev_curr_temp_memory = temp_memory;
		} else {
			prev_curr_temp_memory->next = temp_memory;
			prev_curr_temp_memory = temp_memory;
		}
		fields = TREE_CHAIN (fields);
	}
}

s_heap_loc_list create_value_structure_for_array (tree type) {
	tree tmp;
	int size;
	int prev_size;
	int k, j;
	int round = 1;
	s_heap_loc_list temp_heap;
	s_heap_loc_list prev_round_first_heap = NULL;
	s_heap_loc_list temp_prev_round_first_heap = NULL;
	s_heap_loc_list return_heap = NULL;
	struct array_size * array_size_list = NULL;
	struct array_size * temp_array_size;
	struct array_size * prev_array_size = NULL;

	//printf ("create value structure for array\n");
	/* first store all the dimensions of array in list */
	tmp = type;
	while (tmp && TREE_CODE (tmp) == ARRAY_TYPE) {
		temp_array_size = (struct array_size *) xmalloc (sizeof (struct array_size));
		if (TYPE_SIZE (tmp)) {
			size = TREE_INT_CST_LOW (TYPE_SIZE (tmp)) /
				  TREE_INT_CST_LOW (TYPE_SIZE (TREE_TYPE (tmp)));
			temp_array_size->size =  size;
		} else {
			fprintf (stdout, "Array does not have size");
			exit (0);
		}	
		temp_array_size->next = NULL;
		if (array_size_list == NULL) {
			array_size_list = temp_array_size; 
			prev_array_size = temp_array_size;
		} else {
			prev_array_size->next = temp_array_size;
			prev_array_size = temp_array_size;
		}
		tmp = TREE_TYPE (tmp);
	}
	/* the final value of tmp is used later in this function */
	/* first allocate the heap locations for all the dimensions */
	/* last dimension will be pointing to null it will be filled later in this function*/
	prev_size = 1;
	while (array_size_list != NULL) {
		if (round == 1) {
			round++;
			size = array_size_list->size;
			for (k=0; k<size; k++) {
				temp_heap = (s_heap_loc_list) xmalloc (sizeof (struct my_heap_list));
				temp_heap->location = (s_heap_loc *) xmalloc (sizeof (s_heap_loc));
				temp_heap->location->val = (s_value *) xmalloc (sizeof (s_value));
				temp_heap->next = NULL;
				if (last_allocated_heap != NULL) {
					temp_heap->location->index = last_allocated_heap->location->index + 1;
					temp_heap->location->points_to_index = -1; //initialize
					last_allocated_heap->next = temp_heap;
				}
				else {
					temp_heap->location->index = 0;
					temp_heap->location->points_to_index = -1; //initialize
					r_curr_state->heap = temp_heap;
				}
				last_allocated_heap = temp_heap;
				if (k ==0) {
					prev_round_first_heap = last_allocated_heap;
					return_heap = prev_round_first_heap;
				}
				
			}
		} else {
			temp_prev_round_first_heap = prev_round_first_heap;
			prev_size = prev_size * size;
			size = array_size_list->size;
			for (j=0; j<prev_size; j++) {
				for (k=0; k<size; k++) {
					temp_heap = (s_heap_loc_list) xmalloc (sizeof (struct my_heap_list));
					temp_heap->location = (s_heap_loc *) xmalloc (sizeof (s_heap_loc));
					temp_heap->location->val = (s_value *) xmalloc (sizeof (s_value));
					temp_heap->next = NULL;
					if (last_allocated_heap != NULL) {
						temp_heap->location->index = last_allocated_heap->location->index + 1;
						temp_heap->location->points_to_index = -1; //initialize
						last_allocated_heap->next = temp_heap;
					}
					else {
						temp_heap->location->index = 0;
						temp_heap->location->points_to_index = -1; //initialize
						r_curr_state->heap = temp_heap;
					}
					last_allocated_heap = temp_heap;
					if (k ==0 && j==0) {
						prev_round_first_heap = last_allocated_heap;
					}
					if (k==0) {
						temp_prev_round_first_heap->location->val->value.heap_val = temp_heap;
						temp_prev_round_first_heap->location->val->kind = HEAP_KIND;
						temp_prev_round_first_heap->location->points_to_index = temp_heap->location->index;
					}
				}
				temp_prev_round_first_heap = temp_prev_round_first_heap->next;
			}
		}
		array_size_list = array_size_list->next;
	}
	/*here it is assumed that array can be of primitive type only */
	/* it can not be of pointer type */	
	temp_prev_round_first_heap = prev_round_first_heap;
	if (TREE_CODE (tmp) != ARRAY_TYPE) {
		prev_size = prev_size * size;
		for (k=0; k<prev_size; k++) {
			temp_prev_round_first_heap->location->val = create_value_structure (tmp);
			temp_prev_round_first_heap->location->points_to_index = -1;
			temp_prev_round_first_heap = temp_prev_round_first_heap->next;
		}
	}
	return return_heap; 
}


s_value * create_value_structure (tree type) {
	s_value * return_val;
	int * int_return_val;
	float * float_return_val;
	bool * bool_return_val;
	s_heap_loc_list heap_return_val;

	return_val = (s_value *) xmalloc (sizeof (s_value));
	if (TREE_CODE (type) == INTEGER_TYPE) {
		return_val->kind = INT_KIND;
		return_val->value.int_val = 0;
	} else if (TREE_CODE (type) == REAL_TYPE) {
		return_val->kind = FLOAT_KIND;
		return_val->value.float_val = 0;
	} else if (TREE_CODE (type) == BOOLEAN_TYPE) {
		return_val->kind = BOOL_KIND;
		return_val->value.bool_val = 0;
	} else if (TREE_CODE (type) == POINTER_TYPE) {
		return_val = NULL;	
	} else if (TREE_CODE (type) == ARRAY_TYPE) {
		heap_return_val = create_value_structure_for_array (type);
		return_val->kind = HEAP_KIND;	
		return_val->value.heap_val = heap_return_val;	
	}
	return return_val;
}


void clone_memory (s_state * curr_state, s_state * next_state) {
	int count=0;
	s_mem_loc_list curr_memory;
	s_mem_loc_list next_memory;

	//printf ("clone_memory\n");
	next_memory = NULL;
	curr_memory = curr_state->memory;
	while (curr_memory != NULL) {
		s_mem_loc *temp_location;
		s_mem_loc *curr_location;
		s_mem_loc_list temp_memory;

		temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_memory_list));
		curr_location = curr_memory->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		temp_location->val = (s_value *) xmalloc (sizeof (s_value));
		temp_location->var = curr_location->var; 
		if (curr_location->val != NULL) {
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			}
			if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} 
		/*
		else {
			temp_location->val = NULL;
		}
		*/
		temp_memory->location = temp_location;
		temp_memory->next = NULL;
		if (count == 0) {
			next_memory = temp_memory;
			next_state->memory = temp_memory;
			count = 1;
		} else {
			next_memory->next = temp_memory;
			next_memory = temp_memory;
		}
		curr_memory = curr_memory->next;	
	}
}

void clone_heap (s_state * curr_state, s_state * next_state) {
	int count = 0;
	s_heap_loc_list curr_heap;
	s_heap_loc_list curr_heap1;
	s_mem_loc_list curr_memory1;
	s_heap_loc_list curr_heap2;
	s_heap_loc_list next_heap;
	s_heap_loc_list temp_heap;
	
	//printf ("cloning heap\n");
	next_heap = NULL;
	curr_heap = curr_state->heap;
	while (curr_heap != NULL) {
		s_heap_loc *temp_location;
		s_heap_loc *curr_location;

		temp_heap = (s_heap_loc_list) xmalloc (sizeof (struct my_heap_list));
		curr_location = curr_heap->location;
		temp_location = (s_heap_loc *) xmalloc (sizeof (s_heap_loc));
		temp_location->val = (s_value *) xmalloc (sizeof (s_value));
		temp_location->index = curr_location->index; 
		if (curr_location->val != NULL) {
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			}
			if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} else {
			temp_location->val = NULL;
		}
		temp_heap->location = temp_location;
		temp_heap->next = NULL;
		if (count == 0) {
			next_heap = temp_heap;
			next_state->heap = temp_heap;
			count = 1;
		} else {
			next_heap->next = temp_heap;
			next_heap = temp_heap;
		}
		curr_heap = curr_heap->next;	
	}
	/* we need to renew the last_allocated_heap everytime we clone the heap */
	temp_heap = next_state->heap; 		
	last_allocated_heap = temp_heap;
	while (temp_heap != NULL) {
		last_allocated_heap = temp_heap;
		temp_heap = temp_heap->next;
	}
	/* copying the links of heap locations */
	/* if a heap location is pointing to another heap location, then find that link and put into first's value */
	curr_heap1 = next_state->heap;
	while (curr_heap1 != NULL) {
		int i;

		if (curr_heap1->location->points_to_index >0){
			curr_heap2 = next_state->heap;
			i = 0;
			while (curr_heap2 != NULL && i!= curr_heap1->location->points_to_index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == curr_heap1->location->points_to_index) {
				curr_heap1->location->val->value.heap_val = curr_heap2;
			}
		} 
		curr_heap1 = curr_heap1->next;
	}
	/* copying the links of heap locations */
	/* if a memory location is pointing to another heap location, then find that link and put into first's value */
	curr_memory1 = next_state->memory;
	while (curr_memory1 != NULL) {
		int i;

		if (curr_memory1->location->points_to_index >=0){
			curr_heap2 = next_state->heap;
			i = 0;
			while (curr_heap2 != NULL && i!= curr_memory1->location->points_to_index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == curr_memory1->location->points_to_index) {
				curr_memory1->location->val->value.heap_val = curr_heap2;
			}
		} 
		curr_memory1 = curr_memory1->next;
	}
}

void clone_state (s_state *curr_state, s_state *next_state) {
	next_state->number = curr_state->number + 1;
	next_state->stmt = NULL;	
	next_state->memory = NULL;
	next_state->heap = NULL;
	next_state->proc = curr_state->proc;
	next_state->node = curr_state->node;
	clone_memory (curr_state, next_state);
	//next_state->memory = curr_state->memory;
	clone_heap (curr_state, next_state);
	//next_state->heap = curr_state->heap;
	next_state->return_state = curr_state->return_state;
}

s_common_loc * find_lvalue (s_state * curr_state, tree l_var) {
	s_common_loc * return_loc;
	s_mem_loc_list curr_memory;
	int found;
	s_mem_loc * curr_mem_location;
	s_heap_loc * curr_heap_location;
	
	//printf ("find lvalue\n"); 
	return_loc = (s_common_loc *) xmalloc (sizeof (s_common_loc));
	switch (TREE_CODE (l_var)) {
		case VAR_DECL:
		case PARM_DECL:
		case RESULT_DECL:
		{
			curr_memory = curr_state->memory;
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == l_var) {
					found = 1;
					return_loc->mem_loc = curr_mem_location;
					
				} else {
					curr_memory = curr_memory->next;
				}
			}
			if (!found) {
				return_loc = NULL;
			}
		}
			break;
		case COMPONENT_REF:
		{
			int round;
			tree struct_var, field;
			s_heap_loc * current_location;
			s_heap_loc_list current_heap;
			tree p;
			/* currently I am assuming compref can be of type struct.field */
			for (p = l_var; TREE_CODE (p) == COMPONENT_REF; p = TREE_OPERAND (p, 0)) {
				struct_var = TREE_OPERAND (p, 0);
				field = TREE_OPERAND (p, 1); 
			}
			/* search the array varibale in the memory list */
			curr_memory = curr_state->memory;
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == struct_var) {
					found = 1;
				} else {
					curr_memory = curr_memory->next;
				}
			}
			/* find the field of the structure now */
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == field) {
					found = 1;
					return_loc->mem_loc = curr_mem_location;
					
				} else {
					curr_memory = curr_memory->next;
				}
			}
			if (!found) {
				return_loc = NULL;
			}
				
		}
			break;
		case ARRAY_REF:
		{
			int round;
			struct array_ref * array_ref_list = NULL;
			struct array_ref * temp_array_ref;
			struct array_ref * prev_array_ref = NULL;
			s_heap_loc * current_location;
			s_heap_loc_list current_heap;
			tree p;

			for (p = l_var; TREE_CODE (p) == ARRAY_REF; p = TREE_OPERAND (p, 0)) {
				temp_array_ref = (struct array_ref *) xmalloc (sizeof (struct array_ref));
				temp_array_ref->op1 = TREE_OPERAND (p, 1); 
				temp_array_ref->kind = 0;
				temp_array_ref->next = array_ref_list;
				array_ref_list = temp_array_ref;
			}
			/* search the array varibale in the memory list */
			curr_memory = curr_state->memory;
			found = 0;
			while (!found && curr_memory != NULL) {
				curr_mem_location = curr_memory->location;	
				if (curr_mem_location->var == p) {
					found = 1;
					return_loc->mem_loc = curr_mem_location;
					
				} else {
					curr_memory = curr_memory->next;
				}
			}
			/* variable is just array, no array reference*/
			if (array_ref_list == NULL) {
				fprintf (stdout, "Just passed array name in ARRAR_REF ");
				exit (0);
			}
			round = 0;
			while (array_ref_list != NULL){
				s_value * array_index_value;
				int curr_index;
				int i;

				array_index_value = find_rvalue (r_curr_state, array_ref_list->op1);
				if (array_index_value != NULL) {
					curr_index = array_index_value->value.int_val;
				}
				if (round == 0) {
					current_heap = return_loc->mem_loc->val->value.heap_val;
					round++;
				} else { 
					current_heap = current_location->val->value.heap_val;
				}
				for (i = 1; i<=curr_index; i++) {
					current_heap = current_heap->next;
				}
				current_location = current_heap->location;
				array_ref_list = array_ref_list->next;				
			}
			return_loc->heap_loc = current_location;	
		}
			break;
		case INDIRECT_REF:
		{
			
		}
			break;
		default:
			return_loc = NULL;
			break;
	}
	return return_loc;
} 


s_value * find_rvalue (s_state * curr_state, tree r_var) {
	s_value * return_val;

	//printf ("find rvalue\n"); 
	if (r_var == NULL) {
		return_val = NULL;
		return return_val;
	}
	return_val = (s_value *) xmalloc (sizeof (s_value));
	switch (TREE_CODE (r_var)) {
		case INTEGER_CST:
		{
			return_val->value.int_val = (r_var->int_cst).int_cst.low;
			//printf ("int value %d\n", return_val->value.int_val);
			return_val->kind = INT_KIND;
		}
			break;
		case REAL_CST:
		{
			return_val->value.float_val = (r_var->int_cst).int_cst.low;
			return_val->kind = FLOAT_KIND;
		}
			break;
		case VAR_DECL:
		case PARM_DECL:
		case RESULT_DECL:
		{
			s_common_loc * rhs_location; 
			rhs_location = find_lvalue (curr_state, r_var);	
			if (rhs_location != NULL) {
				if (rhs_location->mem_loc->val != NULL) {
					return_val->value = rhs_location->mem_loc->val->value;
					//printf ("var value %d\n", return_val->value.int_val);
					return_val->kind = rhs_location->mem_loc->val->kind;
				} else {
					return_val = NULL;
				}
			}else {
				return_val = NULL;
			}
		}
			break;
		case COMPONENT_REF: 
		{
			s_common_loc * rhs_location; 
			rhs_location = find_lvalue (curr_state, r_var);	
			if (rhs_location != NULL) {
				if (rhs_location->mem_loc->val != NULL) {
					return_val->value = rhs_location->mem_loc->val->value;
					return_val->kind = rhs_location->mem_loc->val->kind;
				} else {
					return_val = NULL;
				}
			}else {
				return_val = NULL;
			}
		}
			break;
		case ARRAY_REF:
		{
			s_common_loc * rhs_location; 
			rhs_location = find_lvalue (curr_state, r_var);	
			if (rhs_location != NULL) {
				if (rhs_location->mem_loc->val != NULL) {
					return_val->value = rhs_location->heap_loc->val->value;
					return_val->kind = rhs_location->heap_loc->val->kind;
				} else {
					return_val = NULL;
				}
			}else {
				return_val = NULL;
			}
		}
			break;
		case MULT_EXPR:
		{
			#define OPERATOR *
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case PLUS_EXPR:
		{
			#define OPERATOR +
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case MINUS_EXPR:
		{
			#define OPERATOR -
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUNC_DIV_EXPR:
		case CEIL_DIV_EXPR:
		case FLOOR_DIV_EXPR:
		case ROUND_DIV_EXPR:
		case TRUNC_MOD_EXPR:
		case CEIL_MOD_EXPR:
		case FLOOR_MOD_EXPR:
		case ROUND_MOD_EXPR:
		case RDIV_EXPR:
		case EXACT_DIV_EXPR:
		case LSHIFT_EXPR:
		case RSHIFT_EXPR:
		case LROTATE_EXPR:
		case RROTATE_EXPR:
		case BIT_IOR_EXPR:
		case BIT_XOR_EXPR:
		case BIT_AND_EXPR:
		case TRUTH_ANDIF_EXPR:
		{
			#define OPERATOR &&
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_ORIF_EXPR:
		{
			#define OPERATOR ||
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_AND_EXPR:
		{
			#define OPERATOR &&
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_OR_EXPR:
		{
			#define OPERATOR ||
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_XOR_EXPR:
		{
			#define OPERATOR ||
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case LT_EXPR:
		{
			#define OPERATOR <
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case LE_EXPR:
		{
			#define OPERATOR <=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case GT_EXPR:
		{
			#define OPERATOR >
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case GE_EXPR:
		{
			#define OPERATOR >=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case EQ_EXPR:
		{
			#define OPERATOR ==
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case NE_EXPR:
		{
			#define OPERATOR !=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNLT_EXPR:
		{
			#define OPERATOR <
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNLE_EXPR:
		{
			#define OPERATOR <=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNGT_EXPR:
		{
			#define OPERATOR >
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNGE_EXPR:
		{
			#define OPERATOR >=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
	    	case UNEQ_EXPR:
		{
			#define OPERATOR ==
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		default:
			return_val = NULL;
			break;
	}
	return return_val;

}

void execute ()
{
	tree curr_insn;
	while (curr_cfg_node != NULL) {
		curr_insn = curr_cfg_node->insn;
		if (curr_insn!= NULL && TREE_CODE (curr_insn) == FUNCTION_DECL) {
		
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == MODIFY_EXPR) {
			s_common_loc * lhs_location;
			s_value * rhs_value;

			//printf ("modify statements\n");
			if (TREE_CODE (TREE_OPERAND (curr_insn, 1)) == CALL_EXPR) {
				tree formal_params;
				tree actual_params;
				s_value * param_value;
				s_value * global_value;
				s_common_loc * lhs_location;
				char * proc_name;
				struct global_list *temp_globals_list;

				//printf ("call expression\n");
				r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
				clone_state (r_curr_state, r_next_state);
				r_next_state->stmt = curr_insn;
				r_next_state->node = curr_cfg_node;
				r_curr_state = r_next_state;
				r_prev_state = r_curr_state;

				curr_insn = TREE_OPERAND (curr_insn, 1);			
				proc_name = IDENTIFIER_POINTER (DECL_NAME (TREE_OPERAND (TREE_OPERAND (curr_insn, 0), 0))); /*FIXME:*/
				curr_proc = procs;
				while (1)
				{
					if (curr_proc == NULL ||strcmp (curr_proc->proc_name, proc_name) == 0 )
						break;
					curr_proc = curr_proc->next;
				}
				if (curr_proc == NULL)
				{
					fprintf (stderr, "function <%s> is not defined\n", proc_name);
					exit(0);
				}
				allocate_curr_state ();
				r_curr_state->return_state = r_prev_state;
				formal_params = DECL_ARGUMENTS (curr_proc->proc);
				actual_params = TREE_OPERAND (curr_insn, 1);
				while (formal_params && actual_params) {
					lhs_location = find_lvalue (r_curr_state, formal_params);
					param_value = find_rvalue (r_prev_state, TREE_VALUE (actual_params));
					lhs_location->mem_loc->val = param_value;
					formal_params = TREE_CHAIN (formal_params);
					actual_params = TREE_CHAIN (actual_params);
				}

				temp_globals_list = globals_list;
				while (temp_globals_list != NULL) {
					lhs_location = find_lvalue (r_curr_state, temp_globals_list->global);		
					global_value = find_rvalue (r_prev_state, temp_globals_list->global);
					lhs_location->mem_loc->val = global_value;
					temp_globals_list = temp_globals_list->next;
				}
				next_cfg_node = curr_proc->cfg_array[1];
			} else {
				r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
				clone_state (r_curr_state, r_next_state);
				r_next_state->stmt = curr_insn;
				r_next_state->node = curr_cfg_node;
				r_curr_state = r_next_state;
				lhs_location = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
				rhs_value = find_rvalue (r_curr_state, TREE_OPERAND (curr_insn, 1));
				if (lhs_location != NULL) {
					if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
						lhs_location->heap_loc->val = rhs_value;
					} else {
						lhs_location->mem_loc->val = rhs_value;
					}
				}

				/*
				cdata = (struct state_inv *) pblHtLookup (hash_table1, (void *) new_key, sizeof (int));
				if (cdata == NULL)
				{
					pblHtInsert (hash_table1, (void *) new_key, sizeof (int), (void *) next_state_inv);
				}else 
				{
					printf (stderr, "state of same number exists\n");
					exit(0);
				}
				*/
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			}
			check_rule();
			if (found_second == 1) {
				printf ("preoperty is satisfied\n");
				exit(0);
			}
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == COND_EXPR) {
			s_value * cond_value;

			//printf ("conditional statement\n");
			cond_value = find_rvalue (r_curr_state, COND_EXPR_COND (curr_insn));		
			if (cond_value->value.int_val == 1 || cond_value->value.bool_val == 1)
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			else
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->next->node[1]];
			check_rule();
			if (found_second == 1) {
				printf ("preoperty is satisfied\n");
				exit(0);
			}
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == CALL_EXPR) {
			tree formal_params;
			tree actual_params;
			s_value * param_value;
			s_value * global_value;
			s_common_loc * lhs_location;
			char * proc_name;
			struct global_list *temp_globals_list;

			//printf ("call statement\n");
			r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
			clone_state (r_curr_state, r_next_state);
			r_next_state->stmt = curr_insn;
			r_next_state->node = curr_cfg_node;
			r_curr_state = r_next_state;
			r_prev_state = r_curr_state;
			proc_name = IDENTIFIER_POINTER (DECL_NAME (TREE_OPERAND (TREE_OPERAND (curr_insn, 0), 0))); /*FIXME:*/
			curr_proc = procs;
			while (1)
			{
				if (curr_proc == NULL ||strcmp (curr_proc->proc_name, proc_name) == 0 )
					break;
				curr_proc = curr_proc->next;
			}
			if (curr_proc == NULL)
			{
				fprintf (stderr, "function <%s> is not defined\n", proc_name);
				exit(0);
			}
			allocate_curr_state ();
			r_curr_state->return_state = r_prev_state;
			formal_params = DECL_ARGUMENTS (curr_proc->proc);
			actual_params = TREE_OPERAND (curr_insn, 1);
			while (formal_params && actual_params) {
				lhs_location = find_lvalue (r_curr_state, formal_params);
				param_value = find_rvalue (r_prev_state, TREE_VALUE (actual_params));
				lhs_location->mem_loc->val = param_value;
				formal_params = TREE_CHAIN (formal_params);
				actual_params = TREE_CHAIN (actual_params);
			}
			
			temp_globals_list = globals_list;
			while (temp_globals_list != NULL) {
				lhs_location = find_lvalue (r_curr_state, temp_globals_list->global);		
				global_value = find_rvalue (r_prev_state, temp_globals_list->global);
				lhs_location->mem_loc->val = global_value;
				temp_globals_list = temp_globals_list->next;
			}
			next_cfg_node = curr_proc->cfg_array[1];
			check_rule();
			if (found_second == 1) {
				printf ("preoperty is satisfied\n");
				exit(0);
			}
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == RETURN_EXPR) {
			s_value * return_value;
			s_mem_loc_list temp_memory;
			s_mem_loc_list temp_memorya;
			int procedure_name_is_initialize = 0;

			if (strcmp (r_curr_state->proc->proc_name, "initialize") == 0) {
				procedure_name_is_initialize = 1;
			}
			if (TREE_OPERAND (curr_insn, 0)) {
				curr_insn = TREE_OPERAND (curr_insn, 0);
			}	
			if (TREE_CODE (curr_insn) == MODIFY_EXPR) {
				return_value = find_rvalue (r_curr_state, TREE_OPERAND (curr_insn, 1));	
			} else {
				return_value = find_rvalue (r_curr_state, curr_insn);	
			}
			r_prev_state = r_curr_state;
			r_curr_state = r_prev_state->return_state;
			/*if return state is null means this is the first procedure in the call graph */
			if (r_curr_state != NULL) {
				curr_proc = r_curr_state->proc;
				curr_insn = r_curr_state->stmt;
				curr_cfg_node = r_curr_state->node;
				temp_memory = r_curr_state->memory;	
				while (temp_memory != NULL) {
					temp_memorya = r_prev_state->memory;
					while (temp_memorya != NULL) {
						if (temp_memory->location->var == temp_memorya->location->var) {
							temp_memory->location->val->value = temp_memorya->location->val->value;
							temp_memory->location->val->kind = temp_memorya->location->val->kind;
							break;
						} else {
							temp_memorya = temp_memorya->next;
						}	
					}
					temp_memory = temp_memory->next;
				}
				{
					if (procedure_name_is_initialize == 1) {
						temp_memory = r_curr_state->memory;	
						while (temp_memory != NULL) {
							if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Up_Separation") == 0) {
								up_sep = temp_memory->location->val->value.int_val;
							}
							if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Down_Separation") == 0) {
								down_sep = temp_memory->location->val->value.int_val;
							}
							if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Own_Tracked_Alt") == 0) {
								own_tracked_alt = temp_memory->location->val->value.int_val;
							}
							if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Other_Tracked_Alt") == 0) {
								other_tracked_alt = temp_memory->location->val->value.int_val;
							}
							if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Alt_Layer_Value") == 0) {
								alt_layer_value = temp_memory->location->val->value.int_val;
							}
							if (alt_layer_value == 0 && strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Positive_RA_Alt_Thresh0") == 0) {
								positive_ra_alt_thresh = temp_memory->location->val->value.int_val;
							}
							if (alt_layer_value == 1 && strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Positive_RA_Alt_Thresh1") == 0) {
								positive_ra_alt_thresh = temp_memory->location->val->value.int_val;
							}
							if (alt_layer_value == 2 && strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Positive_RA_Alt_Thresh2") == 0) {
								positive_ra_alt_thresh = temp_memory->location->val->value.int_val;
							}
							if (alt_layer_value == 3 && strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_memory->location->var)), "Positive_RA_Alt_Thresh3") == 0) {
								positive_ra_alt_thresh = temp_memory->location->val->value.int_val;
							}
							temp_memory = temp_memory->next;
						}
						if (check_P1 () == 0)
							return;
					}
				}
				/* if the target of return is assignment then update the value of lhs by return value*/
				if (TREE_CODE (curr_insn) == MODIFY_EXPR) {
					s_common_loc * lhs_location;
					lhs_location = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
					if (lhs_location != NULL)
						lhs_location->mem_loc->val = return_value;
				}
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			} else {
				while (r_prev_state && r_prev_state->memory != NULL) {
					if (r_prev_state->memory->location->val)
						printf ("memory value %d\n", r_prev_state->memory->location->val->value.int_val);
					r_prev_state->memory = r_prev_state->memory->next;
				}
				while (r_prev_state && r_prev_state->heap != NULL) {
					if (r_prev_state->heap->location->val)
						//printf ("heap value %d \n", r_prev_state->heap->location->val->value.int_val);
					r_prev_state->heap = r_prev_state->heap->next;
				}
				next_cfg_node = NULL;
			}
		} else {
			//printf ("other type of statement\n");
			check_rule();
			next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			if (found_second == 1) {
				printf ("preoperty is satisfied\n");
				exit(0);
			}
		}
		curr_cfg_node = next_cfg_node;
	}
	/* printing all the varibales in memory */
	while (r_curr_state && r_curr_state->memory != NULL) {
		r_curr_state->memory = r_curr_state->memory->next;
	}
	printf ("execute finished\n");
}

int check_rule () {
	struct cfg_node * temp_cfg_node;
	int node_number;

	temp_cfg_node = r_curr_state->node ;
	node_number = temp_cfg_node->node_number;
	//printf ("node %d %s\n", node_number, r_curr_state->proc->proc_name);
	if (strcmp (r_curr_state->proc->proc_name, "alt_sep_test") == 0 && (node_number == FIRST_NODE_NUMBER)) {
		found_first = 1;
	}
	if ((found_first == 1) && strcmp (r_curr_state->proc->proc_name, "alt_sep_test") == 0 && (node_number == SECOND_NODE_NUMBER)) {
		found_second = 1;
	}
}

int check_P1 () {
	return (up_sep >= positive_ra_alt_thresh && down_sep < positive_ra_alt_thresh);		
	//return (up_sep < positive_ra_alt_thresh && down_sep >= positive_ra_alt_thresh);		
}
int check_P2 () {
	return (up_sep < positive_ra_alt_thresh && down_sep < positive_ra_alt_thresh && up_sep > down_sep);		
	//return (up_sep < positive_ra_alt_thresh && down_sep < positive_ra_alt_thresh && up_sep < down_sep);		
}
int check_P3 () {
	//printf ("up_sep %d down_sep %d positive_ra_alt_thresh %d \n", up_sep, down_sep, positive_ra_alt_thresh);
	return (up_sep >= positive_ra_alt_thresh && down_sep >= positive_ra_alt_thresh && own_tracked_alt > other_tracked_alt);		
	//return (up_sep >= positive_ra_alt_thresh && down_sep >= positive_ra_alt_thresh && own_tracked_alt > other_tracked_alt);		
		
}
int check_P4 () {
	//return (own_tracked_alt > other_tracked_alt);		
	return (own_tracked_alt < other_tracked_alt);		
}
int check_P5 () {
	//return (up_sep > down_sep);		
	return (up_sep < down_sep);		
}
