void clone_memory (s_state * curr_state, s_state * next_state) {
	int count=0;
	s_mem_loc_list curr_memory;
	s_mem_loc_list next_memory;
	s_mem_loc_list temp_memory;

	//printf ("clone_memory\n");
	next_memory = NULL;
	curr_memory = curr_state->memory;
	while (curr_memory != NULL) {
		s_mem_loc *temp_location;
		s_mem_loc *curr_location;

		temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
		curr_location = curr_memory->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		temp_location->val = (s_value *) xmalloc (sizeof (s_value));
		temp_location->var = curr_location->var; 
		temp_location->next_struct = curr_location->next_struct; 
		temp_location->kind = curr_location->kind; 
		if (curr_location->val != NULL) {
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			}
			if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} 
		else {
			temp_location->val = NULL;
			temp_location->points_to_index = -1; 
		}
		
		temp_memory->location = temp_location;
		temp_memory->next = NULL;
		if (count == 0) {
			next_memory = temp_memory;
			next_state->memory = temp_memory;
			count = 1;
		} else {
			next_memory->next = temp_memory;
			next_memory = temp_memory;
		}
		curr_memory = curr_memory->next;	
	}
	/* we need to renew the last_allocated_memory everytime we clone the memory */
	temp_memory = next_state->memory; 		
	last_allocated_memory = temp_memory;
	while (temp_memory != NULL) {
		last_allocated_memory = temp_memory;
		temp_memory = temp_memory->next;
	}
}

void clone_heap (s_state * curr_state, s_state * next_state) {
	int count = 0;
	s_mem_loc_list curr_heap;
	s_mem_loc_list curr_heap1;
	s_mem_loc_list curr_memory1;
	s_mem_loc_list curr_heap2;
	s_mem_loc_list next_heap;
	s_mem_loc_list temp_heap;
	s_mem_loc_list stored_heap_of_next_state;
	
	//printf ("cloning heap\n");
	if (next_state != NULL) {
		stored_heap_of_next_state = next_state->heap;
	}
	next_heap = NULL;
	curr_heap = curr_state->heap;
	while (curr_heap != NULL) {
		s_mem_loc *temp_location;
		s_mem_loc *curr_location;

		temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
		curr_location = curr_heap->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		temp_location->val = (s_value *) xmalloc (sizeof (s_value));
		temp_location->var = curr_location->var; 
		temp_location->next_struct = curr_location->next_struct; 
		temp_location->index = curr_location->index; 
		if (curr_location->val != NULL) {
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			}
			if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} else {
			temp_location->val = NULL;
			temp_location->points_to_index = -1; 
		}
		temp_heap->location = temp_location;
		temp_heap->next = NULL;
		if (count == 0) {
			next_heap = temp_heap;
			next_state->heap = temp_heap;
			count = 1;
		} else {
			next_heap->next = temp_heap;
			next_heap = temp_heap;
		}
		if (stored_heap_of_next_state != NULL) {
			stored_heap_of_next_state = stored_heap_of_next_state->next;
		}
		curr_heap = curr_heap->next;	
	}
	while (stored_heap_of_next_state != NULL) {
		s_mem_loc *temp_location;
		s_mem_loc *curr_location;

		temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
		curr_location = stored_heap_of_next_state->location;
		temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
		temp_location->val = (s_value *) xmalloc (sizeof (s_value));
		temp_location->var = curr_location->var; 
		temp_location->next_struct = curr_location->next_struct; 
		temp_location->index = curr_location->index; 
		if (curr_location->val != NULL) {
			if (curr_location->val->kind == INT_KIND) {
				temp_location->val->value.int_val = curr_location->val->value.int_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = INT_KIND;
			}
			if (curr_location->val->kind == FLOAT_KIND) {
				temp_location->val->value.float_val = curr_location->val->value.float_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = FLOAT_KIND;
			}
			if (curr_location->val->kind == BOOL_KIND) {
				temp_location->val->value.bool_val = curr_location->val->value.bool_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = BOOL_KIND;
			}
			if (curr_location->val->kind == MEM_KIND) {
				temp_location->val->value.mem_val = curr_location->val->value.mem_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = MEM_KIND;
			}
			if (curr_location->val->kind == HEAP_KIND) {
				temp_location->val->value.heap_val = curr_location->val->value.heap_val; 
				temp_location->points_to_index = curr_location->points_to_index; 
				temp_location->val->kind = HEAP_KIND;
			}
		} else {
			temp_location->val = NULL;
			temp_location->points_to_index = -1; 
		}
		temp_heap->location = temp_location;
		temp_heap->next = NULL;
		if (count == 0) {
			next_heap = temp_heap;
			next_state->heap = temp_heap;
			count = 1;
		} else {
			next_heap->next = temp_heap;
			next_heap = temp_heap;
		}
		stored_heap_of_next_state = stored_heap_of_next_state->next;	
	}
	
	/* we need to renew the last_allocated_heap everytime we clone the heap */
	temp_heap = next_state->heap; 		
	last_allocated_heap = temp_heap;
	while (temp_heap != NULL) {
		last_allocated_heap = temp_heap;
		temp_heap = temp_heap->next;
	}
	/* copying the links of heap locations */
	/* if a heap location is pointing to another heap location, then find that link and put into first's value */
	curr_heap1 = next_state->heap;
	while (curr_heap1 != NULL) {
		int i;
		

		if (curr_heap1->location->points_to_index >0){
			curr_heap2 = next_state->heap;
			i = 0;
			while (curr_heap2 != NULL && i!= curr_heap1->location->points_to_index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == curr_heap1->location->points_to_index) {
				curr_heap1->location->val->value.heap_val = curr_heap2;
			}
		} 
		curr_heap1 = curr_heap1->next;
	}
	/* copying the links of memory locations */
	/* if a memory location is pointing to another heap location, then find that link and put into first's value */
	curr_memory1 = next_state->memory;
	while (curr_memory1 != NULL) {
		int i;

		if (curr_memory1->location->points_to_index >=0){
			curr_heap2 = next_state->heap;
			i = 0;
			while (curr_heap2 != NULL && i!= curr_memory1->location->points_to_index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == curr_memory1->location->points_to_index) {
				curr_memory1->location->val->value.heap_val = curr_heap2;
			}
		} 
		curr_memory1 = curr_memory1->next;
	}
	
	/*copy the next_srtuct field */
	curr_heap1 = next_state->heap;
	while (curr_heap1 != NULL) {
		int i;
		int index;
		if (curr_heap1->location->next_struct){
			i = 0;
			index = curr_heap1->location->next_struct->location->index;
			curr_heap2 = next_state->heap;
			while (curr_heap2 != NULL && i!= index) {
				curr_heap2 = curr_heap2->next;
				i++;
			}
			
			if (i == index ) {
				curr_heap1->location->next_struct = curr_heap2;
			}
		} 
		curr_heap1 = curr_heap1->next;
	}
}

void clone_state (s_state *curr_state, s_state *next_state) {
	next_state->number = curr_state->number + 1;
	next_state->stmt = NULL;	
	next_state->memory = NULL;
	next_state->heap = NULL;
	next_state->proc = curr_state->proc;
	next_state->node = curr_state->node;
	clone_memory (curr_state, next_state);
	//next_state->memory = curr_state->memory;
	clone_heap (curr_state, next_state);
	//next_state->heap = curr_state->heap;
	next_state->return_state = curr_state->return_state;
}
