s_value * find_rvalue (s_state * curr_state, tree r_var) {
	s_value * return_val;

	//printf ("find rvalue\n"); 
	if (r_var == NULL) {
		return_val = NULL;
		return return_val;
	}
	return_val = (s_value *) xmalloc (sizeof (s_value));
	switch (TREE_CODE (r_var)) {
		case INTEGER_CST:
		{
			return_val->value.int_val = (r_var->int_cst).int_cst.low;
			//printf ("int value %d\n", return_val->value.int_val);
			return_val->kind = INT_KIND;
		}
			break;
		case REAL_CST:
		{
			return_val->value.float_val = (r_var->int_cst).int_cst.low;
			return_val->kind = FLOAT_KIND;
		}
			break;
		case VAR_DECL:
		case PARM_DECL:
		case RESULT_DECL:
		{
			s_mem_loc_list rhs_mem; 
			rhs_mem = find_lvalue (curr_state, r_var);	
			if (rhs_mem != NULL) {
				if (rhs_mem->location && rhs_mem->location->val != NULL) {
					return_val->value = rhs_mem->location->val->value;
					//printf ("var value %d\n", return_val->value.int_val);
					return_val->kind = rhs_mem->location->val->kind;
				} else {
					return_val = NULL;
				}
			}else {
				return_val = NULL;
			}
		}
			break;
		case COMPONENT_REF: 
		{
			s_mem_loc_list rhs_mem; 
			rhs_mem = find_lvalue (curr_state, r_var);	
			if (rhs_mem != NULL) {
				if (rhs_mem->location && rhs_mem->location->val != NULL) {
					return_val->value = rhs_mem->location->val->value;
					return_val->kind = rhs_mem->location->val->kind;
				} else {
					return_val = NULL;
				}
			}else {
				return_val = NULL;
			}
		}
			break;
		case ARRAY_REF:
		{
			s_mem_loc_list  rhs_mem; 
			rhs_mem = find_lvalue (curr_state, r_var);	
			if (rhs_mem != NULL) {
				if (rhs_mem->location && rhs_mem->location->val != NULL) {
					return_val->value = rhs_mem->location->val->value;
					return_val->kind = rhs_mem->location->val->kind;
				} else {
					return_val = NULL;
				}
			}else {
				return_val = NULL;
			}
		}
			break;
		case INDIRECT_REF: 
		{
			s_mem_loc_list  rhs_mem; 
			rhs_mem = find_lvalue (curr_state, r_var);	
			if (rhs_mem != NULL) {
				if (rhs_mem->location && rhs_mem->location->val != NULL) {
					return_val->value = rhs_mem->location->val->value;
					return_val->kind = rhs_mem->location->val->kind;
				} else {
					return_val = NULL;
				}
			}else {
				return_val = NULL;
			}
		}
			break;
		case ADDR_EXPR:
		{
			s_mem_loc_list  rhs_mem; 
			rhs_mem = find_lvalue (curr_state, TREE_OPERAND (r_var, 0));	
			return_val->value.mem_val = rhs_mem; 
			return_val->kind = MEM_KIND;
			
		}
			break;
		case MULT_EXPR:
		{
			#define OPERATOR *
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case PLUS_EXPR:
		{
			#define OPERATOR +
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case MINUS_EXPR:
		{
			#define OPERATOR -
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUNC_DIV_EXPR:
		case CEIL_DIV_EXPR:
		case FLOOR_DIV_EXPR:
		case ROUND_DIV_EXPR:
		case TRUNC_MOD_EXPR:
		case CEIL_MOD_EXPR:
		case FLOOR_MOD_EXPR:
		case ROUND_MOD_EXPR:
		case RDIV_EXPR:
		case EXACT_DIV_EXPR:
		case LSHIFT_EXPR:
		case RSHIFT_EXPR:
		case LROTATE_EXPR:
		case RROTATE_EXPR:
		case BIT_IOR_EXPR:
		case BIT_XOR_EXPR:
		case BIT_AND_EXPR:
		case TRUTH_ANDIF_EXPR:
		{
			#define OPERATOR &&
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_ORIF_EXPR:
		{
			#define OPERATOR ||
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_AND_EXPR:
		{
			#define OPERATOR &&
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_OR_EXPR:
		{
			#define OPERATOR ||
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case TRUTH_XOR_EXPR:
		{
			#define OPERATOR ||
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case LT_EXPR:
		{
			#define OPERATOR <
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case LE_EXPR:
		{
			#define OPERATOR <=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case GT_EXPR:
		{
			#define OPERATOR >
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case GE_EXPR:
		{
			#define OPERATOR >=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case EQ_EXPR:
		{
			#define OPERATOR ==
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case NE_EXPR:
		{
			#define OPERATOR !=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNLT_EXPR:
		{
			#define OPERATOR <
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNLE_EXPR:
		{
			#define OPERATOR <=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNGT_EXPR:
		{
			#define OPERATOR >
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		case UNGE_EXPR:
		{
			#define OPERATOR >=
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
	    	case UNEQ_EXPR:
		{
			#define OPERATOR ==
			BINARY_OPERATION ();
			#undef OPERATOR
		}
			break;
		default:
			return_val = NULL;
			break;
	}
	return return_val;

}
