s_value * create_value_structure (tree type) {
	s_value * return_val;
	int * int_return_val;
	float * float_return_val;
	bool * bool_return_val;
	s_mem_loc_list heap_return_val;

	//printf ("create value structure\n");
	return_val = (s_value *) xmalloc (sizeof (s_value));
	if (TREE_CODE (type) == INTEGER_TYPE || TREE_CODE (type) == ENUMERAL_TYPE) {
		return_val->kind = INT_KIND;
		return_val->value.int_val = 0;
	} else if (TREE_CODE (type) == REAL_TYPE) {
		return_val->kind = FLOAT_KIND;
		return_val->value.float_val = 0;
	} else if (TREE_CODE (type) == BOOLEAN_TYPE) {
		return_val->kind = BOOL_KIND;
		return_val->value.bool_val = 0;
	} else if (TREE_CODE (type) == POINTER_TYPE) {
		return_val = NULL;	
	} else if (TREE_CODE (type) == ARRAY_TYPE) {
		heap_return_val = create_value_structure_for_array (type);
		return_val->kind = HEAP_KIND;	
		return_val->value.heap_val = heap_return_val;	
	} else if (TREE_CODE (type) == VOID_TYPE) {
		return_val->kind = INT_KIND;
		return_val->value.int_val = 0;
	}
	return return_val;
}

s_mem_loc_list create_value_structure_for_array (tree type) {
	tree tmp;
	int size;
	int prev_size;
	int k, j;
	int round = 1;
	s_mem_loc_list temp_heap;
	s_mem_loc_list prev_round_first_heap = NULL;
	s_mem_loc_list prev_temp_heap = NULL;
	s_mem_loc_list temp_prev_round_first_heap = NULL;
	s_mem_loc_list return_heap = NULL;
	struct array_size * array_size_list = NULL;
	struct array_size * temp_array_size;
	struct array_size * prev_array_size = NULL;

	//printf ("create value structure for array\n");
	/* first store all the dimensions of array in list */
	tmp = type;
	while (tmp && TREE_CODE (tmp) == ARRAY_TYPE) {
		temp_array_size = (struct array_size *) xmalloc (sizeof (struct array_size));
		if (TYPE_SIZE (tmp)) {
			size = TREE_INT_CST_LOW (TYPE_SIZE (tmp)) /
				  TREE_INT_CST_LOW (TYPE_SIZE (TREE_TYPE (tmp)));
			temp_array_size->size =  size;
		} else {
			fprintf (stdout, "Array does not have size");
			exit (0);
		}	
		temp_array_size->next = NULL;
		if (array_size_list == NULL) {
			array_size_list = temp_array_size; 
			prev_array_size = temp_array_size;
		} else {
			prev_array_size->next = temp_array_size;
			prev_array_size = temp_array_size;
		}
		tmp = TREE_TYPE (tmp);
	}
	/* the final value of tmp is used later in this function */
	/* first allocate the heap locations for all the dimensions */
	/* last dimension will be pointing to null it will be filled later in this function*/
	prev_size = 1;
	size = array_size_list->size;
	//while (array_size_list != NULL) {
	while (array_size_list->next != NULL) {
		if (round == 1) {
			round++;
			//size = array_size_list->size;
			for (j=0; j<prev_size; j++) {
				for (k=0; k<size; k++) {
					temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
					temp_heap->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
					temp_heap->location->val = (s_value *) xmalloc (sizeof (s_value));
					temp_heap->location->next_struct = NULL;
					temp_heap->next = NULL;
					if (last_allocated_heap != NULL) {
						temp_heap->location->index = last_allocated_heap->location->index + 1;
						temp_heap->location->points_to_index = -1; //initialize
						last_allocated_heap->next = temp_heap;
					}
					else {
						temp_heap->location->index = 0;
						temp_heap->location->points_to_index = -1; //initialize
						r_curr_state->heap = temp_heap;
					}
					last_allocated_heap = temp_heap;
					if (k ==0 && j == 0) {
						prev_round_first_heap = last_allocated_heap;
						return_heap = prev_round_first_heap;
					}
					
				}
			}
			prev_size = prev_size * size;
		} else {
			temp_prev_round_first_heap = prev_round_first_heap;
			//prev_size = prev_size * size;
			//size = array_size_list->size;
			for (j=0; j<prev_size; j++) {
				for (k=0; k<size; k++) {
					temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
					temp_heap->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
					temp_heap->location->val = (s_value *) xmalloc (sizeof (s_value));
					temp_heap->location->next_struct = NULL;
					temp_heap->next = NULL;
					if (last_allocated_heap != NULL) {
						temp_heap->location->index = last_allocated_heap->location->index + 1;
						temp_heap->location->points_to_index = -1; //initialize
						last_allocated_heap->next = temp_heap;
					}
					else {
						temp_heap->location->index = 0;
						temp_heap->location->points_to_index = -1; //initialize
						r_curr_state->heap = temp_heap;
					}
					last_allocated_heap = temp_heap;
					if (k ==0 && j==0) {
						prev_round_first_heap = last_allocated_heap;
					}
					if (k==0 && temp_prev_round_first_heap ) {
						temp_prev_round_first_heap->location->val->value.heap_val = temp_heap;
						temp_prev_round_first_heap->location->val->kind = HEAP_KIND;
						temp_prev_round_first_heap->location->points_to_index = temp_heap->location->index;
					}
				}
				if (temp_prev_round_first_heap)	
					temp_prev_round_first_heap = temp_prev_round_first_heap->next;
			}
			prev_size = prev_size * size;
		}
		array_size_list = array_size_list->next;
		size = array_size_list->size;
	}
	/*here it is assumed that array can be of primitive type only */
	/* it can not be of pointer type */	
	/*
	temp_prev_round_first_heap = prev_round_first_heap;
	if (TREE_CODE (tmp) != ARRAY_TYPE) {
		prev_size = prev_size * size;
		for (k=0; k<prev_size; k++) {
			if (TREE_CODE (tmp) != RECORD_TYPE) {
				temp_prev_round_first_heap->location->val = create_value_structure (tmp);
				temp_prev_round_first_heap->location->points_to_index = -1;
				temp_prev_round_first_heap = temp_prev_round_first_heap->next;
			} else {
				s_value * temp_value;
				s_mem_loc_list return_heap;
				temp_value = (s_value *) xmalloc (sizeof (s_value));
				return_heap = allocate_heap_for_records (tmp);
				printf ("h1 \n");
				temp_value->value.heap_val = return_heap; 
				temp_value->kind = HEAP_KIND;
				temp_prev_round_first_heap->location->val = temp_value;
				temp_prev_round_first_heap->location->points_to_index = return_heap->location->index;
				temp_prev_round_first_heap = temp_prev_round_first_heap->next;
			}
		}
	}
	*/
	temp_prev_round_first_heap = prev_round_first_heap;
	prev_temp_heap = NULL;
	if (TREE_CODE (tmp) != ARRAY_TYPE) {
		for (j=0; j<prev_size; j++) {
			for (k=0; k<size; k++) {
				if (TREE_CODE (tmp) != RECORD_TYPE) {
					temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
					temp_heap->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
					temp_heap->location->val = create_value_structure (tmp);
					temp_heap->location->next_struct = NULL;
					temp_heap->next = NULL;
					if (last_allocated_heap != NULL) {
						temp_heap->location->index = last_allocated_heap->location->index + 1;
						temp_heap->location->points_to_index = -1; //initialize
						last_allocated_heap->next = temp_heap;
					}
					else {
						temp_heap->location->index = 0;
						temp_heap->location->points_to_index = -1; //initialize
						r_curr_state->heap = temp_heap;
					}
					last_allocated_heap = temp_heap;
					if (k==0 && temp_prev_round_first_heap) {
						temp_prev_round_first_heap->location->val->value.heap_val = temp_heap;
						temp_prev_round_first_heap->location->val->kind = HEAP_KIND;
						temp_prev_round_first_heap->location->points_to_index = temp_heap->location->index;
					}
				} else {
					temp_heap = allocate_heap_for_records (tmp);
					if (k==0 && temp_prev_round_first_heap) {
						temp_prev_round_first_heap->location->val->value.heap_val = temp_heap;
						temp_prev_round_first_heap->location->val->kind = HEAP_KIND;
						temp_prev_round_first_heap->location->points_to_index = temp_heap->location->index;
					}
					temp_heap->location->next_struct = NULL;
					if (prev_temp_heap != NULL) 
						prev_temp_heap->location->next_struct = temp_heap;
					prev_temp_heap = temp_heap;
				}
				if (round ==1 && k == 0 && j==0) {
					return_heap = temp_heap;
				}
			}
			if (temp_prev_round_first_heap)	
				temp_prev_round_first_heap = temp_prev_round_first_heap->next;
		}
	}
	return return_heap; 
}

s_value * create_value_structure_for_pointer (int malloc_size, tree type) {
	int size;
	int k;
	s_mem_loc_list temp_heap;
	s_mem_loc_list return_heap;
	s_value * return_val;
	
	//printf ("malloc_size %d type %d\n", malloc_size, TREE_CODE (TREE_TYPE (type)));

	size = malloc_size / (TYPE_SIZE (TREE_TYPE (type))->int_cst.int_cst.low/8);
	for (k=0; k<size; k++) {
		if (TREE_CODE (TREE_TYPE (type)) != RECORD_TYPE) {
			temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			temp_heap->location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			temp_heap->location->val = create_value_structure (TREE_TYPE (type));
			temp_heap->next = NULL;
			if (last_allocated_heap != NULL) {
				temp_heap->location->index = last_allocated_heap->location->index + 1;
				temp_heap->location->points_to_index = -1; //initialize
				last_allocated_heap->next = temp_heap;
			}
			else {
				temp_heap->location->index = 0;
				temp_heap->location->points_to_index = -1; //initialize
				r_curr_state->heap = temp_heap;
			}
			last_allocated_heap = temp_heap;
			if (k ==0) {
				return_heap = last_allocated_heap;
			}
		} else {
			if (k == 0) {
				return_heap = allocate_heap_for_records (TREE_TYPE (type));	
			} else {
				allocate_heap_for_records (TREE_TYPE (type));	
			}
		}
	}
	return_val = (s_value *) xmalloc (sizeof (s_value));
	return_val->kind = HEAP_KIND;
	return_val->value.heap_val = return_heap;
	return return_val;
}
