void allocate_curr_state () {
	struct global_list *temp_globals_list;
	struct var_list * temp_locals_list; 
	s_mem_loc_list curr_temp_memory = NULL;
	s_mem_loc_list temp_memory;
	s_mem_loc *temp_location;
	tree params;
	int count = 0, i;

	//printf ("allocate curr state\n");
	r_curr_state = (s_state *) xmalloc (sizeof (s_state)); 
	mm_memory = mm_memory + sizeof (s_state);
	r_curr_state->freed = 0;
	push_state_in_stack (r_curr_state);
	r_curr_state->number = 0;
	r_curr_state->heap = NULL;
	r_curr_state->memory = NULL;
	r_curr_state->stmt = curr_proc->cfg_array[0]->insn;
	r_curr_state->proc = curr_proc;
	curr_cfg_node = curr_proc->cfg_array[0];
	r_curr_state->node = curr_cfg_node;
	r_curr_state->return_stack_length = -1;
	r_curr_state->return_state = NULL;
	for (i=0; i<MAX_RETURN_STACK_SIZE; i++)
		r_curr_state->return_stack[i]= -1;
	last_allocated_memory = NULL;
	last_allocated_heap = NULL;

	temp_globals_list = globals_list;
 	while (temp_globals_list != NULL) {

		if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
			allocate_memory_for_records (temp_globals_list->global, G);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			mm_memory = mm_memory + sizeof (struct my_mem_list);
			temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			mm_memory = mm_memory + sizeof (s_mem_loc);
			temp_location->var = temp_globals_list->global;
			temp_location->kind = G;
			temp_location->points_to_index = -1; //initialize
			temp_location->val = create_value_structure (TREE_TYPE (temp_globals_list->global));	
			temp_location->next_struct = NULL;
			if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
				temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
			}
			temp_memory->location = temp_location;
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
			/*specially for TCAS*/
			if (first_procedure_allocate_state == 1) {
				int x;
				//printf ("random value %s\n",IDENTIFIER_POINTER(DECL_NAME (temp_globals_list->global)) );
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Own_Tracked_Alt") == 0) {
					x = 1+ (int)(drand48() * 2.0);
					//printf ("random value %d\n",x );
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Own_Tracked_Alt_Rate") == 0) {
					x = 1+ (int)(drand48() * 700.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Other_Tracked_Alt") == 0) {
					x = 1+ (int)(drand48() * 2.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Cur_Vertical_Sep") == 0) {
					x = 1+ (int)(drand48() * 700.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Up_Separation") == 0) {
					x = 1+ (int)(drand48() * 900.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Down_Separation") == 0) {
					x = 1+ (int)(drand48() * 900.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "High_Confidence") == 0) {
					x = (int)(drand48() * 2.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Two_of_Three_Reports_Valid") == 0) {
					x = (int)(drand48() * 2.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Alt_Layer_Value") == 0) {
					x = (int)(drand48() * 4.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Other_RAC") == 0) {
					x = (int)(drand48() * 3.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Other_Capability") == 0) {
					x = 1+(int)(drand48() * 2.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
				if (strcmp (IDENTIFIER_POINTER (DECL_NAME (temp_globals_list->global)), "Climb_Inhibit") == 0) {
					x = (int)(drand48() * 2.0);
					temp_memory->location->val->value.int_val = x ;	
				} 
			}
			/*specially for TCAS ends*/
		}

		temp_globals_list = temp_globals_list->next;
	}	
			
	temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
	mm_memory = mm_memory + sizeof (struct my_mem_list);
	temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
	mm_memory = mm_memory + sizeof (s_mem_loc);
	temp_location->var = NULL;  //This is to find that global variables are done before this
	temp_location->kind = G;
	temp_location->points_to_index = -1; 
	temp_location->val = NULL;
	temp_location->next_struct = NULL;
	temp_memory->location = temp_location;
	temp_memory->next = NULL;
	if (last_allocated_memory == NULL) {
		last_allocated_memory = temp_memory ;
		r_curr_state->memory = temp_memory;
	} else {
		last_allocated_memory->next = temp_memory;
		last_allocated_memory = temp_memory;
	}

	params = DECL_ARGUMENTS (curr_proc->proc);	
	while (params) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (params)) == RECORD_TYPE) {
			allocate_memory_for_records (params, L);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			mm_memory = mm_memory + sizeof (struct my_mem_list);
			temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			mm_memory = mm_memory + sizeof (s_mem_loc);
			temp_location->var = params;
			temp_location->kind = L;
			temp_location->points_to_index = -1; //initialize
			temp_location->val = create_value_structure (TREE_TYPE (params));	
			temp_location->next_struct = NULL;
			if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
				temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
			}
			temp_memory->location = temp_location;
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		params = TREE_CHAIN (params);
	}

	temp_locals_list = curr_proc->vars;
 	while (temp_locals_list != NULL) {
		s_mem_loc_list temp_memory;

		if (TREE_CODE (TREE_TYPE (temp_locals_list->var)) == RECORD_TYPE) {
			allocate_memory_for_records (temp_locals_list->var, L);
		} else {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			mm_memory = mm_memory + sizeof (struct my_mem_list);
			temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			mm_memory = mm_memory + sizeof (s_mem_loc);
			temp_location->var = temp_locals_list->var;
			temp_location->kind = L;
			temp_location->points_to_index = -1; //initialize
			temp_location->val = create_value_structure (TREE_TYPE (temp_locals_list->var));	
			temp_location->next_struct = NULL;
			if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
				temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
			}
			temp_memory->location = temp_location;
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				last_allocated_memory = temp_memory ;
				r_curr_state->memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		temp_locals_list = temp_locals_list->next;
	}	
	first_procedure_allocate_state = 0;
	//printf ("finished allocate curr state\n");
}

void allocate_memory_for_records (tree var, int kind) {
	tree fields;
	tree type;
	s_mem_loc_list curr_temp_memory, prev_curr_temp_memory;
	s_mem_loc_list temp_memory;
	s_mem_loc *temp_location;

	//printf ("allocate memory for records\n");
	
	/* a memory location for the structure variable */
	/* location is null as it is dummy location just to keep track of the starting of structure variable*/
	temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
	mm_memory = mm_memory + sizeof (struct my_mem_list);
	temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
	mm_memory = mm_memory + sizeof (s_mem_loc);
	temp_location->var = var;
	temp_location->kind = kind;
	temp_location->points_to_index = -1; //initialize
	temp_location->val = NULL;
	temp_location->next_struct = NULL;
	temp_memory->location = temp_location;
	temp_memory->next = NULL;
	if (last_allocated_memory == NULL) {
		r_curr_state->memory = temp_memory;
		last_allocated_memory = temp_memory;
	} else {
		last_allocated_memory->next = temp_memory;
		last_allocated_memory = temp_memory;
	}
	type = TREE_TYPE (var);
	fields = TYPE_FIELDS (type);
	while (fields) {
		if (TREE_CODE (TREE_TYPE (fields)) != RECORD_TYPE) {
			temp_memory = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			mm_memory = mm_memory + sizeof (struct my_mem_list);
			temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			mm_memory = mm_memory + sizeof (s_mem_loc);
			temp_location->var = fields;
			temp_location->kind = kind;
			temp_location->points_to_index = -1; //initialize
			temp_location->val = create_value_structure (TREE_TYPE (fields));	
			temp_location->next_struct = NULL;
			if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
				temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
			}
			temp_memory->location = temp_location;
			temp_memory->next = NULL;
			if (last_allocated_memory == NULL) {
				r_curr_state->memory = temp_memory;
				last_allocated_memory = temp_memory;
			} else {
				last_allocated_memory->next = temp_memory;
				last_allocated_memory = temp_memory;
			}
		}
		else {
			allocate_memory_for_records (fields, kind);
		}
		fields = TREE_CHAIN (fields);
	}
}

s_mem_loc_list allocate_heap_for_records (tree type) {
	tree fields;
	s_mem_loc_list temp_heap;
	s_mem_loc_list return_heap;
	s_mem_loc * temp_location;

	//printf ("allocate heap for records\n");
	temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
	mm_memory = mm_memory + sizeof (struct my_mem_list);
	temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
	mm_memory = mm_memory + sizeof (s_mem_loc);
	temp_location->var = type; //FIXME, var should be set to some other value not type
	temp_location->points_to_index = -1; //initialize
	temp_location->val = NULL;	
	temp_location->next_struct = NULL;
	if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
		temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
	}
	temp_heap->location = temp_location;
	temp_heap->next = NULL;
	if (last_allocated_heap != NULL) {
		temp_heap->location->index = last_allocated_heap->location->index + 1;
		last_allocated_heap->next = temp_heap;
	} else {
		temp_heap->location->index = 0;
		r_curr_state->heap = temp_heap;
	}
	last_allocated_heap = temp_heap;
	return_heap = temp_heap;
	
	fields = TYPE_FIELDS (type);
	while (fields) {
		if (TREE_CODE (TREE_TYPE (fields)) != RECORD_TYPE) {
			temp_heap = (s_mem_loc_list) xmalloc (sizeof (struct my_mem_list));
			mm_memory = mm_memory + sizeof (struct my_mem_list);
			temp_location = (s_mem_loc *) xmalloc (sizeof (s_mem_loc));
			mm_memory = mm_memory + sizeof(s_mem_loc);
			temp_location->var = fields;
			temp_location->points_to_index = -1; //initialize
			temp_location->val = create_value_structure (TREE_TYPE (fields));	
			temp_location->next_struct = NULL;
			if (temp_location->val && temp_location->val->kind == HEAP_KIND) {
				temp_location->points_to_index = (temp_location->val->value.heap_val)->location->index;
			}
			temp_heap->location = temp_location;
			temp_heap->next = NULL;
			if (last_allocated_heap != NULL) {
				temp_heap->location->index = last_allocated_heap->location->index + 1;
				last_allocated_heap->next = temp_heap;
			} else {
				temp_heap->location->index = 0;
				r_curr_state->heap = temp_heap;
			}
			last_allocated_heap = temp_heap;
		}
		else {
			temp_heap = allocate_heap_for_records (TREE_TYPE (fields));
			temp_heap->location->var = fields;
		}
		fields = TREE_CHAIN (fields);
	}
	return return_heap;
}
