#include "memory.h"
#include "location.h"
#include "state.h"
#include "globals.h"
#include "process.h"
#include "pbl.c"
#include "pblhash.c"
#include "pbl.h"
#include "execution.h"
#include "macros.h"
#include <time.h>
#include "clone.c"
#include "allocate.c"
#include "lvalue.c"
#include "rvalue.c"
#include "lasso_memoize.h"
#include "value-structures.c"

#define MEMWATCH
#define MW_STDIO

int round = 0;
int iround = 0;
int ** hash_table_key_array;
int key_number;
void start_execution(void) 
{
	struct proc_cfg * main_proc; 
	void * data;
	int i;

	lasso_hash_table = pblHtCreate ();
	if (lasso_hash_table == NULL) {
		printf ("error in allocating lasso_hash_table\n");
		exit(0);
	}

	seed = (unsigned)time (NULL);
	srand(seed);
	hash_table_entry = (int *) xmalloc (sizeof (int) * 1000);
	state_hash_table = pblHtCreate ();
	if (state_hash_table == NULL)
	{
		sprintf (stderr, "error in allocating state_hash_table\n");
		exit(0);
	}
	while (1) {
		int present = 0;

		current_index_in_lasso = 0;
		for (i=0; i<MAX_LASSO_LENGTH; i++) {	
			if (i<length_of_largest_lasso_so_far) {
				int current_value;
				int range;
				//range = 2;
				range = 5;
				current_value  = ((range+1) * (rand()/(RAND_MAX + 1.0))); 
				current_lasso[i] = current_value; 
			}
			else
				current_lasso[i] = -1;
		}
		present = pblHtLookup (lasso_hash_table, (void *) current_lasso, sizeof (int) *MAX_LASSO_LENGTH);	
		if (present)
			continue;

		//printf ("********main process ******\n");
		main_process = (s_process *) xmalloc (sizeof (s_process));
		//mm_memory = mm_memory + sizeof (s_process);
		current_process = NULL;
		child_process = NULL;
		last_allocated_heap = NULL;
		last_allocated_memory = NULL;
		r_curr_state = NULL;	
		curr_cfg_node = NULL;
		curr_proc = NULL;
		key_number = 0;
		state_stack = NULL;
		round = 0;
		/*identify the main procedure in the list of all procedures*/
		main_proc = procs;
		while (1)
		{
			if (main_proc == NULL ||strcmp (main_proc->proc_name, "main") == 0 )
				break;
			main_proc = main_proc->next;
		}
		if (main_proc == NULL)
		{
			fprintf (stderr, "function <main> is not defined\n");
			exit(0);
		}
		curr_proc = main_proc;
		allocate_curr_state ();	
		main_process->process_state = r_curr_state;
		main_process->curr_proc = curr_proc;
		main_process->curr_cfg_node = curr_cfg_node;
		main_process->last_allocated_memory = last_allocated_memory;
		main_process->last_allocated_heap = last_allocated_heap;
		current_process = main_process;
		curr_cfg_node = curr_proc->cfg_array[1];
		printf ("round = %d \n", iround);
		execute();
		//printf ("number of keys = %d \n", key_number);
		iround++;
		for( data = pblHtFirst(state_hash_table ); data; data = pblHtNext(state_hash_table )) {
        		if (pblHtRemove(state_hash_table, 0, 0 ) == 0) {
				//printf ("Removed an entry\n");
			}
    		}		

		while (state_stack != NULL) {
			struct state_list * temp_state_list = NULL;
			temp_state_list = pop_state_from_stack ();
			free_state (temp_state_list->state);
			free (temp_state_list->state);
			free (temp_state_list);
		}

		if (main_process) {
			free (main_process);
			//mf_memory = mf_memory + sizeof (s_process);
			main_process = 0;
		}
		if (child_process) {
			free (child_process);
			//mf_memory = mf_memory + sizeof (s_process);
			child_process = 0;
		}
	}
}

void execute ()
{
	tree curr_insn;
	struct cfg_node * next_cfg_node = NULL;
	s_state * r_prev_state = NULL;
	s_state * r_next_state = NULL;
	s_state * r_other_state = NULL;
	
	s_mem_loc_list  lhs_mem;
	while (curr_cfg_node != NULL) {
		curr_insn = curr_cfg_node->insn;
		if (curr_insn!= NULL && TREE_CODE (curr_insn) == FUNCTION_DECL) {
		
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == MODIFY_EXPR) {
			s_value * rhs_value;
			//printf ("modify statements\n");
			if (TREE_CODE (TREE_OPERAND (curr_insn, 1)) == CALL_EXPR) {
				tree formal_params;
				tree actual_params;
				s_value * param_value;
				s_value * global_value;
				char * proc_name;
				struct global_list *temp_globals_list;


				proc_name = IDENTIFIER_POINTER (DECL_NAME (TREE_OPERAND (TREE_OPERAND (TREE_OPERAND (curr_insn,1), 0), 0))); /*FIXME:*/
				//printf ("** %s ** call expression\n", proc_name);
				if (strcmp (proc_name, "malloc") != 0 && strcmp (proc_name, "VS_toss") != 0 && strcmp (proc_name, "fork") != 0) {
					tree temp_insn;

					//r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
					//mm_memory = mm_memory + sizeof (s_state);
					//clone_state (r_curr_state, r_next_state);
					//push_state_in_stack (r_next_state);
					//free_state (r_curr_state);
					//r_next_state->stmt = curr_insn;
					//r_next_state->node = curr_cfg_node;
					//r_curr_state = r_next_state;
					r_curr_state->stmt = curr_insn;
					r_curr_state->node = curr_cfg_node;

					temp_insn = TREE_OPERAND (curr_insn, 1);			
					r_prev_state = r_curr_state;
					curr_proc = procs;
					while (1)
					{
						if (curr_proc == NULL ||strcmp (curr_proc->proc_name, proc_name) == 0 )
							break;
						curr_proc = curr_proc->next;
					}
					if (curr_proc == NULL)
					{
						fprintf (stderr, "function <%s> is not defined\n", proc_name);
						exit(0);
					}
					allocate_curr_state ();
					r_curr_state->return_state = r_prev_state;
					formal_params = DECL_ARGUMENTS (curr_proc->proc);
					actual_params = TREE_OPERAND (temp_insn, 1);
					
					while (formal_params && actual_params) {
						lhs_mem = find_lvalue (r_curr_state, formal_params);
						param_value = find_rvalue (r_prev_state, TREE_VALUE (actual_params));
						if (param_value && param_value->kind == HEAP_KIND) {
							lhs_mem->location->points_to_index = param_value->value.heap_val->location->index;
							free (param_value);
							mf_memory = mf_memory + sizeof (s_value);
							param_value = NULL;
						} else {
							if (lhs_mem->location->val != NULL) {
								free (lhs_mem->location->val);
								mf_memory = mf_memory + sizeof (s_value);
								lhs_mem->location->val = NULL;
							}
							lhs_mem->location->val = param_value;
						}
						formal_params = TREE_CHAIN (formal_params);
						actual_params = TREE_CHAIN (actual_params);
					}
					
					temp_globals_list = globals_list;
					while (temp_globals_list != NULL) {
						if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
							copy_record (r_prev_state, r_curr_state, temp_globals_list->global,0);
						} else {
							lhs_mem = find_lvalue (r_curr_state, temp_globals_list->global);
							global_value = find_rvalue (r_prev_state, temp_globals_list->global);
							//printf ("value %d\n", global_value->value.int_val);
							if (global_value && global_value->kind == HEAP_KIND) {
								lhs_mem->location->points_to_index = global_value->value.heap_val->location->index;
								free (global_value);
								mf_memory = mf_memory + sizeof (s_value);
								global_value = NULL;
							} else {
								
								if (lhs_mem->location->val != NULL) {
									free (lhs_mem->location->val);
									mf_memory = mf_memory + sizeof (s_value);
									lhs_mem->location->val = NULL;
								}
							
								lhs_mem->location->val = global_value;
							}
						}
						temp_globals_list = temp_globals_list->next;
					}
					
					{
						s_mem_loc_list temp_heap, prev_heap;
						prev_heap = r_prev_state->heap;
						temp_heap = r_curr_state->heap;
						while (prev_heap != NULL && temp_heap != NULL) {
							if (prev_heap->location->val != NULL) {
								if (prev_heap->location->val->kind == INT_KIND) {
									temp_heap->location->val->value.int_val = prev_heap->location->val->value.int_val; 
									temp_heap->location->points_to_index = prev_heap->location->points_to_index; 
									temp_heap->location->val->kind = INT_KIND;
								}
							}
							temp_heap = temp_heap->next;
							prev_heap = prev_heap->next;
						}
					}
					//clone_heap (r_prev_state, r_curr_state);
					next_cfg_node = curr_proc->cfg_array[1];
				} else if (strcmp (proc_name, "VS_toss") != 0 && strcmp (proc_name, "fork") != 0) {
					int malloc_size;
					tree type;
					tree temp_insn;

					//r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
					//mm_memory = mm_memory + sizeof (s_state);
					//clone_state (r_curr_state, r_next_state);
					//free_state (r_curr_state);
					//r_next_state->stmt = curr_insn;
					//r_next_state->node = curr_cfg_node;
					//r_curr_state = r_next_state;
					r_curr_state->stmt = curr_insn;
					r_curr_state->node = curr_cfg_node;

					temp_insn = TREE_OPERAND (curr_insn, 1);
					lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
					malloc_size = TREE_VALUE (TREE_OPERAND (temp_insn, 1))->int_cst.int_cst.low ;
					type = TREE_TYPE (curr_insn);
					rhs_value = create_value_structure_for_pointer (malloc_size, type);
					if (lhs_mem != NULL) {
				
						/*
						if (lhs_mem->location->val) {
							free (lhs_mem->location->val);
							mf_memory = mf_memory + sizeof (s_value);
							lhs_mem->location->val = NULL;
						}
						*/
						if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
							lhs_mem->location->val = rhs_value;
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
							lhs_mem->location->val = rhs_value;
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						} else {
							lhs_mem->location->val = rhs_value;
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						}
					}
					/*CHECK_HASH_TABLE();*/
					next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
				} else if (strcmp (proc_name, "fork") != 0) {
					tree temp_insn;
					int range;

					//r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
					//mm_memory = mm_memory + sizeof (s_state);
					//clone_state (r_curr_state, r_next_state);
					//free_state (r_curr_state);
					//r_next_state->stmt = curr_insn;
					//r_next_state->node = curr_cfg_node;
					//r_curr_state = r_next_state;
					r_curr_state->stmt = curr_insn;
					r_curr_state->node = curr_cfg_node;

					temp_insn = TREE_OPERAND (curr_insn, 1);
					lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
					rhs_value = find_rvalue (r_curr_state, TREE_VALUE (TREE_OPERAND (temp_insn, 1)));
					if (rhs_value != NULL) {
						range = rhs_value->value.int_val;
					} else {
						range = -1;
					}

					if (rhs_value != NULL) {
						free (rhs_value);
						mf_memory = mf_memory + sizeof (s_value);
						rhs_value = NULL;
					}

					rhs_value = (s_value *) xmalloc (sizeof (s_value));
					mm_memory = mm_memory + sizeof (s_value);
					/*
					{
						int current_value;
						int present;
						
						start_new_run = 0;
						current_value  = ((range+1) * (rand()/(RAND_MAX + 1.0))); 
						current_lasso[current_index_in_lasso] = current_value;
					  	present = pblHtLookup (lasso_hash_table, (void *) current_lasso, sizeof (int) *35);	
						if (present) {
							if (current_value < range) {
								current_value++;	
								current_lasso[current_index_in_lasso] = current_value;
					  			present = pblHtLookup (lasso_hash_table, (void *) current_lasso, sizeof (int) *35);	
								if (present) {
									start_new_run = 1;
								}
							}
							else 
								start_new_run = 1;
						}
						rhs_value->value.int_val = current_value;
					}
					current_index_in_lasso++;
					if (start_new_run == 1) { 
						int i;
						for (i=0; i<35; i++) {	
							printf ("%d", current_lasso[i]);
						}
						printf ("\n");
						return;
					}
					*/

					if (round == 0) {
						rhs_value->value.int_val = 0; 
					}
					else if (round == 1) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 2) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 3) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 4) {
						rhs_value->value.int_val = 2;
					}
					else if (round == 5) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 6) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 7) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 8) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 9) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 10) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 11) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 12) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 13) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 14) {
						rhs_value->value.int_val = 0;
					} 
					else if (round == 15) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 16) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 17) {
						rhs_value->value.int_val = 2;
					}
					else if (round == 18) {
						rhs_value->value.int_val = 0;
					}
					else
					{
						int wrong_lasso_flag;

						wrong_lasso_flag = 0;
						if (current_index_in_lasso >= MAX_LASSO_LENGTH || current_lasso[current_index_in_lasso] > range) {
							wrong_lasso_flag = 1;
						}
						if (wrong_lasso_flag == 1) { 
							int i;
							/*for (i=0; i<MAX_LASSO_LENGTH; i++) {	
								printf ("%d", current_lasso[i]);
							}
							printf ("range %d\n", range);*/
                					pblHtInsert (lasso_hash_table, (void *) current_lasso, sizeof (int) *MAX_LASSO_LENGTH, (void *) current_lasso);\
							return;
						}
						if (current_lasso[current_index_in_lasso] != -1) {
							/*if (range == 5) {
								rhs_value->value.int_val = ((range+1) * (rand()/(RAND_MAX + 1.0))); 
								//current_lasso[current_index_in_lasso] = rhs_value->value.int_val;
							}else {
								rhs_value->value.int_val = current_lasso[current_index_in_lasso];
							}
							*/
							rhs_value->value.int_val = current_lasso[current_index_in_lasso];
						}
						else {
							rhs_value->value.int_val = ((range+1) * (rand()/(RAND_MAX + 1.0))); 
							current_lasso[current_index_in_lasso] = rhs_value->value.int_val;
						}
					}
					current_index_in_lasso++;

					/*	
					if (round == 0) {
						rhs_value->value.int_val = 0; 
					}
					else if (round == 1) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 2) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 3) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 4) {
						rhs_value->value.int_val = 2;
					}
					else if (round == 5) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 6) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 7) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 8) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 9) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 10) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 11) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 12) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 13) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 14) {
						rhs_value->value.int_val = 0;
					} 
					else if (round == 15) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 16) {
						rhs_value->value.int_val = 1;
					}
					else if (round == 17) {
						rhs_value->value.int_val = 2;
					}
					else if (round == 18) {
						rhs_value->value.int_val = 0;
					}
					else if (round == 16) {
						srand (3);
						rhs_value->value.int_val = ((2+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 17) {
						srand (7);
						rhs_value->value.int_val = ((5+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 18) {
						srand (5);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 19) {
						srand (5);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 20) {
						srand (5);
						rhs_value->value.int_val = ((2+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 21) {
						srand (5);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 22) {
						srand (2);
						rhs_value->value.int_val = ((2+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 23) {
						srand (1);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 24) {
						srand (5);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 25) {
						srand (5);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 26) {
						srand (3);
						rhs_value->value.int_val = ((2+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 27) {
						srand (12);
						rhs_value->value.int_val = ((5+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 28) {
						srand (1);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					if (round == 29) {
						srand (1);
						rhs_value->value.int_val = ((1+1) * (rand()/(RAND_MAX + 1.0))); 
					}
					*/
					//round++;
					//rhs_value->value.int_val = ((range+1) * (rand()/(RAND_MAX + 1.0))); 
					//printf ("VS_toss(%d) = %d\n",range,  rhs_value->value.int_val);
					if (lhs_mem != NULL) {
						
						if (lhs_mem->location->val != NULL) {
							free (lhs_mem->location->val);
							mf_memory = mf_memory + sizeof (s_value);
							lhs_mem->location->val = NULL;
						}
						
						if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
							lhs_mem->location->val = rhs_value;
						} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
							lhs_mem->location->val = rhs_value;
						} else {
							lhs_mem->location->val = rhs_value;
						}
					}
					/*
					{
						struct global_list *temp_globals_list;
						temp_globals_list = globals_list;	
						while (temp_globals_list != NULL) {
							s_value * temp_value;
							temp_value = find_rvalue (r_curr_state, temp_globals_list->global);	
							if (temp_value) {
								//printf ("value %d\n", temp_value->value);
							}
							else {
								//printf ("value null\n" );
							}
							temp_globals_list = temp_globals_list->next;
						}
					} 
					*/
					/*CHECK_HASH_TABLE();*/
					next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
					
				} else {
					tree temp_insn;
					struct cfg_node * prev_cfg_node;
					s_mem_loc_list prev_last_allocated_memory;
					s_mem_loc_list prev_last_allocated_heap;

					//r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
					//mm_memory = mm_memory + sizeof (s_state);
					//clone_state (r_curr_state, r_next_state);
					//free_state (r_curr_state);
					//r_next_state->stmt = curr_insn;
					//r_next_state->node = curr_cfg_node;
					//r_curr_state = r_next_state;
					r_curr_state->stmt = curr_insn;
					r_curr_state->node = curr_cfg_node;

					temp_insn = TREE_OPERAND (curr_insn, 1);
					lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
					rhs_value = (s_value *) xmalloc (sizeof (s_value));
					mm_memory = mm_memory + sizeof (s_value);
					rhs_value->value.int_val = 0;
					if (lhs_mem != NULL) {
						
						if (lhs_mem->location->val) {
							free (lhs_mem->location->val);
							mf_memory = mf_memory + sizeof (s_value);
							lhs_mem->location->val = NULL;
						}
						

						if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
							lhs_mem->location->val = rhs_value;
						} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
							lhs_mem->location->val = rhs_value;
						} else {
							lhs_mem->location->val = rhs_value;
						}
					}
					next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
					curr_cfg_node = next_cfg_node;
					if (curr_cfg_node != NULL) {
						curr_insn = curr_cfg_node->insn;
					}
					r_prev_state = r_curr_state;
					prev_cfg_node = curr_cfg_node;
					prev_last_allocated_memory = last_allocated_memory;
					prev_last_allocated_heap = last_allocated_heap;

					child_process = create_process();
					next_cfg_node = curr_proc->cfg_array[prev_cfg_node->outgoing_edges->node[1]];
					copy_shared_vars_among_processes(r_prev_state, r_curr_state);
					child_process->process_state =  r_curr_state;
					child_process->process_state->stmt = next_cfg_node->insn;
					child_process->process_state->node = next_cfg_node;
					child_process->curr_proc = curr_proc;
					child_process->curr_cfg_node = next_cfg_node;
					child_process->last_allocated_memory = last_allocated_memory;
					child_process->last_allocated_heap = last_allocated_heap;

					next_cfg_node = curr_proc->cfg_array[prev_cfg_node->outgoing_edges->next->node[1]];
					curr_cfg_node = next_cfg_node;
					main_process->process_state = r_prev_state; 
					main_process->curr_proc = curr_proc;
					main_process->curr_cfg_node = curr_cfg_node;
					main_process->last_allocated_memory = prev_last_allocated_memory;
					main_process->last_allocated_heap = prev_last_allocated_heap;
					current_process = main_process;
					r_curr_state = r_prev_state;
					last_allocated_memory = prev_last_allocated_memory;
					last_allocated_heap = prev_last_allocated_heap;
				}
			} else {
				tree temp_insn;	

				temp_insn = TREE_OPERAND (curr_insn, 1);
				//r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
				//mm_memory = mm_memory + sizeof (s_state);
				//clone_state (r_curr_state, r_next_state);
				//free_state (r_curr_state);
				//r_next_state->stmt = curr_insn;
				//r_next_state->node = curr_cfg_node;
				//r_curr_state = r_next_state;
				r_curr_state->stmt = curr_insn;
				r_curr_state->node = curr_cfg_node;
				lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
				if (TREE_CODE (temp_insn) == CONVERT_EXPR) {
					rhs_value = find_rvalue (r_curr_state, TREE_OPERAND (temp_insn, 0));
				} else if (TREE_CODE (temp_insn) == NOP_EXPR) {
					rhs_value = find_rvalue (r_curr_state, TREE_OPERAND (temp_insn, 0));
				} else {
					rhs_value = find_rvalue (r_curr_state, temp_insn);
				}
				if (lhs_mem != NULL) {

					if (lhs_mem->location->val != NULL) {
						free (lhs_mem->location->val);
						mf_memory = mf_memory + sizeof (s_value);
						lhs_mem->location->val = NULL;
					}
					
					if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
						lhs_mem->location->val = rhs_value;
						if (rhs_value->kind == HEAP_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
					} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
						lhs_mem->location->val = rhs_value;
						if (rhs_value->kind == HEAP_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
					} else {
						lhs_mem->location->val = rhs_value;
						if (rhs_value->kind == HEAP_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.heap_val->location->index;
						if (rhs_value->kind == MEM_KIND)
							lhs_mem->location->points_to_index = rhs_value->value.mem_val->location->index;
					}
				} else {
					if (rhs_value) {
						free (rhs_value);
						mf_memory = mf_memory + sizeof (s_value);
						rhs_value = NULL;
					}
				}
				/*CHECK_HASH_TABLE();*/
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			}
			//printf ("allocated = %d freed = %d\n", mm_memory, mf_memory);
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == COND_EXPR) {
			s_value * cond_value;

			//printf ("conditional statement\n");
			cond_value = find_rvalue (r_curr_state, COND_EXPR_COND (curr_insn));		
			//printf ("cond value %d\n",cond_value->value.bool_val); 
			if (cond_value->value.int_val == 1 || cond_value->value.bool_val == 1) {
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			}
			else {
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->next->node[1]];
			}
			if (cond_value != NULL) {
				free (cond_value);
				mf_memory = mf_memory + sizeof (s_value);
				cond_value = NULL;
			}
			//printf ("allocated = %d freed = %d\n", mm_memory, mf_memory);
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == CALL_EXPR) {
			tree formal_params;
			tree actual_params;
			s_value * param_value;
			s_value * global_value;
			char * proc_name;
			struct global_list *temp_globals_list;

			//r_next_state = (s_state *) xmalloc (sizeof (s_state)); 
			//mm_memory = mm_memory + sizeof (s_state);
			//clone_state (r_curr_state, r_next_state);
			//free_state (r_curr_state);
			//r_next_state->stmt = curr_insn;
			//r_next_state->node = curr_cfg_node;
			//r_curr_state = r_next_state;
			r_curr_state->stmt = curr_insn;
			r_curr_state->node = curr_cfg_node;
			r_prev_state = r_curr_state;
			proc_name = IDENTIFIER_POINTER (DECL_NAME (TREE_OPERAND (TREE_OPERAND (curr_insn, 0), 0))); /*FIXME:*/
			//printf ("** %s ** call statement\n", proc_name);
			if (strcmp (proc_name, "wait_process") != 0) { 
				//push_state_in_stack (r_next_state);
				curr_proc = procs;
				while (1)
				{
					if (curr_proc == NULL ||strcmp (curr_proc->proc_name, proc_name) == 0 )
						break;
					curr_proc = curr_proc->next;
				}
				if (curr_proc == NULL)
				{
					fprintf (stderr, "function <%s> is not defined\n", proc_name);
					exit(0);
				}
				allocate_curr_state ();
				r_curr_state->return_state = r_prev_state;
				formal_params = DECL_ARGUMENTS (curr_proc->proc);
				actual_params = TREE_OPERAND (curr_insn, 1);
				
				while (formal_params && actual_params) {
					lhs_mem = find_lvalue (r_curr_state, formal_params);
					param_value = find_rvalue (r_prev_state, TREE_VALUE (actual_params));

					if (param_value && param_value->kind == HEAP_KIND) {
						lhs_mem->location->points_to_index = param_value->value.heap_val->location->index;
						free (param_value);
						mf_memory = mf_memory + sizeof (s_value);
						param_value = NULL;
					} else {
						if (lhs_mem->location->val != NULL) {
							free (lhs_mem->location->val);
							mf_memory = mf_memory + sizeof (s_value);
							lhs_mem->location->val = NULL;
						}
						lhs_mem->location->val = param_value;
					}
					formal_params = TREE_CHAIN (formal_params);
					actual_params = TREE_CHAIN (actual_params);
				}
				
				temp_globals_list = globals_list;
				while (temp_globals_list != NULL) {
					if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
						copy_record (r_prev_state, r_curr_state, temp_globals_list->global, 0);
					} else {
						lhs_mem = find_lvalue (r_curr_state, temp_globals_list->global);	
						global_value = find_rvalue (r_prev_state, temp_globals_list->global);
						//printf ("value %d\n", global_value->value.int_val);
						if (global_value && global_value->kind == HEAP_KIND) {
							lhs_mem->location->points_to_index = global_value->value.heap_val->location->index;
							free (global_value);
							mf_memory = mf_memory + sizeof (s_value);
							global_value = NULL;
						} else {
							
							if (lhs_mem->location->val != NULL) {
								free (lhs_mem->location->val);
								mf_memory = mf_memory + sizeof (s_value);
								lhs_mem->location->val = NULL;
							}
							
							lhs_mem->location->val = global_value;
						}
					}
					temp_globals_list = temp_globals_list->next;
				}
				{
					s_mem_loc_list temp_heap, prev_heap;

					prev_heap = r_prev_state->heap;
					temp_heap = r_curr_state->heap;
					while (prev_heap != NULL && temp_heap != NULL) {
						if (prev_heap->location->val != NULL) {
							if (prev_heap->location->val->kind == INT_KIND) {
								temp_heap->location->val->value.int_val = prev_heap->location->val->value.int_val; 
								temp_heap->location->points_to_index = prev_heap->location->points_to_index; 
								temp_heap->location->val->kind = INT_KIND;
							}
						}
						temp_heap = temp_heap->next;
						prev_heap = prev_heap->next;
					}
				}
				//clone_heap (r_prev_state, r_curr_state);
				next_cfg_node = curr_proc->cfg_array[1];
			} else {
				s_state * prev_state;
				//switch_process ();
				CHECK_HASH_TABLE();
				if (current_process == main_process) {
					//printf ("********child process ******\n");
					prev_state = r_curr_state;
					main_process->process_state = r_curr_state;
					main_process->curr_proc = curr_proc;
					//next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
					next_cfg_node = curr_cfg_node;
					main_process->curr_cfg_node = next_cfg_node;
					main_process->last_allocated_memory = last_allocated_memory;
					main_process->last_allocated_heap = last_allocated_heap;
					current_process = child_process;
					curr_cfg_node = current_process->curr_cfg_node;
					curr_proc = current_process->curr_proc;
					r_curr_state = current_process->process_state;
					copy_shared_vars_among_processes(prev_state, r_curr_state);
					last_allocated_memory = current_process->last_allocated_memory;
					last_allocated_heap = current_process->last_allocated_heap;
				}
				else { 
					//printf ("********main process ******\n");
					prev_state = r_curr_state;
					child_process->process_state = r_curr_state;
					child_process->curr_proc = curr_proc;
					//next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
					next_cfg_node = curr_cfg_node;
					child_process->curr_cfg_node = next_cfg_node;
					child_process->last_allocated_memory = last_allocated_memory;
					child_process->last_allocated_heap = last_allocated_heap;
					current_process = main_process;
					curr_cfg_node = current_process->curr_cfg_node;
					curr_proc = current_process->curr_proc;
					r_curr_state = current_process->process_state;
					copy_shared_vars_among_processes(prev_state, r_curr_state);
					last_allocated_memory = current_process->last_allocated_memory;
					last_allocated_heap = current_process->last_allocated_heap;
				}
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			}
			//printf ("allocated = %d freed = %d\n", mm_memory, mf_memory);
		} else if (curr_insn!= NULL && TREE_CODE (curr_insn) == RETURN_EXPR) {
			s_value * return_value;
			s_mem_loc_list temp_memory;
			s_mem_loc_list temp_memorya;

			//printf ("return statement\n");
			if (TREE_OPERAND (curr_insn, 0)) {
				curr_insn = TREE_OPERAND (curr_insn, 0);
			}	
			if (TREE_CODE (curr_insn) == MODIFY_EXPR) {
				return_value = find_rvalue (r_curr_state, TREE_OPERAND (curr_insn, 1));	
			} else {
				return_value = find_rvalue (r_curr_state, curr_insn);	
			}
			
			//printf ("proc_name %s\n", curr_proc->proc_name);
			if (strcmp (curr_proc->proc_name, "VS_assert") == 0) {
				//printf ("return value %d\n", return_value->value.int_val);
				if (return_value->value.int_val == 0) {
					printf ("Assertion is not valid at this point\n");
					exit(0);
				}
			}	
			r_prev_state = r_curr_state;
			r_curr_state = r_prev_state->return_state;
			
			/*if return state is null means this is the first procedure in the call graph */
			if (r_curr_state != NULL) {
				struct global_list *temp_globals_list;
				s_value * global_value;
				s_mem_loc_list lhs_mem;

				curr_proc = r_curr_state->proc;
				curr_insn = r_curr_state->stmt;
				curr_cfg_node = r_curr_state->node;

				temp_globals_list = globals_list;
				while (temp_globals_list != NULL) {
					if (TREE_CODE (TREE_TYPE (temp_globals_list->global)) == RECORD_TYPE) {
						copy_record (r_prev_state, r_curr_state, temp_globals_list->global, 0);
					} else {
						lhs_mem = find_lvalue (r_curr_state, temp_globals_list->global);	
						global_value = find_rvalue (r_prev_state, temp_globals_list->global);
						//printf ("value %d\n", global_value->value.int_val);
						if (global_value && global_value->kind == HEAP_KIND) {
							lhs_mem->location->points_to_index = global_value->value.heap_val->location->index;
							free (global_value);
							mf_memory = mf_memory + sizeof (s_value);
							global_value = NULL;
						} else {
							
							if (lhs_mem->location->val != NULL) {
								free (lhs_mem->location->val);
								mf_memory = mf_memory + sizeof (s_value);
								lhs_mem->location->val = NULL;
							}
							
							lhs_mem->location->val = global_value;
						}
					}
					temp_globals_list = temp_globals_list->next;
				}
				{
					s_mem_loc_list temp_heap, prev_heap;

					prev_heap = r_prev_state->heap;
					temp_heap = r_curr_state->heap;
					while (prev_heap != NULL && temp_heap != NULL) {
						if (prev_heap->location->val != NULL) {
							if (prev_heap->location->val->kind == INT_KIND) {
								temp_heap->location->val->value.int_val = prev_heap->location->val->value.int_val; 
								temp_heap->location->points_to_index = prev_heap->location->points_to_index; 
								temp_heap->location->val->kind = INT_KIND;
							}
						}
						temp_heap = temp_heap->next;
						prev_heap = prev_heap->next;
					}
				}

				//clone_heap (r_prev_state, r_curr_state);
				/* if the target of return is assignment then update the value of lhs by return value*/
				if (TREE_CODE (curr_insn) == MODIFY_EXPR) {
					lhs_mem = find_lvalue (r_curr_state, TREE_OPERAND (curr_insn, 0));
					if (lhs_mem != NULL) {

						
						if (lhs_mem->location->val != NULL) {
							free (lhs_mem->location->val);
							mf_memory = mf_memory + sizeof (s_value);
							lhs_mem->location->val = NULL;
						}
						

						if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == ARRAY_REF) {
							lhs_mem->location->val = return_value;
							if (return_value->kind == HEAP_KIND)
								lhs_mem->location->points_to_index = return_value->value.heap_val->location->index;
						} else if (TREE_CODE (TREE_OPERAND (curr_insn, 0)) == INDIRECT_REF) {
							lhs_mem->location->val = return_value;
							if (return_value->kind == HEAP_KIND)
								lhs_mem->location->points_to_index = return_value->value.heap_val->location->index;
						} else {
							lhs_mem->location->val = return_value;
							if (return_value->kind == HEAP_KIND)
								lhs_mem->location->points_to_index = return_value->value.heap_val->location->index;
						}
					} else {
						if (return_value) {
							free (return_value);
							mf_memory = mf_memory + sizeof (s_value);
							return_value = NULL;
						}
					}
				}
				/*CHECK_HASH_TABLE();*/
				next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
			} else {
				printf ("************** values *******************\n");
				while (r_prev_state && r_prev_state->memory != NULL) {
					printf ("memory value ");
					if (r_prev_state->memory->location->val) {
						printf ("%d\n", r_prev_state->memory->location->val->value.int_val);
					}
					else {
						printf ("null \n");
					}
					r_prev_state->memory = r_prev_state->memory->next;
				}
				while (r_prev_state && r_prev_state->heap != NULL) {
					printf ("heap value ");
					if (r_prev_state->heap->location->val) {
						printf ("%d \n", r_prev_state->heap->location->val->value.int_val);
					}
					else {
						printf ("null \n");
					}
					r_prev_state->heap = r_prev_state->heap->next;
				}
				next_cfg_node = NULL;
			}
			free_state (r_prev_state);
			//pop_state_from_stack ();
			//printf ("allocated = %d freed = %d\n", mm_memory, mf_memory);
		} else {
			//printf ("other type of statement\n");
			next_cfg_node = curr_proc->cfg_array[curr_cfg_node->outgoing_edges->node[1]];
		}
		curr_cfg_node = next_cfg_node;
	}
}

int check_rule () {
	struct cfg_node * temp_cfg_node;
	int node_number;

	temp_cfg_node = r_curr_state->node ;
	node_number = temp_cfg_node->node_number;
	if (strcmp (r_curr_state->proc->proc_name, "alt_sep_test") == 0 && (node_number == FIRST_NODE_NUMBER)) {
		found_first = 1;
	}
	if ((found_first == 1) && strcmp (r_curr_state->proc->proc_name, "alt_sep_test") == 0 && (node_number == SECOND_NODE_NUMBER)) {
		found_second = 1;
	}
}

void copy_record (s_state * curr_state, s_state * next_state, tree var, int offset) {
	s_mem_loc_list  lhs_mem;
	s_mem_loc_list  rhs_mem;
	s_value * r_value;
	tree fields;
	tree type;
	int k;
	
	//printf ("copy_record\n");
	lhs_mem = find_lvalue (next_state, var);		
	rhs_mem = find_lvalue (curr_state, var);
	for (k = 0; k<offset; k++) {
		lhs_mem = lhs_mem->next;
		rhs_mem = rhs_mem->next;
	}
	r_value = (s_value *) xmalloc (sizeof (s_value));
	mm_memory = mm_memory + sizeof (s_value);
	if (rhs_mem->location->val) {
		r_value->value = rhs_mem->location->val->value;
		r_value->kind = rhs_mem->location->val->kind;
		//printf ("record value %d\n", rhs_mem->location->val->value.int_val);
	} else {
		//printf ("record value null\n");
		free (r_value);
		mf_memory = mf_memory + sizeof (s_value);
		r_value = NULL;
	}
	
	if (lhs_mem->location->val) {
		free (lhs_mem->location->val);
		mf_memory = mf_memory + sizeof (s_value);
		lhs_mem->location->val = NULL;
	}
	

	lhs_mem->location->val = r_value;	
	if (r_value && r_value->kind == HEAP_KIND)
		lhs_mem->location->points_to_index = r_value->value.heap_val->location->index;
	type = TREE_TYPE (var);		
	fields = TYPE_FIELDS (type);	
	while (fields) {
		offset = offset + 1;
		if (TREE_CODE (TREE_TYPE (fields)) != RECORD_TYPE) {
			lhs_mem = find_lvalue (next_state, var);		
			rhs_mem = find_lvalue (curr_state, var);
			for (k = 0; k<offset; k++) {
				lhs_mem = lhs_mem->next;
				rhs_mem = rhs_mem->next;
			}
			r_value = (s_value *) xmalloc (sizeof (s_value));
			mm_memory = mm_memory + sizeof (s_value);
			if (rhs_mem->location->val) {
				r_value->value = rhs_mem->location->val->value;
				r_value->kind = rhs_mem->location->val->kind;
				//printf ("record value %d\n", rhs_mem->location->val->value.int_val);
			} else {
				//printf ("record value null\n");
				free (r_value);
				mf_memory = mf_memory + sizeof (s_value);
				r_value = NULL;
			}
			
			if (lhs_mem->location->val) {
				free (lhs_mem->location->val);
				mf_memory = mf_memory + sizeof (s_value);
				lhs_mem->location->val = NULL;
			}
			
			lhs_mem->location->val = r_value;	
			if (r_value && r_value->kind == HEAP_KIND)
				lhs_mem->location->points_to_index = r_value->value.heap_val->location->index;
		} else {
			copy_record (curr_state, next_state, var, offset);
		}
		fields = TREE_CHAIN (fields);
	}
	return;
}

s_process * create_process () {
	s_process * new_process;
	
	new_process = (s_process *) xmalloc (sizeof (s_process));
	//mm_memory = mm_memory + sizeof (s_process);
	allocate_curr_state ();
	return new_process;
}

void copy_shared_vars_among_processes (s_state * curr_state, s_state * next_state) {
	s_mem_loc_list curr_memory;
	s_mem_loc_list temp_memory;
	s_mem_loc_list curr_heap;
	s_mem_loc_list temp_heap;
	
	curr_memory = curr_state->memory;	
 	while (curr_memory != NULL) {
		s_mem_loc * curr_location;
		s_mem_loc * temp_location;
		char * temp_var_name;
		char * curr_var_name;

		curr_location = curr_memory->location;
		curr_var_name = IDENTIFIER_POINTER (DECL_NAME (curr_location->var)); 
		if ((strcmp(curr_var_name, "I_to_A") == 0)
			|| (strcmp(curr_var_name, "A_to_I") == 0)
			|| (strcmp(curr_var_name, "R_to_A") == 0)
			|| (strcmp(curr_var_name, "A_to_R") == 0)) {
			temp_memory = next_state->memory;
			while (temp_memory != NULL) {
				temp_location = temp_memory->location;
				temp_var_name = IDENTIFIER_POINTER (DECL_NAME (temp_location->var)); 
				if (((strcmp(temp_var_name, "I_to_A") == 0) 
					|| (strcmp(temp_var_name, "A_to_I") == 0)
					|| (strcmp(temp_var_name, "R_to_A") == 0)
					|| (strcmp(temp_var_name, "A_to_R") == 0)) 
					&& (strcmp (curr_var_name, temp_var_name) == 0)){
					/*copy null*/
					curr_heap = curr_location->val->value.heap_val;
					temp_heap = temp_location->val->value.heap_val;
					/*copy 0*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					temp_heap->location->val->value.int_val = curr_heap->location->val->value.int_val;
					/*copy null*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					/*copy 0*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					temp_heap->location->val->value.int_val = curr_heap->location->val->value.int_val;
					/*copy 0*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					temp_heap->location->val->value.int_val = curr_heap->location->val->value.int_val;
					/*copy null*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					/*copy 0*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					temp_heap->location->val->value.int_val = curr_heap->location->val->value.int_val;
					/*copy 0*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					temp_heap->location->val->value.int_val = curr_heap->location->val->value.int_val;
					/*copy 0*/
					curr_heap = curr_heap->next;
					temp_heap = temp_heap->next;
					temp_heap->location->val->value.int_val = curr_heap->location->val->value.int_val;
					
				}
				temp_memory = temp_memory->next;
			}
		}
		if ((strcmp(curr_var_name, "I_to_A_filled") == 0)
			|| (strcmp(curr_var_name, "A_to_I_filled") == 0)
			|| (strcmp(curr_var_name, "R_to_A_filled") == 0)
			|| (strcmp(curr_var_name, "A_to_R_filled") == 0)) {

			temp_memory = next_state->memory;
			while (temp_memory != NULL) {
				temp_location = temp_memory->location;
				temp_var_name = IDENTIFIER_POINTER (DECL_NAME (temp_location->var)); 
				if (((strcmp(temp_var_name, "I_to_A_filled") == 0) 
					|| (strcmp(temp_var_name, "A_to_I_filled") == 0)
					|| (strcmp(temp_var_name, "R_to_A_filled") == 0)
					|| (strcmp(temp_var_name, "A_to_R_filled") == 0)) 
					&& (strcmp (curr_var_name, temp_var_name) == 0)){
						temp_location->val->value.int_val = curr_location->val->value.int_val;
					//	printf ("%s %d\n", temp_var_name, curr_location->val->value.int_val);
				}
				temp_memory = temp_memory->next;
			}
		}
		curr_memory = curr_memory->next;
	}	
	return;
}

void generate_hash_table_entry (s_state * curr_state, int curr_proc_number, int curr_insn_number, 
			s_state * other_state, int other_proc_number, int other_insn_number) {
	s_mem_loc_list temp_memory;
	s_mem_loc_list temp_heap;
	int i;
	
	for (i=0; i<1000; i++) {
		hash_table_entry[i] = -1;
	}
	//printf ("hash entries %d %d %d %d\n", curr_proc_number, curr_insn_number, other_proc_number, other_insn_number);
	i=0;
	hash_table_entry[i] = curr_proc_number;
	i++;
	hash_table_entry[i] = curr_insn_number;
	i++;
	hash_table_entry[i] = other_proc_number;
	i++;
	hash_table_entry[i] = other_insn_number;
	i++;
	temp_heap = curr_state->heap;	
	while (temp_heap != NULL) {
		if (temp_heap->location->val != NULL) {
			if (temp_heap->location->val->kind == INT_KIND) {
				hash_table_entry[i] = temp_heap->location->val->value.int_val;
				i++;
								
			}
		}
		temp_heap = temp_heap->next;
	}
	temp_memory = curr_state->memory;	
	while (temp_memory != NULL) {
		if (temp_memory->location->val != NULL) {
			if (temp_memory->location->val->kind == INT_KIND) {
				hash_table_entry[i] = temp_memory->location->val->value.int_val;
				i++;
			}
		}
		temp_memory = temp_memory->next;
	}

	temp_heap = NULL;
	temp_memory = NULL;
	if (other_state != NULL)
		temp_heap = other_state->heap;	
	while (temp_heap != NULL) {
		if (temp_heap->location->val != NULL) {
			if (temp_heap->location->val->kind == INT_KIND) {
				hash_table_entry[i] = temp_heap->location->val->value.int_val;
				i++;
								
			}
		}
		temp_heap = temp_heap->next;
	}
	if (other_state != NULL)
		temp_memory = other_state->memory;	
	while (temp_memory != NULL) {
		if (temp_memory->location->val != NULL) {
			if (temp_memory->location->val->kind == INT_KIND) {
				hash_table_entry[i] = temp_memory->location->val->value.int_val;
				i++;
			}
		}
		temp_memory = temp_memory->next;

	}
	key_number++;
	return;
}

void free_state (s_state * state) {
	s_mem_loc_list temp_memory;
	s_mem_loc_list prev_memory;
	s_mem_loc_list temp_heap;
	s_mem_loc_list prev_heap;
	
	if (state->freed == 1) {
		return;
	}
	temp_memory = state->memory;
	while (temp_memory != NULL) {
		if (temp_memory->location->val) {
			free (temp_memory->location->val);
			mf_memory = mf_memory + sizeof (s_value);
			temp_memory->location->val = NULL;
		}
		if (temp_memory->location) {
			free (temp_memory->location);
			//mf_memory = mf_memory + sizeof (s_mem_loc);
			temp_memory->location = NULL;
		}
		prev_memory = temp_memory;
		temp_memory = temp_memory->next;
		free (prev_memory);
		//mf_memory = mf_memory + sizeof (struct my_mem_list);
		prev_memory = NULL;
	}

	temp_heap = state->heap;
	while (temp_heap != NULL) {
		
		if (temp_heap->location->val) {
			free (temp_heap->location->val);
			mf_memory = mf_memory + sizeof (s_value);
			temp_heap->location->val =NULL;
		}
		if (temp_heap->location) {
			free (temp_heap->location);
			//mf_memory = mf_memory + sizeof (s_mem_loc);
			temp_heap->location = NULL;
		}
		prev_heap = temp_heap;
		temp_heap = temp_heap->next;
		free (prev_heap);
		//mf_memory = mf_memory + sizeof (struct my_mem_list);
		prev_heap = NULL;
	}
	state->freed = 1;
	//free (state);
	//mf_memory = mf_memory + sizeof (s_state);
	state = NULL;
	return;
}


void push_state_in_stack (s_state * state) {
	struct state_list * temp_state_list;
	temp_state_list = (struct state_list *) xmalloc (sizeof (struct state_list));
	temp_state_list->state = state;
	//printf ("pushed state %d\n", state->number);
	temp_state_list->next = NULL;
	if (state_stack == NULL) {
		state_stack = temp_state_list;	
	} else {
		temp_state_list->next = state_stack;
		state_stack = temp_state_list;
	}
	return;
}

struct state_list * pop_state_from_stack () {
	struct state_list * temp_state_list;
	if (state_stack == NULL) {
		return NULL;
	} else {
		temp_state_list = state_stack;
		state_stack = state_stack->next;
		//printf ("popped state %d\n", temp_state_list->state->number);
		return temp_state_list;
	}
}
