#include "bitstr.h"

#define MAX_NUM_VARS 3

typedef struct state_def {
	unsigned long int val[MAX_NUM_VARS];
	int range[MAX_NUM_VARS];
} state_t;

/*
int state_compress(const state_t *state, byte_t **bytes)
{
	int i;
	int bit_pos;
	int num_bits = 0;
	bitstr_t *bstr;
	for (i=0; i<MAX_NUM_VARS; i++) {
		int current_range = state->range[i];
		while (current_range  != 0) {
			current_range = current_range / 2;
			num_bits++;
		}
	}
	
	bstr = bitstr_alloc (num_bits);
	
	bit_pos = 0;
	for (i=0; i<MAX_NUM_VARS; i++) {
		unsigned long int current_val;
		int n_bits = 0;
		int current_range = state->range[i];
		while (current_range != 0) {
			current_range = current_range / 2;
			n_bits++;
		}
		printf ("%d numbits ", n_bits);
		current_val = state->val[i];
		while (n_bits>0) {
			if (current_val & 0x1) {
				printf ("bit%d ", bit_pos );
				bitstr_set(bstr, bit_pos);
			} else {
				printf ("-bit " );
			} 
			current_val = current_val >> 1;
			n_bits--;
			bit_pos++;
		}
	}

	*bytes = bstr->ptr;
	free(bstr);
	return 1;;
}
*/

bitstr_t * state_compress (const state_t * state) {
	int i;
	int bit_pos;
	int num_bits = 0;
	bitstr_t *bstr;
	for (i=0; i<MAX_NUM_VARS; i++) {
		int current_range = state->range[i];
		while (current_range  != 0) {
			current_range = current_range / 2;
			num_bits++;
		}
	}
	
	bstr = bitstr_alloc (num_bits);
	
	bit_pos = 0;
	for (i=0; i<MAX_NUM_VARS; i++) {
		unsigned long int current_val;
		int n_bits = 0;
		int current_range = state->range[i];
		while (current_range != 0) {
			current_range = current_range / 2;
			n_bits++;
		}
		current_val = state->val[i];
		while (n_bits>0) {
			if (current_val & 0x1) {
				bitstr_set(bstr, bit_pos);
			} else {
			} 
			current_val = current_val >> 1;
			n_bits--;
			bit_pos++;
		}
	}
	return bstr;
}


state_t * state_decompress (const bitstr_t * bstr) {
	state_t * state;
	unsigned long int current_val;
	int begin_bit_pos;
	int end_bit_pos;
	int i;
	state = (state_t*) malloc (sizeof (state_t));

	for (i=0; i<MAX_NUM_VARS; i++) {
		state->range[i] =  ;
	}
	
	begin_bit_pos = 0;
	for (i=0; i<MAX_NUM_VARS; i++) {
		int n_bits = 0;
		int current_range = state->range[i];
		while (current_range  != 0) {
			current_range = current_range / 2;
			n_bits++;
		}
		end_bit_pos = begin_bit_pos + (n_bits -1);
		current_val = bitstr_substr_to_uint32 (bstr, begin_bit_pos, end_bit_pos);	
		state->val[i] = current_val;
		begin_bit_pos = end_bit_pos +1;
	}	
	return state;	
}


int main() {
	state_t * state;
	bitstr_t * bstr;
	state = (state_t*) malloc (sizeof (state_t));
	state->val[0] = 2;	
	state->range[0] = 2;	
	state->val[1] = 3;	
	state->range[1] = 4;	
	state->val[2] = 7;	
	state->range[2] = 8;	
	bstr = state_compress(state);
	printf("string 1: %s\n", bitstr_to_bit_seq (bstr));
}
