#include "../bitstr.h"
#include <stdio.h>
#include "memwatch.h"

int main()
{
	mwInit();
	
	bitstr_t *bstr1 = bitstr_from_uint32(0x5de61a31);
	bitstr_t *bstr2 = bitstr_from_uint16(0x3c9d);

	printf("string 1: %s\n", bitstr_to_bit_seq(bstr1));
	printf("string 2: %s\n", bitstr_to_bit_seq(bstr2));

	int from = 5, to = 21;
	bitstr_t *bstr3 = bitstr_substr(bstr1, from, to);
	bitstr_t *bstr4 = bitstr_substr(bstr2, 6, 15);
	bitstr_t *bstr5 = bitstr_concat(bstr3, bstr4);
	
	printf("string 3: %s\n", bitstr_to_bit_seq(bstr3));
	printf("string 4: %s\n", bitstr_to_bit_seq(bstr4));
	printf("string 5: %s\n", bitstr_to_bit_seq(bstr5));
	bitstr_append_uint32(bstr5, 0x31035dd2);
	printf("string 6: %s\n", bitstr_to_bit_seq(bstr5));
	
	printf("int of string: 0x%x\n", bitstr_substr_to_uint32(bstr1, from, to));
	bitstr_free(bstr1);
	bitstr_free(bstr2);
	bitstr_free(bstr3);
	bitstr_free(bstr4);
	bitstr_free(bstr5);
	
	mwTerm();
	return 0;
}
