void build_node_array (){
	int p_id;
	basic_block bb;
	struct p_node * p_node;
	block_stmt_iterator bsi;
	
	total_pdg_nodes = 0;
	total_pdg_nodes++; /* this is for the function name instruction which is considered to be first instruction in our case*/
	FOR_EACH_BB (bb) {
       		for (bsi = bsi_start (bb); !bsi_end_p (bsi); bsi_next (&bsi))
		{
			total_pdg_nodes++;
		}
	}

	node_array = (struct p_node **) xmalloc (sizeof (struct p_node *) * total_pdg_nodes);
	p_id = 0;
	p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
	p_node->node_number = p_id;
	p_node->insn = current_function_decl;
	node_array[p_id] = p_node; 
	p_id++;
	FOR_EACH_BB (bb) {
       		for (bsi = bsi_start (bb); !bsi_end_p (bsi); bsi_next (&bsi))
		{
			tree stmt;
			stmt = bsi_stmt (bsi);
			stmt->common.p_id_sumit = p_id;
			p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
			p_node->node_number = p_id;
			p_node->insn = stmt;
			node_array[p_id] = p_node; 
			p_id++;
		}
	}
}

void create_dot_file_for_cfg()
{
    int p, q;
    FILE * dot_file;
    tree curr_insn;
    basic_block bb;
    block_stmt_iterator si; 
    block_stmt_iterator temp_si; 
    int prev_insn_id, curr_insn_id;
    tree prev_insn = NULL;
    int first_stmt_of_block = 0;
    int last_stmt_of_block = 0;
    int first_basic_block = 0;
  

    dot_file = fopen("dot_file_cfg","w");

        fprintf(dot_file,"\ndigraph G {\n");
	if (total_pdg_nodes >1)
	{
		for(p=0; p <total_pdg_nodes; p++) {
			if(node_array[p] != NULL)
			{
				if (p==0)
					fprintf(dot_file,"  %d [label= \"Entry\", color=blue];\n",p);
				else 
					fprintf(dot_file,"  %d [label= \"%d\", color=blue];\n",p,p);
			}
		}
	}
	
	first_basic_block = 0;
	FOR_EACH_BB (bb)
	{
		first_stmt_of_block = 0;
		last_stmt_of_block = 0;
		si = bsi_start (bb);
		first_basic_block++;
		while (!bsi_end_p (si)) 
		{
			curr_insn = bsi_stmt (si);
			first_stmt_of_block++;
			bsi_next (&si);
			if (bsi_end_p(si))
				last_stmt_of_block =1;
			if (first_stmt_of_block != 1 && last_stmt_of_block != 1)
			{
				if (prev_insn != NULL)
					prev_insn_id = prev_insn->common.p_id_sumit;
				curr_insn_id = curr_insn->common.p_id_sumit;
				fprintf(dot_file,"  %d -> %d [label= \"e\"];\n",prev_insn_id,curr_insn_id);
				prev_insn = curr_insn;
			}
			if (first_stmt_of_block == 1)
			{
				curr_insn_id = curr_insn->common.p_id_sumit;
				if (first_basic_block == 1)
					fprintf(dot_file,"  %d -> %d [label= \"e\"];\n",0,curr_insn_id);
				prev_insn = curr_insn;
			}
			if (last_stmt_of_block == 1)
			{
				edge e;
				if (first_stmt_of_block != 1)
				{
					if (prev_insn != NULL)
						prev_insn_id = prev_insn->common.p_id_sumit;
					curr_insn_id = curr_insn->common.p_id_sumit;
					fprintf(dot_file,"  %d -> %d [label= \"e\"];\n",prev_insn_id,curr_insn_id);
				}
				prev_insn = curr_insn;
				for (e = bb->succ; e != 0; e = e->succ_next)
				{
					basic_block bb1;
					if (e->dest == EXIT_BLOCK_PTR)
						curr_insn_id = total_pdg_nodes;	
					else
					{
						bb1 = e->dest;
						temp_si = bsi_start (bb1);
						curr_insn = bsi_stmt (temp_si);
						if (TREE_CODE (curr_insn) == COMPOUND_EXPR)
							curr_insn = TREE_OPERAND (curr_insn, 0);
						curr_insn_id = curr_insn->common.p_id_sumit;
					}
					if (prev_insn != NULL)
						prev_insn_id = prev_insn->common.p_id_sumit;
					fprintf(dot_file,"  %d -> %d [label= \"e\"];\n",prev_insn_id,curr_insn_id);
					
				}
				
			}
		}		
		
	}

	fprintf(dot_file," }");
}


void construct_cfg (void)
{
	struct cfg_edge * ot_edge;
	struct cfg_edge * it_edge;
	int src_pid, dest_pid;
	tree curr_insn;
	tree prev_insn=NULL;
	block_stmt_iterator si; 
	block_stmt_iterator temp_si; 
	basic_block bb;
	int prev_insn_id, curr_insn_id;
	int first_stmt_of_block=0;
	int last_stmt_of_block=0;
	int first_basic_block=0;
	int i;

	build_node_array ();
	cfg_array = (struct cfg_node **) xmalloc (sizeof (struct cfg_node *) * total_pdg_nodes+1);	
	for (i=0; i<total_pdg_nodes; i++)
	{
		struct cfg_node * c_node = (struct cfg_node *) xmalloc (sizeof (struct cfg_node)); 
		c_node->node_number = i; 
		c_node->insn = node_array[i]->insn;
		c_node->outgoing_edges = NULL;
		c_node->incoming_edges = NULL;
		cfg_array[i] = c_node;
	}
	cfg_array[i] = NULL;

	first_basic_block = 0;
	FOR_EACH_BB (bb)
	{
		first_stmt_of_block = 0;
		last_stmt_of_block = 0;
		si = bsi_start (bb);
		first_basic_block++;
		
		if (bsi_end_p (si)) {
			edge e;
			//prev_insn = curr_insn;
			for (e = bb->succ; e != 0; e = e->succ_next)
			{
				basic_block bb1;
				if (e->dest == EXIT_BLOCK_PTR)
					curr_insn_id = total_pdg_nodes;	
				else
				{
					bb1 = e->dest;
					temp_si = bsi_start (bb1);
					curr_insn = bsi_stmt (temp_si);
					if (TREE_CODE (curr_insn) == COMPOUND_EXPR)
						curr_insn = TREE_OPERAND (curr_insn, 0);
					curr_insn_id = curr_insn->common.p_id_sumit;
				}
				if (first_basic_block == 1)
				{
					prev_insn_id = 0;
				} else if (prev_insn != NULL)
					prev_insn_id = prev_insn->common.p_id_sumit;
				src_pid = prev_insn_id;
				dest_pid = curr_insn_id; 
				ot_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
				ot_edge->node[0] = src_pid; 
				ot_edge->node[1] = dest_pid;
				ot_edge->next = cfg_array[src_pid]->outgoing_edges;
				cfg_array[src_pid]->outgoing_edges = ot_edge;
				
				it_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
				it_edge->node[0] = src_pid; 
				it_edge->node[1] = dest_pid;
				if (dest_pid != total_pdg_nodes) {
					it_edge->next = cfg_array[dest_pid]->incoming_edges;
					cfg_array[dest_pid]->incoming_edges = it_edge;
				}
			}
			continue;
		}
		
		while (!bsi_end_p (si)) 
		{
			curr_insn = bsi_stmt (si);
			first_stmt_of_block++;
			bsi_next (&si);
			if (bsi_end_p(si))
				last_stmt_of_block =1;
			if (first_stmt_of_block != 1 && last_stmt_of_block != 1)
			{
				if (prev_insn != NULL)
					prev_insn_id = prev_insn->common.p_id_sumit;
				curr_insn_id = curr_insn->common.p_id_sumit;
				src_pid = prev_insn_id;
				dest_pid = curr_insn_id; 
				ot_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
				ot_edge->node[0] = src_pid; 
				ot_edge->node[1] = dest_pid;
				ot_edge->next = cfg_array[src_pid]->outgoing_edges;
				cfg_array[src_pid]->outgoing_edges = ot_edge;
				
				it_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
				it_edge->node[0] = src_pid; 
				it_edge->node[1] = dest_pid;
				it_edge->next = cfg_array[dest_pid]->incoming_edges;
				cfg_array[dest_pid]->incoming_edges = it_edge;
				
				prev_insn = curr_insn;
			}
			if (first_stmt_of_block == 1)
			{
				curr_insn_id = curr_insn->common.p_id_sumit;
				if (first_basic_block == 1)
				{
					//src_pid = 1;
					src_pid = 0;
					dest_pid = curr_insn_id; 
					ot_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
					ot_edge->node[0] = src_pid; 
					ot_edge->node[1] = dest_pid;
					ot_edge->next = cfg_array[src_pid]->outgoing_edges;
					cfg_array[src_pid]->outgoing_edges = ot_edge;
					
					it_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
					it_edge->node[0] = src_pid; 
					it_edge->node[1] = dest_pid;
					it_edge->next = cfg_array[dest_pid]->incoming_edges;
					cfg_array[dest_pid]->incoming_edges = it_edge;
				}
				prev_insn = curr_insn;
			}
			if (last_stmt_of_block == 1)
			{
				edge e;
				if (first_stmt_of_block != 1)
				{
					if (prev_insn != NULL)
						prev_insn_id = prev_insn->common.p_id_sumit;
					curr_insn_id = curr_insn->common.p_id_sumit;
					src_pid = prev_insn_id;
					dest_pid = curr_insn_id; 
					ot_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
					ot_edge->node[0] = src_pid; 
					ot_edge->node[1] = dest_pid;
					ot_edge->next = cfg_array[src_pid]->outgoing_edges;
					cfg_array[src_pid]->outgoing_edges = ot_edge;
					
					it_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
					it_edge->node[0] = src_pid; 
					it_edge->node[1] = dest_pid;
					it_edge->next = cfg_array[dest_pid]->incoming_edges;
					cfg_array[dest_pid]->incoming_edges = it_edge;
				}
				prev_insn = curr_insn;
				for (e = bb->succ; e != 0; e = e->succ_next)
				{
					basic_block bb1;
					if (e->dest == EXIT_BLOCK_PTR)
						curr_insn_id = total_pdg_nodes;	
					else
					{
						bb1 = e->dest;
						/*curr_insn = *(bb1->head_tree_p);*/
						temp_si = bsi_start (bb1);
						curr_insn = bsi_stmt (temp_si);
						if (TREE_CODE (curr_insn) == COMPOUND_EXPR)
							curr_insn = TREE_OPERAND (curr_insn, 0);
						curr_insn_id = curr_insn->common.p_id_sumit;
					}
					if (prev_insn != NULL)
						prev_insn_id = prev_insn->common.p_id_sumit;
					src_pid = prev_insn_id;
					dest_pid = curr_insn_id; 
					ot_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
					ot_edge->node[0] = src_pid; 
					ot_edge->node[1] = dest_pid;
					ot_edge->next = cfg_array[src_pid]->outgoing_edges;
					cfg_array[src_pid]->outgoing_edges = ot_edge;
					
					it_edge = (struct cfg_edge *) xmalloc (sizeof (struct cfg_edge));
					it_edge->node[0] = src_pid; 
					it_edge->node[1] = dest_pid;
					if (dest_pid != total_pdg_nodes) {
						it_edge->next = cfg_array[dest_pid]->incoming_edges;
						cfg_array[dest_pid]->incoming_edges = it_edge;
					}
					
				}
				
			}
		}		
		
	}
}


