#include <tgmath.h>
#define LAMDBA (M_E - 2)
#define max(a,b) ((a>=b)?a:b)
#define min(a,b) ((a<=b)?a:b)

static double calculate_gamma(double epsilon, double delta)
{
	return 4.0 * LAMDBA * log(2.0/delta) / (epsilon*epsilon);
}
static double calculate_gamma2(double gamma, double epsilon, double delta)
{
	double sqrt_epsilon = sqrt(epsilon);
	return 2 * (1+sqrt_epsilon) * (1+2*sqrt_epsilon) *
			(1 + log(1.5)/log(2.0/delta) ) * gamma;
}
static int calculate_N1(double epsilon, double delta)
{
	double gamma = calculate_gamma(epsilon, delta);
	return (int)((1+epsilon) * gamma) + 1;
}
static int calculate_N2(double gamma2, double epsilon, double mu_z)
{
	return (int)(gamma2 * epsilon / mu_z);
}
static int calculate_N3(double gamma2, double rho_z, double mu_z)
{
	return (int)(gamma2 * rho_z / (mu_z*mu_z));
}
static int calculate_N(double epsilon, double delta)
{
	double gamma = calculate_gamma(epsilon, delta);
	double gamma2 = calculate_gamma2(gamma, epsilon, delta);
	int N1 = calculate_N1(min(0.5, sqrt(epsilon)), delta/3.0);
	int N2 = calculate_N2(gamma2, epsilon, 1.0);
	int N3 = calculate_N3(gamma2, epsilon, 1.0); 
	
	return 2*N2 + max(N1, N3);
}
/*int main() {
	double epsilon = 0.00001;
	double delta = 0.0001;
	int N = calculate_N(epsilon, delta);
  	printf ("%d\n", N);
}
*/
