/* data structure for stoing basic block list and all the insn list */
struct bb_list_sumit {
	basic_block bb;
	struct bb_list_sumit *next;
};

struct tree_list_sumit {
	tree *stmt;
	struct tree_list_sumit *next;
};

struct tree_list_sumit * head_stack = NULL;
struct bb_list_sumit * head_bb_stack = NULL;

/* data structure for reaching definition analysis */
struct insn_info_sumit
{
	unsigned int id;
	struct insn_info_sumit * next;
};

tree * insn_list_sumit; //this will keep the maping of id to insn

struct reg_info_sumit 
{
	tree reg;
  	struct insn_info_sumit **insns;//new
	struct reg_info_sumit *next;
};

struct reg_info_sumit *regs = NULL;
int total_rd_nodes;

/* data structure for program dependency graph pdg */
/*
struct p_edge
{
	int node[2];	
	int type; // 1 for flow, 2 for control
	struct p_edge * next;
};

struct p_node
{
	int node_number;
	bool marked;
	tree insn;
	struct p_edge * outgoing_edges;
	struct p_edge * incoming_edges;
	//int num_outgoing_edges;
	//int num_incoming_edges;
};

struct p_node * * node_array = NULL;

int total_pdg_nodes;

struct proc_pdg
{
	struct p_node * * node_array;
	int total_nodes;
	char * proc_name;
	struct proc_pdg * next;
};
struct proc_pdg * sys_pdg = NULL;
*/

struct use_vars
{
	tree var1;
	tree var2;
};


struct worklist_node
{
	int node_number;
	struct worklist_node *next;
};

struct worklist_node * worklist = NULL;

/* data structure for dominance tree */
struct dom_tree_edge
{
	int node[2];
	int type;
	struct dom_tree_edge * next;
};

struct dom_tree_node 
{
	struct dom_tree_edge * outgoing_edges;
	struct dom_tree_edge * incoming_edges;
	//int num_outgoing_edges;
	//int num_incoming_edges;
};

struct dom_tree_node ** dominance_tree_array = NULL;
struct dom_tree_node ** dominance_tree_array_slicing = NULL;

/* data structure for lexical successor tree */
struct last_stmt
{
	tree stmt;
	struct last_stmt *next;
}; 

struct lexical_succ_edge 
{
	int node[2];
	struct lexical_succ_edge *next;

};

struct lexical_succ_node 
{
	struct lexical_succ_edge * outgoing_edges;
	struct lexical_succ_edge * incoming_edges;
	//int num_outgoing_edges;
	//int num_incoming_edges;
};

struct lexical_succ_node ** lexical_succ_array = NULL;

basic_block * bb_array_sumit = NULL;

/* data structure for basick_block storing in list for cfg construction in dot file*/
struct bb_list_sumit_for_cfg {
	basic_block bb;
	tree prev_insn;
	struct bb_list_sumit_for_cfg *next;
};
struct bb_list_sumit_for_cfg * head_bb_stack_for_cfg = NULL;

int slicing_point;

extern void compute_alias_sets (void);
void tree_stmt_push_stack_sumit(tree *t); 
void tree_stmt_pop_stack_sumit(tree **curr_stmt_ptr); 
void push_bb_stack(basic_block bb); 
void pop_bb_stack(basic_block *bb); 
void construct_cfg(void);
void create_dot_file_for_cfg(void);
void push_worklist (int node_number);
int pop_worklist ();
void insert_reg_insn_list (tree reg, unsigned int id, unsigned int bindex);
int collect_reg_insn_info(void);
void compute_local_rd_gen_kill(void);
void iterative_dataflow_rd (void);
void construct_lexical_successor_tree ();
tree find_first_stmt (tree stmt);
void track_last_stmt (tree stmt, struct last_stmt **);
void create_dot_file_for_lexical_succ_tree();
void construct_immediate_post_dominance_tree();
void construct_immediate_post_dominance_tree_for_insns();
void create_dot_file_for_dominance_tree();
void construct_pdg_data_dep_edges (void);
void construct_pdg_control_dep_edges(void);
void create_dot_file_for_pdg();
void construct_slice (int );
void construct_slice_with_jump_statements ();
void pop_bb_stack_for_cfg (basic_block *bb, tree * prev_insn);
void push_bb_stack_for_cfg (basic_block bb, tree  prev_insn);

void push_bb_stack (basic_block bb) {
	struct bb_list_sumit *temp_stack;
	temp_stack = (struct bb_list_sumit *) xmalloc(sizeof(struct bb_list_sumit));
	temp_stack->bb = bb;
	temp_stack->next = head_bb_stack;
	head_bb_stack = temp_stack;

}

void pop_bb_stack (basic_block *bb) {
	
	if (head_bb_stack == NULL) {
		printf("Error in popping bb_stack\n");
	}
	else {
		*(bb) = head_bb_stack->bb;
		head_bb_stack = head_bb_stack->next;	
	}
}

void push_bb_stack_for_cfg (basic_block bb, tree prev_insn) {
	struct bb_list_sumit_for_cfg *temp_stack;
	temp_stack = (struct bb_list_sumit_for_cfg *) xmalloc(sizeof(struct bb_list_sumit_for_cfg));
	temp_stack->bb = bb;
	temp_stack->prev_insn = prev_insn;
	temp_stack->next = head_bb_stack_for_cfg;
	head_bb_stack_for_cfg = temp_stack;

}

void pop_bb_stack_for_cfg (basic_block *bb, tree * prev_insn) {
	
	if (head_bb_stack_for_cfg == NULL) {
		printf("Error in popping bb_stack\n");
	}
	else {
		*(bb) = head_bb_stack_for_cfg->bb;
		*(prev_insn) = head_bb_stack_for_cfg->prev_insn;
		head_bb_stack_for_cfg = head_bb_stack_for_cfg->next;	
	}
}

void tree_stmt_push_stack_sumit(tree *t) {

	struct tree_list_sumit *temp_stack;
	temp_stack = (struct tree_list_sumit *) xmalloc(sizeof(struct tree_list_sumit));
	temp_stack->stmt = t;
	temp_stack->next = head_stack;
	head_stack = temp_stack;
}

void tree_stmt_pop_stack_sumit(tree **curr_stmt_ptr) {
	
	if(head_stack == NULL) {
		printf("Error in stack null\n");
	}
	else {

		*(curr_stmt_ptr) = head_stack->stmt;
		head_stack = head_stack->next;
	}
}




bool sbitmap_union_of_diff_cg_sumit (int bb)
{
  unsigned int i;
  unsigned int changed = 0;
  int * temp_array;
  basic_block b = BASIC_BLOCK (bb);

  temp_array = (int *) xmalloc (total_rd_nodes * sizeof (int));
  for (i=0; i<total_rd_nodes; i++)
	temp_array[i]=0;

  for (i=0; i<total_rd_nodes; i++)
	temp_array[i] = b->rd_out[i];

  for (i = 0; i < total_rd_nodes; i++)
  {
	b->rd_out[i] = b->rd_gen[i] | (b->rd_in[i] & ~b->rd_kill[i]);
  }
  
/* here we are checking if the rd->out is changing or not */
  i=0;
  while (i < total_rd_nodes)
  {
	if (b->rd_out[i] != temp_array[i])
	{
		changed = 1;
		break;
	}
	i++;
  }

  return changed;
}


void sbitmap_union_of_preds_sumit (int bb)
{
  edge e;
  unsigned int i;
  basic_block b = BASIC_BLOCK (bb);

  for (e = b->pred; e != 0; e = e->pred_next)
    {
      if (e->src == ENTRY_BLOCK_PTR)
	continue;

      for (i=0; i<total_rd_nodes; i++)
      	b->rd_in[i] = e->src->rd_out[i];
      break;
    }

  if (e == 0)
  {
      for (i=0; i<total_rd_nodes; i++)
      	b->rd_in[i] = 0;
  }
  else
    for (e = e->pred_next; e != 0; e = e->pred_next)
      {
	if (e->src == ENTRY_BLOCK_PTR)
	  continue;
	
	for (i=0; i<total_rd_nodes; i++)
		b->rd_in[i] |= e->src->rd_out[i]; 
	  
      }
}


void iterative_dataflow_rd (void)
{
	basic_block bb;
	int i, changed;

	/* My own adddition in standard iterative solution 
	given in Aho Sethi.
	*/

	FOR_EACH_BB (bb) 
	{
		for (i=0; i<total_rd_nodes; i++)
		{
			bb->rd_gen[i] = (bb->rd_gen[i] & ~bb->rd_kill[i]);
		}
	}

	FOR_EACH_BB (bb)
	{
		for (i=0; i<total_rd_nodes; i++)
		{
			bb->rd_out[i] = bb->rd_gen[i];
		}
	}	
	changed = 1;
	while (changed)
	{
		changed = 0;
		FOR_EACH_BB (bb)
		{
			sbitmap_union_of_preds_sumit (bb->index);
	  		changed |= sbitmap_union_of_diff_cg_sumit (bb->index);
		}
	}
	
	FOR_EACH_BB (bb) 
	{
		printf("rd_gen = ");
		for (i=0; i<total_rd_nodes; i++)
		{
			printf("%d", bb->rd_gen[i]);
		}
		printf("\n");
		printf("rd_kill = ");
		for (i=0; i<total_rd_nodes; i++)
		{
			printf("%d", bb->rd_kill[i]);
		}
		printf("\n");
		printf("rd_in = ");
		for (i=0; i<total_rd_nodes; i++)
		{
			printf("%d", bb->rd_in[i]);
		}
		printf("\n");
		printf("rd_out = ");
		for (i=0; i<total_rd_nodes; i++)
		{
			printf("%d", bb->rd_out[i]);
		}
		printf("\n");
		printf("\n");
		printf("\n");
	}
}


struct reg_info_sumit * lookup_reg_list (tree reg) 
{
	struct reg_info_sumit * curr;
	bool found;
	found=0;
	if (regs == NULL) 
		return NULL; 
	curr = regs;
	while (!found && curr != NULL) 
	{
		if (curr->reg == reg) 
			found = 1;
		else
			curr = curr->next;
	}
	if (found)
		return curr;
	else 
		return NULL;

}

/**
The following function is used to compute the gen and kill for each basic block.
Simultaneously we also create nodes for pdg.
To get gen & kill we traverse each modify_stmt (instruction). gen is 
obviously the instruction only, but that instruction kills def generated 
in other basic blocks, so we get insns  associated to the variable of def
and kill all of them except the current instruction.
We also create the insntructions list in insn_list_sumit, list's index is 
the id of instruction. 
**/

void compute_local_rd_gen_kill(void)
{
	basic_block bb;
	block_stmt_iterator si;
	tree * first_p;
	tree tnode, node0;
	tree op0, op1;
	tree arg;
	int id=0;
	int p_id = 0;
	int src_pid, dest_pid;
	struct p_node * p_node;
	struct p_edge * ot_edge;
	struct p_edge * it_edge;

	insn_list_sumit = (tree *) xmalloc (total_rd_nodes * sizeof (tree));	

	/* for entry node */	
	p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
	p_node->node_number = p_id;
	p_node->marked = 0;
	p_node->insn = current_function_decl;
	p_node->outgoing_edges = NULL;
	p_node->incoming_edges = NULL;
	node_array[p_id] = p_node; 
	p_id++;

	/*arg = DECL_ARGUMENTS (current_function_decl);
	while (arg)
	{
		p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
		p_node->node_number = p_id;
		p_node->marked = 0;
		p_node->insn = NULL;
		p_node->outgoing_edges = NULL;
		p_node->incoming_edges = NULL;
		node_array[p_id] = p_node; 
		ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
		src_pid = 0;
		dest_pid = p_id;
		ot_edge->node[0] = src_pid;
		ot_edge->node[1] = dest_pid;
		ot_edge->type = 2;
		ot_edge->next = node_array[src_pid]->outgoing_edges;
		node_array[src_pid]->outgoing_edges = ot_edge;
		
		it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
		src_pid = 0;
		dest_pid = p_id;
		it_edge->node[0] = src_pid;
		it_edge->node[1] = dest_pid;
		it_edge->type = 2;
		it_edge->next = node_array[dest_pid]->incoming_edges;
		node_array[dest_pid]->incoming_edges = it_edge;
		p_id++;
		arg = TREE_CHAIN (arg);			
	}
	*/

	FOR_EACH_BB (bb) 
	{
		for (si = bsi_start (bb); !bsi_end_p (si); bsi_next (&si)) 
		{
			tnode = bsi_stmt (si);
			if (TREE_CODE (tnode) == GOTO_EXPR) 
			{
				p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
				p_node->node_number = p_id;
				p_node->marked = 0;
				p_node->insn = tnode;
				p_node->outgoing_edges = NULL;
				p_node->incoming_edges = NULL;
				node_array[p_id] = p_node; 
				tnode->common.p_id_sumit = p_id;
				p_id++;
			}
			else if (TREE_CODE (tnode) == COND_EXPR) 
			{	
				p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
				p_node->node_number = p_id;
				p_node->marked = 0;
				p_node->insn = tnode;	 
				p_node->outgoing_edges = NULL;
				p_node->incoming_edges = NULL;
				node_array[p_id] = p_node; 
				tnode->common.p_id_sumit = p_id;
				TREE_OPERAND (tnode, 0)->common.p_id_sumit = p_id;
				p_id++;

			}
			else if (TREE_CODE (tnode) == MODIFY_EXPR)
			{
				struct reg_info_sumit * reg;
				struct insn_info_sumit * curr_insn;
				int num_aliases;
				int i;
  				varray_type aliases;

				p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
				p_node->node_number = p_id;
				p_node->marked = 0;
				p_node->insn = tnode;
				p_node->outgoing_edges = NULL;
				p_node->incoming_edges = NULL;
				node_array[p_id] = p_node; 
				tnode->common.p_id_sumit = p_id;
				p_id++;

				node0 = TREE_OPERAND (tnode, 0);	
				insn_list_sumit[id] = tnode;
				/*
				if (TREE_CODE (node0) == INDIRECT_REF)
				{
					var_ann_t ann;
					ann = var_ann (TREE_OPERAND (node0, 0));
					if (ann->type_mem_tag)
						aliases = var_ann (ann->type_mem_tag)->may_aliases;
					if (aliases)
					{
						num_aliases = VARRAY_ACTIVE_SIZE (aliases);		
						printf ("in aliases %d\n", num_aliases);
						for (i=0; i<num_aliases; i++)
						{
							tree temp_node;
							temp_node = VARRAY_TREE (aliases, i);
							reg = lookup_reg_list (temp_node); 
							if(reg != NULL)
							{
								int b;	
								for (b=0; b<last_basic_block; b++)
								{
									curr_insn = reg->insns[b];
									while (curr_insn != NULL)
									{
										int id1;
										id1 = curr_insn->id;
										bb->rd_kill[id1] = 1;
										curr_insn = curr_insn->next;
									} 
								}
								bb->rd_kill[id] = 0;
							}
							bb->rd_gen[id] = 1;
						}
					}else 
					{
						reg = lookup_reg_list (node0); 
						if(reg != NULL)
						{
							int b;	
							for (b=0; b<last_basic_block; b++)
							{
								curr_insn = reg->insns[b];
								while (curr_insn != NULL)
								{
									int id1;
									id1 = curr_insn->id;
									bb->rd_kill[id1] = 1;
									curr_insn = curr_insn->next;
								} 
							}
							bb->rd_kill[id] = 0;
						}
						bb->rd_gen[id] = 1;
					}
						
				} else if (TREE_CODE (node0) == COMPONENT_REF || TREE_CODE (node0) == ARRAY_REF)
				{
					op0 = TREE_OPERAND (node0, 0);
					reg = lookup_reg_list (op0); 
					if(reg != NULL)
					{
						int b;	
						for (b=0; b<last_basic_block; b++)
						{
							curr_insn = reg->insns[b];
							while (curr_insn != NULL)
							{
								int id1;
								id1 = curr_insn->id;
								bb->rd_kill[id1] = 1;
								curr_insn = curr_insn->next;
							} 
						}
						bb->rd_kill[id] = 0;
						
					}
					bb->rd_gen[id] = 1;
				} else 
				*/
				{
					reg = lookup_reg_list (node0); 
					if(reg != NULL)
					{
						int b;	
						for (b=0; b<last_basic_block; b++)
						{
							curr_insn = reg->insns[b];
							while (curr_insn != NULL)
							{
								int k;
								k = curr_insn->id;
								bb->rd_kill[k] = 1;
								curr_insn = curr_insn->next;
							} 
						}
						bb->rd_kill[id] = 0;
						
					}
					bb->rd_gen[id] = 1;
				}
				id++;
			}
			else if (TREE_CODE (tnode) == CALL_EXPR) 
			{ 
				p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
				p_node->node_number = p_id;
				p_node->marked = 0;
				p_node->insn = tnode;
				p_node->outgoing_edges = NULL;
				p_node->incoming_edges = NULL;
				node_array[p_id] = p_node; 
				tnode->common.p_id_sumit = p_id;
				p_id++;
				/*
				op1 = TREE_OPERAND (tnode, 1);
				if (op1)
				{
					if (TREE_CODE (op1) == TREE_LIST)
					{
						while (op1 && op1 != error_mark_node)
						{
							p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
							p_node->node_number = p_id;
							p_node->marked = 0;
							p_node->insn = op1;
							p_node->outgoing_edges = NULL;
							p_node->incoming_edges = NULL;
							node_array[p_id] = p_node; 
							ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
							src_pid = tnode->common.p_id_sumit;
							dest_pid = p_id;
							ot_edge->node[0] = src_pid;
							ot_edge->node[1] = dest_pid;
							ot_edge->type = 2;
							ot_edge->next = node_array[src_pid]->outgoing_edges;
							node_array[src_pid]->outgoing_edges = ot_edge;
							
							it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
							src_pid = tnode->common.p_id_sumit;
							dest_pid = p_id;
							it_edge->node[0] = src_pid;
							it_edge->node[1] = dest_pid;
							it_edge->type = 2;
							it_edge->next = node_array[dest_pid]->incoming_edges;
							node_array[dest_pid]->incoming_edges = it_edge;
			
							p_id++;
							op1 = TREE_CHAIN (op1);
						}
					}  
				}
				*/
			}
			else if (TREE_CODE (tnode) == RETURN_EXPR)
			{
				p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
				p_node->node_number = p_id;
				p_node->marked = 0;
				p_node->insn = tnode;
				p_node->outgoing_edges = NULL;
				p_node->incoming_edges = NULL;
				node_array[p_id] = p_node; 
				tnode->common.p_id_sumit = p_id;
				p_id++;
				/*op0 = TREE_OPERAND (tnode, 0);
				if (op0)
				{
					p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
					p_node->node_number = p_id;
					p_node->marked = 0;
					p_node->insn = tnode;
					p_node->outgoing_edges = NULL;
					p_node->incoming_edges = NULL;
					node_array[p_id] = p_node; 


					src_pid = tnode->common.p_id_sumit;
					dest_pid = p_id;
					ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
					src_pid = tnode->common.p_id_sumit;
					dest_pid = p_id;
					ot_edge->node[0] = src_pid;
					ot_edge->node[1] = dest_pid;
					ot_edge->type = 2;
					ot_edge->next = node_array[src_pid]->outgoing_edges;
					node_array[src_pid]->outgoing_edges = ot_edge;
					
					it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
					src_pid = tnode->common.p_id_sumit;
					dest_pid = p_id;
					it_edge->node[0] = src_pid;
					it_edge->node[1] = dest_pid;
					it_edge->type = 2;
					it_edge->next = node_array[dest_pid]->incoming_edges;
					node_array[dest_pid]->incoming_edges = it_edge;
			
					p_id++;
				}
				*/
			}
			else 
			{ 
				p_node = (struct p_node *) xmalloc (sizeof (struct p_node));
				p_node->node_number = p_id;
				p_node->marked = 0;
				p_node->insn = tnode;
				p_node->outgoing_edges = NULL;
				p_node->incoming_edges = NULL;
				node_array[p_id] = p_node; 
				tnode->common.p_id_sumit = p_id;
				p_id++;
			}
		}
	}
}



/**
The following function is used to insert the information about the assoication
between variables and instructions. The information is inserted in the list named
regs. We also keep that the instruction is in which basic block. 

	regs[0]-->insns[i]->id 
	       -->reg 
	       .
	       .
	regs[1]
	.
	.
	.

Above is the structure of the regs list.
**/
void insert_reg_insn_list (tree reg, unsigned int id, unsigned int bindex) 
{
	struct reg_info_sumit * prev;
	struct reg_info_sumit * curr;
	struct insn_info_sumit * insn;
	struct insn_info_sumit * curr_insn;
	bool found;
	int i;
	found=0;
	if (regs == NULL) {
		curr = (struct reg_info_sumit *) xmalloc (sizeof(struct reg_info_sumit));
		curr->reg = reg;
		curr->insns = (struct insn_info_sumit * *) xmalloc ((last_basic_block+2) * sizeof (struct insn_info_sumit *));	
		for (i=0; i<(last_basic_block+2); i++)
			curr->insns[i] = NULL;
		
		insn = (struct insn_info_sumit *) xmalloc (sizeof (struct insn_info_sumit));
	  	insn->id = id;
		insn->next = NULL;
		curr->insns[bindex] = insn;
		curr->next = NULL;
		regs = curr;
		return; 
	}
	curr = regs;
	while (!found && curr != NULL) 
	{
		if (curr->reg == reg) 
			found = 1;
		else
		{
			prev = curr;
			curr = curr->next;
		}
	}
	if (found)
	{
		if(curr->insns[bindex] == NULL)
		{
			insn = (struct insn_info_sumit *) xmalloc (sizeof (struct insn_info_sumit));
			insn->id = id;
			insn->next = NULL;
			curr->insns[bindex] = insn; 
			return;
		}
		curr_insn = curr->insns[bindex];
		while (curr_insn->next != NULL)
		{
			curr_insn = curr_insn->next;
		}
		insn = (struct insn_info_sumit *) xmalloc (sizeof (struct insn_info_sumit));
		insn->id = id;
		insn->next = NULL;
		curr_insn->next = insn; 
		return;
	}
	else 
	{
		curr = (struct reg_info_sumit *) xmalloc (sizeof(struct reg_info_sumit));
		curr->reg = reg;
		curr->insns = (struct insn_info_sumit * *) xmalloc ((last_basic_block+2) * sizeof (struct insn_info_sumit *));		     
		for (i=0; i<(last_basic_block+2); i++)
			curr->insns[i] = NULL;

		insn = (struct insn_info_sumit *) xmalloc (sizeof (struct insn_info_sumit));
	  	insn->id = id;
		insn->next = NULL;
		curr->insns[bindex] = insn;
		curr->next = NULL;
		prev->next = curr;
		return;
	}

}



/**
The following function computes the list of all instructions 
associated with a register (variable).
e.g. x = y;
     x = z+d;
then there are two instructions associated with variable x.
this information of association is kept in a list and done through
function named insert_reg_insn_list.
in the following function we also compute the total number of nodes
in the pdg, there two kind of nodes. First modify statements and another
conditionals. We also give number to all instructions (modify_stmts)
using variable id.
	
**/
int collect_reg_insn_info(void)
{
	
	tree node0;
  	tree tnode;
	tree op0, op1;
	basic_block bb;
	block_stmt_iterator si;
	int id=0;
	int total_nodes_for_pdg=0;
	tree arg;
	
	/*arg = DECL_ARGUMENTS (current_function_decl);
	while (arg)
	{
		total_nodes_for_pdg++;
		arg = TREE_CHAIN (arg);			
	}
	*/
	total_nodes_for_pdg++;
	FOR_EACH_BB (bb)
	{
		for (si = bsi_start (bb); !bsi_end_p (si); bsi_next (&si)) 
		{
			tnode = bsi_stmt (si);
			if (TREE_CODE (tnode) == GOTO_EXPR) 
			{
				total_nodes_for_pdg++;
			}
			else if (TREE_CODE (tnode) == COND_EXPR) 
			{	
				//insert_reg_insn_list (TREE_OPERAND (tnode, 0), id, bb->index);
				//id++;
				total_nodes_for_pdg++;
			}
			else if (TREE_CODE (tnode) == MODIFY_EXPR)
			{
				int i;
				int num_aliases;
  				varray_type aliases;

				total_nodes_for_pdg++;
				node0 = TREE_OPERAND (tnode, 0);	
				/*if (TREE_CODE (node0) == INDIRECT_REF)
				{
					var_ann_t ann;

					ann = var_ann (TREE_OPERAND (node0, 0));
					if (ann->type_mem_tag)
						aliases = var_ann (ann->type_mem_tag)->may_aliases;
					if (aliases)
					{
						num_aliases = VARRAY_ACTIVE_SIZE (aliases);		
						printf ("instruction is indirect_ref with num_aliases = %d\n", num_aliases);
						for (i=0; i<num_aliases; i++)
						{
							tree temp_node;
							temp_node = VARRAY_TREE (aliases, i);
							insert_reg_insn_list (temp_node, id, bb->index); 
						}
					}
					else 
						insert_reg_insn_list (node0, id, bb->index); 
				} else if (TREE_CODE (node0) == COMPONENT_REF || TREE_CODE (node0) == ARRAY_REF)
				{
					op0 = TREE_OPERAND (node0, 0);
					insert_reg_insn_list (op0, id, bb->index); 
				} else*/
					insert_reg_insn_list (node0, id, bb->index); 
				id++;
			}
			else if (TREE_CODE (tnode) == CALL_EXPR) 
			{
				total_nodes_for_pdg++;
				/*op1 = TREE_OPERAND (tnode, 1);
				if (op1)
				{
					if (TREE_CODE (op1) == TREE_LIST)
					{
						while (op1 && op1 != error_mark_node)
						{
							total_nodes_for_pdg++;
							op1 = TREE_CHAIN (op1);
						}
					}  
				}*/
			}
			else if (TREE_CODE (tnode) == RETURN_EXPR)
			{
				total_nodes_for_pdg++;
				/*if (TREE_OPERAND (tnode, 0))
					total_nodes_for_pdg++;
				*/
				
			}
			else 
			{ 
				/* do nothing for other type of statements in the program */
				total_nodes_for_pdg++;
			}
		}
	}
	total_rd_nodes = id;

	/** for the exit node **/
	total_nodes_for_pdg++;
	return total_nodes_for_pdg;
}



struct use_vars give_use_vars(tree use_insn) 
{
    struct use_vars use_vars;
    tree temp_tree;
    use_vars.var1 = NULL;
    use_vars.var2 = NULL;
    switch (TREE_CODE (use_insn))
    {
    	case VAR_DECL:
    	case PARM_DECL:
 		use_vars.var1 = use_insn;
 		use_vars.var2 = NULL; 
		break;
    	case COMPONENT_REF:
 		use_vars.var1 = TREE_OPERAND (use_insn, 0);
 		use_vars.var2 = NULL; 
		break;
    	case ARRAY_REF:
 		use_vars.var1 = TREE_OPERAND (use_insn, 0);
 		use_vars.var2 = NULL; 
		break;
   /* binary ops */	
	case MULT_EXPR:
	case PLUS_EXPR:
	case MINUS_EXPR:
	case TRUNC_DIV_EXPR:
	case CEIL_DIV_EXPR:
	case FLOOR_DIV_EXPR:
	case ROUND_DIV_EXPR:
	case TRUNC_MOD_EXPR:
	case CEIL_MOD_EXPR:
	case FLOOR_MOD_EXPR:
	case ROUND_MOD_EXPR:
	case RDIV_EXPR:
	case EXACT_DIV_EXPR:
	case LSHIFT_EXPR:
	case RSHIFT_EXPR:
	case LROTATE_EXPR:
	case RROTATE_EXPR:
	case BIT_IOR_EXPR:
	case BIT_XOR_EXPR:
	case BIT_AND_EXPR:
	case TRUTH_ANDIF_EXPR:
	case TRUTH_ORIF_EXPR:
	case TRUTH_AND_EXPR:
	case TRUTH_OR_EXPR:
	case TRUTH_XOR_EXPR:
	case LT_EXPR:
	case LE_EXPR:
	case GT_EXPR:
	case GE_EXPR:
	case EQ_EXPR:
	case NE_EXPR:
	case UNLT_EXPR:
	case UNLE_EXPR:
	case UNGT_EXPR:
	case UNGE_EXPR:
	case UNEQ_EXPR:
 		temp_tree = use_insn;	
 		if (TREE_CODE (TREE_OPERAND (temp_tree, 0)) == VAR_DECL)
			use_vars.var1 = TREE_OPERAND (temp_tree, 0);	
 		if (TREE_CODE (TREE_OPERAND (temp_tree, 1)) == VAR_DECL)
			use_vars.var2 = TREE_OPERAND (temp_tree, 1);	
		break;
   /* unary ops */ 
	case NEGATE_EXPR:
	case BIT_NOT_EXPR:
	case TRUTH_NOT_EXPR:
 		temp_tree = use_insn;	
 		if (TREE_CODE (TREE_OPERAND (temp_tree, 0)) == VAR_DECL)
			use_vars.var1 = TREE_OPERAND (temp_tree, 0);	
		break;
	case INDIRECT_REF:
		use_vars.var1 = use_insn; 
		use_vars.var2 = NULL; 
    	default: 
		break;
    }

    return use_vars;

}



void construct_pdg_data_dep_edges (void)
{
	struct use_vars use_vars;
	int i, j;
	int p;
	int src_pid, dest_pid;
	struct p_edge * ot_edge;
	struct p_edge * it_edge;
	int count;
	int num_aliases;
	struct reg_info_sumit * reg;
	int use_id, def_id;
	struct insn_info_sumit * curr_insn;
	int find_data_dep_flag=0;
	varray_type aliases;
	tree lhs_of_def_insn;
	tree tnode, node0, node1;
  	tree use_insn, def_insn, prev_def_insn;
	basic_block bb;
	block_stmt_iterator si, si0, si1;
	tree use_insn_temp;
	
	FOR_EACH_BB (bb)	
	{
		for (si = bsi_start (bb); !bsi_end_p (si); bsi_next (&si)) 
		{
			tree temp_node;

			i=0;
			use_insn = bsi_stmt (si);
			use_id = use_insn->common.p_id_sumit;
			find_data_dep_flag = 0;
			if (TREE_CODE (use_insn) == MODIFY_EXPR)
			{
				use_insn_temp = TREE_OPERAND (use_insn, 1);
				find_data_dep_flag = 1;
			}
			if (TREE_CODE (use_insn) == COND_EXPR)
			{
				use_insn = TREE_OPERAND (use_insn, 0);
				use_insn_temp = use_insn;
				find_data_dep_flag = 1;
			}
			if (TREE_CODE (use_insn) == RETURN_EXPR)
			{
				use_insn_temp = TREE_OPERAND (use_insn, 0);
				if (use_insn_temp)
				{
					use_insn_temp = TREE_OPERAND (use_insn_temp, 1);
					find_data_dep_flag = 1;
				}
			}
			if (find_data_dep_flag == 1)
			{
				use_vars = give_use_vars (use_insn_temp);
				node0 = use_vars.var1;
				node1 = use_vars.var2;
				if (node0 != NULL) 
				{
					reg = lookup_reg_list (node0); 
					if(reg != NULL)
					{
						int b;	
						for (b=0; b<last_basic_block; b++)
						{
							curr_insn = reg->insns[b];
							while (curr_insn != NULL)
							{
								int reach_flag = 0;
								struct insn_info_sumit * temp_insn;
								tree temp_temp_insn;

								def_id = curr_insn->id;
								def_insn = insn_list_sumit[def_id];
								if (bb->rd_in[def_id] == 1) {
									reach_flag = 1;
								}
								
								def_id = def_insn->common.p_id_sumit;
								temp_insn = reg->insns[bb->index];
								while (temp_insn != NULL){
									temp_temp_insn = insn_list_sumit[temp_insn->id];
									if (temp_temp_insn != NULL) {
										if (def_id == temp_temp_insn->common.p_id_sumit && def_id < use_id)
											reach_flag = 1;
										if (def_id != temp_temp_insn->common.p_id_sumit 
									            && temp_temp_insn->common.p_id_sumit < use_id)
											reach_flag = 0;
									}
									temp_insn = temp_insn->next;
								}
								if (reach_flag ==1)
								{
									src_pid = def_insn->common.p_id_sumit;
									dest_pid = use_insn->common.p_id_sumit;
									ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
									ot_edge->node[0] = src_pid; 
									ot_edge->node[1] = dest_pid;
									ot_edge->type = 1;
									ot_edge->next = node_array[src_pid]->outgoing_edges;
									node_array[src_pid]->outgoing_edges = ot_edge;
									
									it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
									it_edge->node[0] = src_pid; 
									it_edge->node[1] = dest_pid;
									it_edge->type = 1;
									it_edge->next = node_array[dest_pid]->incoming_edges;
									node_array[dest_pid]->incoming_edges = it_edge;
								}

								curr_insn = curr_insn->next;
							} 
						}
					}
				}
				if (node1 != NULL) 
				{
					reg = lookup_reg_list (node1); 
					if(reg != NULL)
					{
						int b;	
						for (b=0; b<last_basic_block; b++)
						{
							curr_insn = reg->insns[b];
							while (curr_insn != NULL)
							{
								int reach_flag = 0;
								struct insn_info_sumit * temp_insn;
								tree temp_temp_insn;

								def_id = curr_insn->id;
								def_insn = insn_list_sumit[def_id];
								if (bb->rd_in[def_id] == 1) {
									reach_flag = 1;
								}
								
								def_id = def_insn->common.p_id_sumit;
								temp_insn = reg->insns[bb->index];
								while (temp_insn != NULL){
									temp_temp_insn = insn_list_sumit[temp_insn->id];
									if (temp_temp_insn != NULL) {
										if (def_id == temp_temp_insn->common.p_id_sumit && def_id < use_id)
											reach_flag = 1;
										if (def_id != temp_temp_insn->common.p_id_sumit 
									            && temp_temp_insn->common.p_id_sumit < use_id)
											reach_flag = 0;
									}
									temp_insn = temp_insn->next;
								}
								if (reach_flag ==1)
								{
									src_pid = def_insn->common.p_id_sumit;
									dest_pid = use_insn->common.p_id_sumit;
									ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
									ot_edge->node[0] = src_pid; 
									ot_edge->node[1] = dest_pid;
									ot_edge->type = 1;
									ot_edge->next = node_array[src_pid]->outgoing_edges;
									node_array[src_pid]->outgoing_edges = ot_edge;
									
									it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
									it_edge->node[0] = src_pid; 
									it_edge->node[1] = dest_pid;
									it_edge->type = 1;
									it_edge->next = node_array[dest_pid]->incoming_edges;
									node_array[dest_pid]->incoming_edges = it_edge;
								}

								curr_insn = curr_insn->next;
							} 
						}
					}
				}
			}
		}
	}

}


void construct_immediate_post_dominance_tree()
{
	basic_block bb;
	int i;

	calculate_dominance_info (CDI_POST_DOMINATORS);
	FOR_EACH_BB(bb)
	{
		i = bb->index;		
		dominance_tree_array[i] = (struct dom_tree_node *) xmalloc (sizeof(struct dom_tree_node)); 
		dominance_tree_array[i]->outgoing_edges = NULL;
		dominance_tree_array[i]->incoming_edges = NULL;
		
	}

	i = last_basic_block;//this is for entry node whose index is -1, but as we can't have -1 as array index
			  // so we keep the index for entry block as first free available index and that is last_basic_block
	dominance_tree_array[i] = (struct dom_tree_node *) xmalloc (sizeof(struct dom_tree_node)); 
	dominance_tree_array[i]->outgoing_edges = NULL;
	dominance_tree_array[i]->incoming_edges = NULL;

	i = last_basic_block+1; //this is for exit block whose index is -2, but we keep it as last_basic_block+1
	dominance_tree_array[i] = (struct dom_tree_node *) xmalloc (sizeof(struct dom_tree_node)); 
	dominance_tree_array[i]->outgoing_edges = NULL;
	dominance_tree_array[i]->incoming_edges = NULL;

	FOR_EACH_BB(bb)
	{
      		basic_block idom_bb = NULL;
		idom_bb = get_immediate_dominator (CDI_POST_DOMINATORS, bb);
		if(idom_bb)
		{
			
			struct dom_tree_edge * it_edge;
			struct dom_tree_edge * ot_edge;
			int src_id;
			int dest_id = bb->index;
			if (idom_bb)
				src_id = idom_bb->index;
			else 
				continue;
			if(src_id == -1)
				src_id = last_basic_block;
			if(src_id == -2)
				src_id = last_basic_block+1;
			ot_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
			ot_edge->node[0] = src_id;
			ot_edge->node[1] = dest_id;
			ot_edge->next = dominance_tree_array[src_id]->outgoing_edges;
			dominance_tree_array[src_id]->outgoing_edges = ot_edge;
			
			it_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
			it_edge->node[0] = src_id;
			it_edge->node[1] = dest_id;
			it_edge->next = dominance_tree_array[dest_id]->incoming_edges;
			dominance_tree_array[dest_id]->incoming_edges = it_edge;
			
		}
	}
	/* now we believe that entry block is post dominated by exit block  not by 0th block*/
	{
		struct dom_tree_edge * it_edge;
		struct dom_tree_edge * ot_edge;
		ot_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
		ot_edge->node[0] = last_basic_block+1;
		ot_edge->node[1] = last_basic_block;
		ot_edge->next = dominance_tree_array[last_basic_block+1]->outgoing_edges;
		dominance_tree_array[last_basic_block+1]->outgoing_edges = ot_edge;

		it_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
		it_edge->node[0] = last_basic_block+1;
		it_edge->node[1] = last_basic_block;
		it_edge->next = dominance_tree_array[last_basic_block]->incoming_edges;
		dominance_tree_array[last_basic_block]->incoming_edges = it_edge;
	}

	/* just printing */	
	FOR_EACH_BB(bb)
	{
		int i = bb->index;
		struct dom_tree_edge * tedge;
		printf("block %d is dominated by = ", i);
		tedge =	dominance_tree_array[i]->incoming_edges;
		while (tedge)
		{
			printf ("%d \n", tedge->node[0]); 
			tedge = tedge->next;
		} 
	}
	{
		struct dom_tree_edge * tedge;
		printf("block %d is dominated by = ", last_basic_block);
		tedge =	dominance_tree_array[last_basic_block]->incoming_edges;
		while (tedge)
		{
			printf ("%d \n", tedge->node[0]); 
			tedge = tedge->next;
		}
	}
	free_dominance_info (CDI_POST_DOMINATORS);
}



void construct_immediate_post_dominance_tree_for_insns()
{
	basic_block bb;
	tree dominated_insn;
	int j, i;
	tree dominator_insn;
	struct dom_tree_edge * it_edge;
	struct dom_tree_edge * ot_edge;
	block_stmt_iterator si;
	int savej;
	int first_stmt_of_block, last_stmt_of_block;
	int curr_insn_id, prev_insn_id;
	tree curr_insn, prev_insn;
	
	for (i=0; i<=total_pdg_nodes; i++)
	{
		dominance_tree_array_slicing[i] = (struct dom_tree_node *) xmalloc (sizeof(struct dom_tree_node)); 
		dominance_tree_array_slicing[i]->outgoing_edges = NULL;
		dominance_tree_array_slicing[i]->incoming_edges = NULL;
	}

	FOR_EACH_BB (bb)
	{
		// here we are not traversing through all incoming edges as there is only one immediate post-doimintaor
		// hence just one incoming edge 
		if (dominance_tree_array[bb->index]->incoming_edges != NULL)
		{
			j = dominance_tree_array[bb->index]->incoming_edges->node[0]; //index of dominator bb
			if ((j != last_basic_block))
			{	
				if (j != (last_basic_block +1)) {
					dominator_insn = bsi_stmt(bsi_start(bb_array_sumit[j]));
					if (TREE_CODE (dominator_insn) == COMPOUND_EXPR) // i don't know why this is needed fix it
					{
						printf ("in compund expr...very strange case\n");
						dominator_insn = TREE_OPERAND (dominator_insn, 0);
					}
					
					j = dominator_insn->common.p_id_sumit; // index of dominator insn
					savej = j;
				
				} else {
					savej = total_pdg_nodes;
				}
				first_stmt_of_block = 0;
				last_stmt_of_block = 0;
				si = bsi_start (bb);
				while (!bsi_end_p (si)) 
				{
					first_stmt_of_block++;
					curr_insn = bsi_stmt (si);
					bsi_next (&si);
					if (bsi_end_p(si))
						last_stmt_of_block =1;
					if (last_stmt_of_block != 1 && first_stmt_of_block != 1)
					{
						if (prev_insn != NULL)
							prev_insn_id = prev_insn->common.p_id_sumit; // dominated insn
						else {
							printf ("Error in construct_immediate_post_dominance_tree_for_insns\n");
							exit(0);
						}
						curr_insn_id = curr_insn->common.p_id_sumit; //dominator insns
						j = curr_insn_id;
						i = prev_insn_id;
						ot_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
						ot_edge->node[0] = j;
						ot_edge->node[1] = i;
						ot_edge->next = dominance_tree_array_slicing[j]->outgoing_edges;
						dominance_tree_array_slicing[j]->outgoing_edges = ot_edge;
						
						it_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
						it_edge->node[0] = j;
						it_edge->node[1] = i;
						it_edge->next = dominance_tree_array_slicing[i]->incoming_edges;
						dominance_tree_array_slicing[i]->incoming_edges = it_edge;
						prev_insn = curr_insn;
					}
					if (last_stmt_of_block == 1)
					{
						curr_insn_id = curr_insn->common.p_id_sumit;
						j = savej;
						i = curr_insn_id;
						ot_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
						ot_edge->node[0] = j;
						ot_edge->node[1] = i;
						ot_edge->next = dominance_tree_array_slicing[j]->outgoing_edges;
						dominance_tree_array_slicing[j]->outgoing_edges = ot_edge;
						
						it_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
						it_edge->node[0] = j;
						it_edge->node[1] = i;
						it_edge->next = dominance_tree_array_slicing[i]->incoming_edges;
						dominance_tree_array_slicing[i]->incoming_edges = it_edge;
						if (first_stmt_of_block != 1)
						{
							if (prev_insn != NULL)
								prev_insn_id = prev_insn->common.p_id_sumit; // dominated insn
							else {
								printf ("Error in construct_immediate_post_dominance_tree_for_insns\n");
								exit(0);
							}
							curr_insn_id = curr_insn->common.p_id_sumit; //dominator insns
							j = curr_insn_id;
							i = prev_insn_id;
							ot_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
							ot_edge->node[0] = j;
							ot_edge->node[1] = i;
							ot_edge->next = dominance_tree_array_slicing[j]->outgoing_edges;
							dominance_tree_array_slicing[j]->outgoing_edges = ot_edge;
							
							it_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
							it_edge->node[0] = j;
							it_edge->node[1] = i;
							it_edge->next = dominance_tree_array_slicing[i]->incoming_edges;
							dominance_tree_array_slicing[i]->incoming_edges = it_edge;
							prev_insn = curr_insn;
						}
					}
					if (first_stmt_of_block == 1)
					{
						prev_insn = curr_insn;
					}
					
				}		
			}
		}
	}
	
	/* Entry is dominated by Exit */
	{

		j = total_pdg_nodes;
		i = 0;
		ot_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
		ot_edge->node[0] = j;
		ot_edge->node[1] = i;
		ot_edge->next = dominance_tree_array_slicing[j]->outgoing_edges;
		dominance_tree_array_slicing[j]->outgoing_edges = ot_edge;
		
		it_edge = (struct dom_tree_edge *) xmalloc (sizeof (struct dom_tree_edge)); 
		it_edge->node[0] = j;
		it_edge->node[1] = i;
		it_edge->next = dominance_tree_array_slicing[i]->incoming_edges;
		dominance_tree_array_slicing[i]->incoming_edges = it_edge;
	}
}


void create_dot_file_for_dominance_tree()
{
    int p, q;
    FILE * dot_file;

    	dot_file = fopen("dot_file_dom","w");

        fprintf(dot_file,"\ndigraph G {\n");
	for( p=0; p <=total_pdg_nodes; p++) {
                if(dominance_tree_array_slicing[p] != NULL)
                {
			if (p==0)
				fprintf(dot_file,"  %d [label= \"Entry\", color=blue];\n",p);
			else if (p == total_pdg_nodes)
				fprintf(dot_file,"  %d [label= \"Exit\", color=blue];\n",p);
			else
				fprintf(dot_file,"  %d [label= \"%d\", color=blue];\n",p,p);
        	}
        }

	for( p=0; p <=total_pdg_nodes; p++) {
		struct dom_tree_node *  lnode;
		struct dom_tree_edge * tedge = NULL;
		lnode = dominance_tree_array_slicing[p];
		if (lnode != NULL)
		{
			tedge = lnode->incoming_edges;
		}
		while (tedge != NULL)
		{
			fprintf(dot_file,"  %d -> %d [label= \"c\"];\n",tedge->node[0], p);
			tedge = tedge->next;
		}
				
	}

        fprintf(dot_file," }");
}



void construct_pdg_control_dep_edges(void)
{
	basic_block bb;
	int A, B;
	struct dom_tree_edge * temp_edge;
	edge e;

	FOR_EACH_BB(bb)
	{
		A = bb->index;
		/* look at edges (A, B) where A is bb, and B is bb->succ */
		for (e = bb->succ; e ; e = e->succ_next)
		{
			if(e->dest)
			{
				int found = 0;
				B = e->dest->index;
				/* check if B dominates A or not */
				if (B == -1)
					B = last_basic_block;
				if (B == -2)
					B = last_basic_block+1;
				temp_edge = dominance_tree_array[B]->outgoing_edges;
				while ((temp_edge != NULL) && (!found))
				{
					if (temp_edge->node[1] == A)
					{
						found = 1;
						break;
					}
					temp_edge = temp_edge->next;
				}
				/* if B does not dominate A then travel from B to A's parent in dominance tree */
				/* mark all the intermediate nodes be control dep on A */ 
				if (!found)
				{
					basic_block dest_bb;
					block_stmt_iterator si;
					int parent_A = -1;
					if(dominance_tree_array[A]->incoming_edges != NULL)
						parent_A =  dominance_tree_array[A]->incoming_edges->node[0];

					tree src_insn = bsi_stmt(bsi_last(bb_array_sumit[A]));
					if (TREE_CODE (src_insn) == COMPOUND_EXPR) // I don't know why this is needed fix it
					{
						printf ("in compund expr...very strange case\n");
						src_insn = TREE_OPERAND (src_insn, 0);
					}
					int src_pid = src_insn->common.p_id_sumit;

					temp_edge = dominance_tree_array[B]->incoming_edges;
					dest_bb = bb_array_sumit[B];
					while (temp_edge != NULL && temp_edge->node[0] != parent_A)
					{
						dest_bb = bb_array_sumit[temp_edge->node[1]]; //temp_edge->node[1] is dependend on A;
						for (si = bsi_start (dest_bb); !bsi_end_p (si); bsi_next (&si)) 
						{
							tree dest_insn = bsi_stmt(si);
							{
								struct p_edge * ot_edge; 
								struct p_edge * it_edge; 
								int dest_pid = dest_insn->common.p_id_sumit;

								ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								ot_edge->node[0] = src_pid; 
								ot_edge->node[1] = dest_pid;
								ot_edge->type = 2;
								ot_edge->next = node_array[src_pid]->outgoing_edges;
								node_array[src_pid]->outgoing_edges = ot_edge;
								
								it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								it_edge->node[0] = src_pid; 
								it_edge->node[1] = dest_pid;
								it_edge->type = 2;
								if (dest_pid != total_pdg_nodes) {
									it_edge->next = node_array[dest_pid]->incoming_edges;
									node_array[dest_pid]->incoming_edges = it_edge;
								}
							}
						}
						temp_edge = dominance_tree_array[temp_edge->node[0]]->incoming_edges;
					}
					//temp_edge->node[1] i.e B is also control dependend on A;
					if (temp_edge != NULL)
					{
						dest_bb = bb_array_sumit[temp_edge->node[1]]; 
						for (si = bsi_start (dest_bb); !bsi_end_p (si); bsi_next (&si)) 
						{
							tree dest_insn = bsi_stmt(si);
							{
								struct p_edge * ot_edge; 
								struct p_edge * it_edge; 
								int src_pid = src_insn->common.p_id_sumit;
								int dest_pid = dest_insn->common.p_id_sumit;
								ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								ot_edge->node[0] = src_pid; 
								ot_edge->node[1] = dest_pid;
								ot_edge->type = 2;
								ot_edge->next = node_array[src_pid]->outgoing_edges;
								node_array[src_pid]->outgoing_edges = ot_edge;
								
								it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								it_edge->node[0] = src_pid; 
								it_edge->node[1] = dest_pid;
								it_edge->type = 2;
								if (dest_pid != total_pdg_nodes) {
									it_edge->next = node_array[dest_pid]->incoming_edges;
									node_array[dest_pid]->incoming_edges = it_edge;
								}
							}
						}
					} 
					/*root node of dominance_tree has been reached yet paernt of A is not found
					hence root also has to be dependent on A*/
					else {
						int flag = 0;
						if (dest_bb->index != B)
							dest_bb = bb_array_sumit[dominance_tree_array[dest_bb->index]->incoming_edges->node[0]];
						for (si = bsi_start (dest_bb); !bsi_end_p (si); bsi_next (&si)) 
						{
							flag = 1;
							tree dest_insn = bsi_stmt(si);
							{
								struct p_edge * ot_edge; 
								struct p_edge * it_edge; 
								int src_pid = src_insn->common.p_id_sumit;
								int dest_pid = dest_insn->common.p_id_sumit;
								ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								ot_edge->node[0] = src_pid; 
								ot_edge->node[1] = dest_pid;
								ot_edge->type = 2;
								ot_edge->next = node_array[src_pid]->outgoing_edges;
								node_array[src_pid]->outgoing_edges = ot_edge;
								
								it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								it_edge->node[0] = src_pid; 
								it_edge->node[1] = dest_pid;
								it_edge->type = 2;
								if (dest_pid != total_pdg_nodes) {
									it_edge->next = node_array[dest_pid]->incoming_edges;
									node_array[dest_pid]->incoming_edges = it_edge;
								}
							}
						}
						/* root of dominance_tree is Exit node */
						if (flag == 0) {
							{
								struct p_edge * ot_edge; 
								struct p_edge * it_edge; 
								int src_pid = src_insn->common.p_id_sumit;
								int dest_pid = total_pdg_nodes;
								ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								ot_edge->node[0] = src_pid; 
								ot_edge->node[1] = dest_pid;
								ot_edge->type = 2;
								ot_edge->next = node_array[src_pid]->outgoing_edges;
								node_array[src_pid]->outgoing_edges = ot_edge;
								
								it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
								it_edge->node[0] = src_pid; 
								it_edge->node[1] = dest_pid;
								it_edge->type = 2;
								if (dest_pid != total_pdg_nodes) {
									it_edge->next = node_array[dest_pid]->incoming_edges;
									node_array[dest_pid]->incoming_edges = it_edge;
								}
							}
						}
					}

				}
			}		
		}
	}
	/* this is for edge (entry --> 0) i.e. B is 0 in this case and A is entry */
	{
		basic_block dest_bb;
		block_stmt_iterator si;
		int parent_A = -1;
		tree src_insn;

		A = last_basic_block;
		parent_A = dominance_tree_array[A]->incoming_edges->node[0];
		src_insn = NULL;
		if (last_basic_block >0)
		{
			int flag = 0;
			B = 0; //first basic block
			temp_edge = dominance_tree_array[B]->incoming_edges;
			dest_bb = bb_array_sumit[B];
			while (temp_edge != NULL && temp_edge->node[0] != parent_A)
			{
				dest_bb = bb_array_sumit[temp_edge->node[1]]; //temp_edge->node[1] is dependend on A;
				for (si = bsi_start (dest_bb); !bsi_end_p (si); bsi_next (&si)) 
				{
					tree dest_insn = bsi_stmt(si);
					{
						struct p_edge * ot_edge; 
						struct p_edge * it_edge; 
						int src_pid = 0; // as insn on entry block has p_id 0
						int dest_pid = dest_insn->common.p_id_sumit;
						ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						ot_edge->node[0] = src_pid; 
						ot_edge->node[1] = dest_pid;
						ot_edge->type = 2;
						ot_edge->next = node_array[src_pid]->outgoing_edges;
						node_array[src_pid]->outgoing_edges = ot_edge;
						
						it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						it_edge->node[0] = src_pid; 
						it_edge->node[1] = dest_pid;
						it_edge->type = 2;
						if (dest_pid != total_pdg_nodes) {
							it_edge->next = node_array[dest_pid]->incoming_edges;
							node_array[dest_pid]->incoming_edges = it_edge;
						}
					}
				}
				temp_edge = dominance_tree_array[temp_edge->node[0]]->incoming_edges;
			}
			//temp_edge->node[1] is dependend on A;
			if  (temp_edge != NULL)
			{
				dest_bb = bb_array_sumit[temp_edge->node[1]]; 
				for (si = bsi_start (dest_bb); !bsi_end_p (si); bsi_next (&si)) 
				{
					tree dest_insn = bsi_stmt(si);
					{
						struct p_edge * ot_edge; 
						struct p_edge * it_edge; 
						int src_pid = 0; // as the insn in entry block has p_id 0;
						int dest_pid = dest_insn->common.p_id_sumit;
						ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						ot_edge->node[0] = src_pid; 
						ot_edge->node[1] = dest_pid;
						ot_edge->type = 2;
						ot_edge->next = node_array[src_pid]->outgoing_edges;
						node_array[src_pid]->outgoing_edges = ot_edge;
						
						it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						it_edge->node[0] = src_pid; 
						it_edge->node[1] = dest_pid;
						it_edge->type = 2;
						if (dest_pid != total_pdg_nodes) {
							it_edge->next = node_array[dest_pid]->incoming_edges;
							node_array[dest_pid]->incoming_edges = it_edge;
						}
					}
				}
			}
			/*root node of dominance_tree has been reached yet paernt of A is not found
			hence root also has to be dependent on A*/
			else {
				int flag = 0;
				if (dest_bb->index != B)
					dest_bb = bb_array_sumit[dominance_tree_array[dest_bb->index]->incoming_edges->node[0]];
				for (si = bsi_start (dest_bb); !bsi_end_p (si); bsi_next (&si)) 
				{
					flag = 1;
					tree dest_insn = bsi_stmt(si);
					{
						struct p_edge * ot_edge; 
						struct p_edge * it_edge; 
						int src_pid = 0;
						int dest_pid = dest_insn->common.p_id_sumit;
						ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						ot_edge->node[0] = src_pid; 
						ot_edge->node[1] = dest_pid;
						ot_edge->type = 2;
						ot_edge->next = node_array[src_pid]->outgoing_edges;
						node_array[src_pid]->outgoing_edges = ot_edge;
						
						it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						it_edge->node[0] = src_pid; 
						it_edge->node[1] = dest_pid;
						it_edge->type = 2;
						if (dest_pid != total_pdg_nodes) {
							it_edge->next = node_array[dest_pid]->incoming_edges;
							node_array[dest_pid]->incoming_edges = it_edge;
						}
					}
				}
				/* root of dominance_tree is Exit node */
				if (flag == 0) {
					{
						struct p_edge * ot_edge; 
						struct p_edge * it_edge; 
						int src_pid = 0;
						int dest_pid = total_pdg_nodes;
						ot_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						ot_edge->node[0] = src_pid; 
						ot_edge->node[1] = dest_pid;
						ot_edge->type = 2;
						ot_edge->next = node_array[src_pid]->outgoing_edges;
						node_array[src_pid]->outgoing_edges = ot_edge;
						
						it_edge = (struct p_edge *) xmalloc (sizeof (struct p_edge));
						it_edge->node[0] = src_pid; 
						it_edge->node[1] = dest_pid;
						it_edge->type = 2;
						if (dest_pid != total_pdg_nodes) {
							it_edge->next = node_array[dest_pid]->incoming_edges;
							node_array[dest_pid]->incoming_edges = it_edge;
						}
					}
				}
			}
		}

	}
}


void create_dot_file_for_pdg()
{
    int p, q;
    FILE * dot_file;

    dot_file = fopen("dot_file_pdg","w");

        fprintf(dot_file,"\ndigraph G {\n");
	for(p=0; p <=total_pdg_nodes; p++) {
                if(node_array[p] != NULL)
                {
			if (p==0 && node_array[p]->marked == 0)
				fprintf(dot_file,"  %d [label= \"Entry\", color=blue];\n",p);
			else if (p==0 && node_array[p]->marked == 1)
				fprintf(dot_file,"  %d [label= \"Entry\", color=red];\n",p);
			else if (p==total_pdg_nodes && node_array[p]->marked == 0)
				fprintf(dot_file,"  %d [label= \"Exit\", color=blue];\n",p);
			else if (p==total_pdg_nodes && node_array[p]->marked == 1)
				fprintf(dot_file,"  %d [label= \"Exit\", color=red];\n",p);
			else if (node_array[p]->marked == 1 )
				fprintf(dot_file,"  %d [label= \"%d\", color=red];\n",p,p);
			else 
				fprintf(dot_file,"  %d [label= \"%d\", color=blue];\n",p,p);
        	}
		else if (p==total_pdg_nodes)
			fprintf(dot_file,"  %d [label= \"Exit\", color=blue];\n",p);
        }
	for( p=0; p <=total_pdg_nodes; p++) {
		for( q=0; q <=total_pdg_nodes; q++) {
			if (p!=q) {
				struct p_node *  pnode;
				struct p_edge * tedge;
				
				pnode = node_array[p];
				if (pnode != NULL) {
					tedge = pnode->outgoing_edges;
					while ((tedge != NULL) && (tedge->node[1] != q))
					{
						tedge = tedge->next;
					}
					if(tedge != NULL)
					{
						if(tedge->node[1] == q)
						{
							if (tedge->type == 2)
								fprintf(dot_file,"  %d -> %d [label= \"c\"];\n",p,q);
							if (tedge->type == 1)
								fprintf(dot_file,"  %d -> %d [label= \"d\"];\n",p,q);
						}
					}
				}
			}
		}
	}
        fprintf(dot_file," }");
}


void construct_lexical_successor_tree (void)
{
	tree prev_insn = NULL;
	tree curr_insn = NULL;
	int prev_insn_id;
	int dest_pid, src_pid;
	struct lexical_succ_edge * ot_edge;
	struct lexical_succ_edge * it_edge;
	block_stmt_iterator si;
	basic_block bb;

	prev_insn_id = 0;
	FOR_EACH_BB(bb){
		for (si = bsi_start (bb); !bsi_end_p (si); bsi_next (&si)) 
		{
			curr_insn = bsi_stmt (si);		
			{
				src_pid = prev_insn_id;
				if (curr_insn != NULL) 
					dest_pid = curr_insn->common.p_id_sumit;
				else 
					continue;
				ot_edge = (struct lexical_succ_edge *) xmalloc (sizeof (struct lexical_succ_edge));
				ot_edge->node[0] = dest_pid;
				ot_edge->node[1] = src_pid; 
				ot_edge->next = lexical_succ_array[dest_pid]->outgoing_edges;
				lexical_succ_array[dest_pid]->outgoing_edges = ot_edge;
				
				it_edge = (struct lexical_succ_edge *) xmalloc (sizeof (struct lexical_succ_edge));
				it_edge->node[0] = dest_pid;
				it_edge->node[1] = src_pid; 
				it_edge->next = lexical_succ_array[src_pid]->incoming_edges;
				lexical_succ_array[src_pid]->incoming_edges = it_edge;
			}
			prev_insn = curr_insn;
			prev_insn_id = prev_insn->common.p_id_sumit;
		}
	}
	{
		src_pid = prev_insn_id;
		dest_pid = total_pdg_nodes;
		ot_edge = (struct lexical_succ_edge *) xmalloc (sizeof (struct lexical_succ_edge));
		ot_edge->node[0] = dest_pid;
		ot_edge->node[1] = src_pid; 
		ot_edge->next = lexical_succ_array[dest_pid]->outgoing_edges;
		lexical_succ_array[dest_pid]->outgoing_edges = ot_edge;
		
		it_edge = (struct lexical_succ_edge *) xmalloc (sizeof (struct lexical_succ_edge));
		it_edge->node[0] = dest_pid;
		it_edge->node[1] = src_pid; 
		it_edge->next = lexical_succ_array[src_pid]->incoming_edges;
		lexical_succ_array[src_pid]->incoming_edges = it_edge;
	}
	
}

/* The function defined below for contructing
lexical successor tree was based on syntax 
directed analysis and worked on AST level.
I was using this in the previous version 
of GCC, but not now. Currently I am 
building it on CFG level. If one want to build
it on AST level, please modify the code below
and use it*/
/** 
This function is used to build the lexical successor tree
for current procedure by traversing the AST.
**/
/*
void construct_lexical_successor_tree (tree * first_p)
{
	tree_stmt_iterator i;
	tree stmt;
	tree tree_first;
	int c1, c2, c3, cf;
	int dest_p_id=0, src_p_id=0;
	
	if (first_p != NULL)
	{
		for (i = tsi_start (first_p); !tsi_end_p (i); tsi_next (&i))
		{
			struct last_stmt * last_stmt_list;
			//tree t = *(i.tp);
			tree t = (i.ptr)->next;
			cf = 0;
			
			stmt = tsi_stmt (i);
		
			last_stmt_list = NULL;
			track_last_stmt (stmt, &last_stmt_list);
			
			if (TREE_CODE (t) == COMPOUND_EXPR)
				tree_first = find_first_stmt (TREE_OPERAND (t, 1));
			else 
				tree_first = NULL;

			if (tree_first != NULL)
				cf = TREE_CODE (tree_first);

			while (last_stmt_list != NULL)
			{
				if (last_stmt_list->stmt != NULL)
				{
					int src_p_id, dest_p_id;
					struct lexical_succ_node * temp_lexical_node;
					struct lexical_succ_edge * ot_edge;
					struct lexical_succ_edge * it_edge;
					
					src_p_id = last_stmt_list->stmt->common.p_id_sumit;
					if (tree_first != NULL && src_p_id != 0) //here src_p_id != 0 check means don't 
										 //take those instructions which have not 
										//been considered during reg_insn_collection 
					{
						dest_p_id = tree_first->common.p_id_sumit;
						ot_edge = (struct lexical_succ_edge *) xmalloc (sizeof (struct lexical_succ_edge));
						ot_edge->node[0] = dest_p_id;
						ot_edge->node[1] = src_p_id; 
						ot_edge->next = lexical_succ_array[dest_p_id]->outgoing_edges;
						lexical_succ_array[dest_p_id]->outgoing_edges = ot_edge;
						
						it_edge = (struct lexical_succ_edge *) xmalloc (sizeof (struct lexical_succ_edge));
						it_edge->node[0] = dest_p_id;
						it_edge->node[1] = src_p_id; 
						it_edge->next = lexical_succ_array[src_p_id]->incoming_edges;
						lexical_succ_array[src_p_id]->incoming_edges = it_edge;
					}
				}
			
				last_stmt_list = last_stmt_list->next;
			}
			
			switch (TREE_CODE (stmt))
			{
				case BIND_EXPR: construct_lexical_successor_tree (&BIND_EXPR_BODY (stmt));
						break;
				case COND_EXPR: 
						construct_lexical_successor_tree (&TREE_OPERAND (stmt, 1));
						construct_lexical_successor_tree (&TREE_OPERAND (stmt, 2));
						break;
				default: 
					break;	
			}
		}
	}
	
}



tree find_first_stmt (tree stmt)
{
	tree tree_first = NULL;

	if (stmt != NULL){
		if (TREE_CODE (stmt) == COMPOUND_EXPR)
			stmt = TREE_OPERAND (stmt, 0);
	}

	if (stmt != NULL)
	{
		switch (TREE_CODE (stmt))
		{
			case BIND_EXPR:
				//printf ("in bind \n");
				tree_first = find_first_stmt (BIND_EXPR_BODY (stmt));
				break;
			case COND_EXPR:
				//printf ("in cond  \n");
				tree_first = TREE_OPERAND (stmt, 0);
				break;
			default: 
				//printf ("in default \n");
				tree_first = stmt;;
				break;
		}
	}
	return tree_first;
}



void track_last_stmt (tree stmt, struct last_stmt **last_stmt_list)
{
	struct last_stmt *last_stmt_temp;
	switch (TREE_CODE (stmt))
	{
		case BIND_EXPR: 
			//printf ("in bind  \n");
			track_last_stmt (tsi_stmt (tsi_last (&BIND_EXPR_BODY (stmt))), last_stmt_list);
			break;

		case COND_EXPR: 
			//printf ("in cond  \n");
			track_last_stmt (tsi_stmt (tsi_last (&TREE_OPERAND (stmt, 1))), last_stmt_list);
			track_last_stmt (tsi_stmt (tsi_last (&TREE_OPERAND (stmt, 2))), last_stmt_list);
			last_stmt_temp = (struct last_stmt *) xmalloc (sizeof (struct last_stmt)); 	
			last_stmt_temp->stmt =  TREE_OPERAND (stmt, 0);
			last_stmt_temp->next =  *last_stmt_list;
			*last_stmt_list = last_stmt_temp;
			break;
		default:
			//printf ("in default \n");
			last_stmt_temp = (struct last_stmt *) xmalloc (sizeof (struct last_stmt)); 	
			last_stmt_temp->stmt =  stmt;
			last_stmt_temp->next =  *last_stmt_list;
			*last_stmt_list = last_stmt_temp;
			break;
	}
}
*/


void create_dot_file_for_lexical_succ_tree()
{
    int p, q;
    FILE * dot_file;

    dot_file = fopen("dot_file_lex","w");

        fprintf(dot_file,"\ndigraph G {\n");
	for( p=0; p <=total_pdg_nodes; p++) {
                if(lexical_succ_array[p] != NULL)
                {
			if (p==0)
				fprintf(dot_file,"  %d [label= \"Entry\", color=blue];\n",p);
			else if (p==total_pdg_nodes)
				fprintf(dot_file,"  %d [label= \"Exit\", color=blue];\n",p);
			else
				fprintf(dot_file,"  %d [label= \"%d\", color=blue];\n",p,p);
        	}
        }
         
	for( p=0; p <=total_pdg_nodes; p++) {
		struct lexical_succ_node *  lnode;
		struct lexical_succ_edge* tedge = NULL;
		lnode = lexical_succ_array[p];
		if (lnode != NULL)
		{
			tedge = lnode->incoming_edges;
		}
		while (tedge != NULL)
		{
			fprintf(dot_file,"  %d -> %d [label= \"c\"];\n",tedge->node[0], p);
			tedge = tedge->next;
		}
				
	}

        fprintf(dot_file," }");
}



int pop_worklist ()
{
	int v;
	
	v = worklist->node_number;
	worklist = worklist->next;
	return v;
		
}


void push_worklist (int node_number)
{
	struct worklist_node *  temp_worklist_node = (struct worklist_node *) xmalloc (sizeof (struct worklist_node));

	temp_worklist_node->node_number = node_number;
	temp_worklist_node->next = worklist;
	worklist = temp_worklist_node;
	return;
}


void construct_slice (int node_number)
{
	int v, w;
	struct p_edge * temp_incoming_edge;

	push_worklist (node_number);
	while (worklist != NULL)
	{
		v = pop_worklist();
		if (v <=total_pdg_nodes && node_array[v] != NULL)
		{
			node_array[v]->marked = 1;

			temp_incoming_edge = node_array[v]->incoming_edges;
			while (temp_incoming_edge != NULL)
			{
				w = temp_incoming_edge->node[0];
				if (!node_array[w]->marked)
				{
					push_worklist (w);
				}
				temp_incoming_edge = temp_incoming_edge->next;
			}
		}
	}
}


void construct_slice_with_jump_statements ()
{
	basic_block bb;
	block_stmt_iterator si;
	tree insn;
	int id, d_id, l_id;
	int nearest_dom = -1;
	int nearest_succ = -2; // we initialize these two variables different so that both can not be same at the end
	struct dom_tree_edge * temp_incoming_edge;
	struct lexical_succ_edge * temp_outgoing_edge;

	FOR_EACH_BB (bb)
	{
		for (si = bsi_start (bb); !bsi_end_p (si); bsi_next (&si)) 
		{
			insn = bsi_stmt (si);
			if (TREE_CODE (insn) == GOTO_EXPR)
			{
				id = insn->common.p_id_sumit;
				// the incoming edge in dominator tree is always one 
				temp_incoming_edge = dominance_tree_array_slicing[id]->incoming_edges;
				while (temp_incoming_edge != NULL)
				{
					d_id = temp_incoming_edge->node[0];
					if (node_array[d_id] && node_array[d_id]->marked == 1)
					{
						nearest_dom = d_id;
						break;
					}
					temp_incoming_edge = dominance_tree_array_slicing[d_id]->incoming_edges;
				}
					//printf ("dom %d \n", nearest_dom);

				// the outgoing edge in lexical successor tree is always one	
				temp_incoming_edge = lexical_succ_array[id]->incoming_edges;
				while (temp_incoming_edge != NULL)
				{
					l_id = temp_incoming_edge->node[0];
					if (node_array[l_id] && node_array[l_id]->marked == 1)
					{
						nearest_succ = l_id;
						break;
					}
					temp_incoming_edge = lexical_succ_array[l_id]->incoming_edges;
				}
					//printf ("lex %d\n", nearest_succ );
				
				if (nearest_succ != nearest_dom && nearest_dom != -1 && nearest_succ != -2)
				{
					node_array[id]->marked = 1;	
					/* Mark corresponding label expr too */
					node_array[cfg_array[cfg_array[id]->outgoing_edges->node[1]]->insn->common.p_id_sumit]->marked = 1;
				}
				nearest_dom = -1;
				nearest_succ = -2;
			}
			else if (insn->common.has_goto_statement == 1) {
				id = insn->common.p_id_sumit;
				// the incoming edge in dominator tree is always one 
				temp_incoming_edge = dominance_tree_array_slicing[id]->incoming_edges;
				while (temp_incoming_edge != NULL)
				{
					d_id = temp_incoming_edge->node[0];
					if (node_array[d_id] && node_array[d_id]->marked == 1)
					{
						nearest_dom = d_id;
						break;
					}
					temp_incoming_edge = dominance_tree_array_slicing[d_id]->incoming_edges;
				}
					//printf ("dom %d \n", nearest_dom);

				// the outgoing edge in lexical successor tree is always one	
				temp_incoming_edge = lexical_succ_array[id]->incoming_edges;
				while (temp_incoming_edge != NULL)
				{
					l_id = temp_incoming_edge->node[0];
					if (node_array[l_id] && node_array[l_id]->marked == 1)
					{
						nearest_succ = l_id;
						break;
					}
					temp_incoming_edge = lexical_succ_array[l_id]->incoming_edges;
				}
					//printf ("lex %d\n", nearest_succ );
				
				if (nearest_succ != nearest_dom && nearest_dom != -1 && nearest_succ != -2)
				{
					node_array[id]->has_goto_statement_marked = 1;	
					node_array[cfg_array[cfg_array[id]->outgoing_edges->node[1]]->insn->common.p_id_sumit]->marked = 1;
				}
				nearest_dom = -1;
				nearest_succ = -2;
			}
		}
	}
}
