
#include "concur.h"
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>

#define DIE_ON_ERROR(retval, func_name) \
	if (retval < 0) { \
		perror(func_name); \
		exit(-1); \
	}

static concur_ctrl_t *ctrl = NULL;

/*
static void concur_sig_handler(int signo, siginfo_t *info,void *myact)
{
	if (signo == SIGINT) {
		printf("get a SIGINT\n");
		DIE_ON_ERROR(concur_unregister_proc(ctrl), "concur_unregister_proc");
		exit(0);
	}
}
*/

int main(int argc, char *argv[])
{
	if (argc < 2) {
		printf("Usage: %s <socket_path>\n", argv[0]);
		return 0;
	}

	const char *socket_path = argv[1];
	ctrl = concur_ctrl_init(socket_path);
	int mlen = 20;
	int msize = 1;
	int mqid = concur_create_mqueue(ctrl, mlen, msize, 0);
	char msg[20];
	
	/*
	struct sigaction sigact;
	sigact.sa_sigaction = concur_sig_handler;
	sigemptyset(&sigact.sa_mask);
	sigact.sa_flags=SA_SIGINFO;
	DIE_ON_ERROR(sigaction(SIGINT, &sigact, NULL), "sigaction");
	*/
	
	if (fork() == 0) {
		// child
		concur_register_proc(ctrl);
		sleep(1);
		concur_send_msg(ctrl, mqid, msg, mlen, 0);
		sleep(2);
		concur_send_msg(ctrl, mqid, msg, mlen, 0); // will block
	}
	else {
		// parent
		concur_register_proc(ctrl);
		sleep(2);
		concur_send_msg(ctrl, mqid, msg, mlen, 0); // will block
	}
	
	return 0;
}


